#include <stdio.h>
#include "Control.h"
#include "EMData.h"
#include "Image.h"
#include "qutil.h"

#include <math.h>
#include <qprogressdialog.h>
#include <qmessagebox.h>
#include <qpopupmenu.h>
#include <qutil.h>
#include <qkeycode.h>
#include "OneLiner.h"
#include "AutoboxD.h"
#include "AutoboxSNR.h"
#include "AutomaskD.h"
#include "DriftmaskD.h"

#ifdef UBUNTU
	#include <qapplication.h>
	#include <qfiledialog.h>
#else	//UBUNTU
	#include <qapp.h>
	#include <qfiledlg.h>
#endif	//UBUNTU

int initdone=0;
Control *control;

int main( int argc, char **argv )
{
QFont *newdf;
QApplication a( argc, argv );
int i;
int num=-1,denom,bsize;
char* boxfile=NULL, *scale=NULL, *brightness=NULL, *contrast=NULL;
bool clipminimized = false;
char* size=NULL;

appinit(argc,argv);

for (i=2; i<argc; i++) {	
	if (strncmp(argv[i],"area=",5)==0) {
		if (sscanf(&argv[i][5],"%d,%d,%d",&num,&denom,&bsize)!=3) {
			printf("Usage: boxer [filename [area=<num>,<denom>,<box>]] [box=<box db>]\n");
			exit(1);
		}
	}
	else if (strncmp(argv[i],"box=",4)==0) boxfile=&argv[i][4];
	else if (strncmp(argv[i],"size=",5)==0) size=&argv[i][5];
	else if (strncmp(argv[i],"scale=",6)==0) scale=&argv[i][6];
	else if (strncmp(argv[i],"bright=",7)==0) brightness=&argv[i][7];
	else if (strncmp(argv[i],"contrast=",9)==0) contrast=&argv[i][9];
	else if (strncmp(argv[i],"clipmini",8)==0) clipminimized=true;
	else { printf("Unknown argument '%s'\n",argv[i]); exit(1); }
}

EMQInit(&a);

control=new Control(NULL,"Name");
a.setMainWidget(control);
control->show();
initdone=1;
if (num>=0) control->readimage(argv[1],num,denom,bsize);
else control->readimage(argv[1]);
if(brightness) control->getImageView()->setBrite(atof(brightness));
if(size) control->setSize(QString(size));
if(contrast) control->getImageView()->setCont(atof(contrast));
if(scale) control->setScale(QString(scale));
if(boxfile) control->Mreadbdb(boxfile);
if(clipminimized) control->minimizeClipView();
return a.exec();
}
