# -------------------------------------------------------------------------
# SegmentEMAN3D/ChimeraExtension.py
#
# Segment Volume package - Segment EMAN3D module
# 
# Author:
#       Lavu Sridhar, Baylor College of Medicine (BCM)
#
# Revisions:
#       2005.07.13: Lavu Sridhar, BCM
#       2005.07.15: Lavu Sridhar, BCM
#
# To Do:
#       See comments marked with # @
# 
"""Segmentation of MRC density maps.

Chimera Extension manager registering modules:
(1) 'Segment EMAN 3D'
"""
# -------------------------------------------------------------------------

import chimera.extension

# -------------------------------------------------------------------------

class SegmentEMAN3DEMO(chimera.extension.EMO):
    """Segment using eman's segment3d 
    """

    def name(self):
        return 'Segment EMAN3D'
    def description(self):
        return 'Segment regions out of a volume density map'
    def categories(self):
        return ['AIRS']
    def icon(self):
        return self.path('')
    def activate(self):
        self.module('segeman3d').show_seg_eman3d_dialog()
        return None

# -------------------------------------------------------------------------

chimera.extension.manager.registerExtension(SegmentEMAN3DEMO(__file__))

# -------------------------------------------------------------------------
