CtfData *FORFIT = NULL;

// This calculates a linear difference between the fit curve and data curve
// (used in fitting)
float calcFORFIT(float *parm) {
if (!FORFIT) return 0;
int steps=FORFIT->steps();

FORFIT->setSigParm(parm[0],parm[1],parm[2],parm[3],parm[4]);
FORFIT->setNoiseParm(0,parm[5],parm[6],parm[7]);
FORFIT->updateEqn();

float sum=0;
DataSet *data=FORFIT->getData();
for (int i=4; i<steps; i+=4) sum+=fabs(data->dataAt(6,i)-data->dataAt(10,i));

return sum;
}

// This calculates
float calcFORFIT2(float *parm) {
if (!FORFIT) return 0;
int steps=FORFIT->steps();

FORFIT->setSigParm(parm[0],parm[1],parm[2],parm[3],parm[4]);
FORFIT->setNoiseParm(0,parm[5],parm[6],parm[7]);
FORFIT->updateEqn();

float sum=0;
DataSet *data=FORFIT->getData();
for (int i=4; i<steps; i+=4) sum+=data->dataAt(6,i)*(data->dataAt(10,i)-data->dataAt(5,i));

return sum;
}


// This is a quick, 'intelligent' fit, but it's not done yet. It just fits
// a few of the parameters right now, and a couple haven't been updated for
// the current parameterization
void CtfData::doFitQ() {
if (!(Flags&CDT_HASFFT)) return; 

float parm[8] = { defocus, B, amp, ampcont*100.0, exps4, noise2, noise3, noise4 };
char flag[8] = { 1,1,1,1,1,1,1,1 };
float v,b,p,p2,x[3],y[3];
int mpos=0;
FORFIT=this;

// find 3 'zeros'. 1 in each 1/3 of the data
for (int j=0; j<3; j++) {
	y[j]=1.0e20;

	for (int i=j*CTFSTEPS/3+4; i<j*CTFSTEPS/3+CTFSTEPS/4; i++) {
		if (data->dataAt(10,i)<y[j]) {
			y[j]=data->dataAt(10,i);
			x[j]=data->dataAt(0,i);
		}
	}
	if (y[j]>0) y[j]=log(y[j]); else y[j]=-5.0;
	printf("%f,%f\n",x[j],y[j]);
}

// e^quadratic, fit log(data) to quadratic
parm[4]=0;
v=(x[0]-x[1])*(x[0]-x[2])*(x[1]-x[2]);
parm[6]=(x[0]*x[2]*y[1]*(x[2]-x[0])+x[1]*x[1]*(x[2]*y[0]-x[0]*y[2])+x[1]*(x[0]*x[0]*y[2]-y[0]*x[2]*x[2]))/v;
parm[5]=-(x[2]*x[2]*(y[0]-y[1])+x[0]*x[0]*(y[1]-y[2])+x[1]*x[1]*(y[2]-y[0]))/v;
parm[7]=(x[2]*(y[1]-y[0])+x[1]*(y[0]-y[2])+x[0]*(y[2]-y[1]))/v;

printf("%f %f %f\n",parm[6],parm[5],parm[7]);

parm[6]=exp(parm[6]);
if (parm[7]<0) parm[7]=sqrt(-parm[7])*2.0/PI;
else {
	parm[5]=(y[0]-y[2])/(x[2]-x[0]);
	parm[6]=exp(y[0])*exp(parm[5]*x[0]);
	parm[7]=0;
}

b=0;
parm[1]=0.0;
parm[2]=1.0;
for (parm[0]=0; parm[0]>-5.0; parm[0]-=.5) {
	v=calcFORFIT2(parm);
	if (v>b) { b=v; p=parm[0]; }
}
p2=p;
for (parm[0]=p2-.5; parm[0]<p2+.5; parm[0]+=.1) {
	v=calcFORFIT2(parm);
	if (v>b) { b=v; p=parm[0]; }
}
parm[0]=p;

v=b=0;
for (int i=5; i<CTFSTEPS/5; i++) {
	v+=pow(data->dataAt(3,i),2.0F);
	b+=fabs(data->dataAt(10,i)-data->dataAt(5,i));
}
parm[2]=sqrt(b/v);

p=1.0e10;
for (b=5.0; b<20.0; b+=2.0) {
	parm[1]=b;  // pow(b*b*PI/2.0,2.0);
	v=calcFORFIT2(parm);
	if (v<p) { p=v; p2=parm[1]; }
}
parm[1]=p2;

//float q=fitrun(8,parm,min,max,flag,calcFORFIT);

FORFIT->setSigParm(parm[0],parm[1],parm[2],parm[3],parm[4]);
FORFIT->setNoiseParm(0,parm[5],parm[6],parm[7]);
FORFIT->updateEqn();

//printf("%f,%f %f,%f    %f,%f %f,%f\n",s0,v0,s1,v1,parm[4],parm[5],parm[6],parm[7]);

//printf("fitqual=%g\n",q);
}

void CtfData::doFit() {
if (!(Flags&CDT_HASFFT)) return; 

float parm[8] = { defocus, B, amp, ampcont*100.0, noise1, noise2, noise3, noise4 };
float min[8] = { -8.0, 2.0, 0, 0, 0, 0, 0, 0 };
float max[8] = { 0, 30.0, 6.0, 20.0, 5.0, 10.0, 40.0, 10.0 };
char flag[8] = { 1,1,1,1,1,1,1,1 };
float v0=1.0e10,v1,s0,s1;
int mpos=0;
FORFIT=this;

float q=fitrun(8,parm,min,max,flag,calcFORFIT);

FORFIT->setSigParm(parm[0],parm[1],parm[2],parm[3],0);
FORFIT->setNoiseParm(parm[4],parm[5],parm[6],parm[7]);
FORFIT->updateEqn();

//printf("%f,%f %f,%f    %f,%f %f,%f\n",s0,v0,s1,v1,parm[4],parm[5],parm[6],parm[7]);

//printf("fitqual=%g\n",q);
}



