set alt 0
set az 90
set phi 0

set Riso .8
set Giso .5
set Biso .8


proc orient { alt az phi zoom } {
	global ctx
	global dtx
	vis5d_set_view $ctx $alt $phi $az  $zoom  0.0 0.0 0.0
	vis5d_draw_frame $dtx
	vis5d_draw_frame $dtx
}

proc savepic { nm } {
	vis5d_save_window $nm VIS5D_PPM
	puts "wrote $nm"
}

proc freeze { steps} {
	global frame
	global basename
	global ext
	global fmt
	global ctx
	global dtx
	global anim

	for {set i 1} {$i <= $steps} {set i [expr $i + 1]} {

#	puts "$i $frame"
		if {$anim == 1} {
			set name $basename$frame$ext
			savepic $name
			set frame [expr $frame + 1]
		} else { 
			vis5d_sleep 33 
		}
	}

}

# 0 fades out 1 fades in
proc fadeiso { steps mode } {
	global frame
	global basename
	global ext
	global fmt
	global ctx
	global dtx
	global anim
	global Riso
	global Giso
	global Biso

	for {set i 0} {$i < $steps} {set i [expr $i + 1]} {
		set j [expr $i.0/($steps - 1.0)];
		if { $mode ==0 } { set j [expr 1.0-$j] }

		vis5d_set_color $ctx VIS5D_ISOSURF D1 $Riso $Giso $Biso $j
#		vis5d_set_color $ctx VIS5D_HSLICE 1 

		vis5d_draw_frame $dtx
		vis5d_draw_frame $dtx
		if {$anim == 1} {
#	puts "$i $j $frame $alt $az $phi"
			set name $basename$frame$ext
			savepic $name
			set frame [expr $frame + 1]
		} else { 
			vis5d_sleep 20 
		}
	}
}

# alpha - the transparency where 0 is completely transparent and 1 is completely opaque

# forward == 1,2,3 for forward,backward or both
proc timecycle { forward } {

	global frame
	global alt
	global az
	global phi
	global basename
	global ext
	global fmt
	global ctx
	global dtx
	global anim

	vis5d_set_view $ctx $alt $phi $az  1.0  0.0 0.0 0.0
	set numtimes [ vis5d_get_dtx_numtimes $dtx ]
puts "timecycle $forward $numtimes"

	if { ($forward&1) != 0 } {
	for {set i 1} {$i < $numtimes} {set i [expr $i + 1]} {
		vis5d_set_dtx_timestep $dtx $i

		vis5d_draw_frame $dtx
		vis5d_draw_frame $dtx
		if {$anim == 1} {
	puts "$i $frame $alt $az $phi"
			set name $basename$frame$ext
			savepic $name
			set frame [expr $frame + 1]
		} else { 
			vis5d_sleep 20 
		}
	}
	}
	if {($forward&2) != 0} {
	for {set i [expr $numtimes-2]} {$i >= 0} {set i [expr $i - 1]} {
        vis5d_set_dtx_timestep $dtx $i

		vis5d_draw_frame $dtx
		vis5d_draw_frame $dtx
		if {$anim == 1} {
	puts "$i $frame $alt $az $phi"
			set name $basename$frame$ext
			savepic $name
			set frame [expr $frame + 1]
		} else { 
			vis5d_sleep 20 
		}
	}
	}
}

proc rotate { a1 a2 a3 steps} {

	global frame
	global alt
	global az
	global phi
	global basename
	global ext
	global fmt
	global ctx
	global dtx
	global anim

	set aa1 $alt
	set aa2 $az
	set aa3 $phi


	for {set i 1} {$i <= $steps} {set i [expr $i + 1]} {
		set j [expr $i.0/($steps.0)]
		set alt [expr $aa1*(1-$j)+($a1)*$j]
		set az [expr $aa2*(1-$j)+($a2)*$j]
		set phi [expr $aa3*(1-$j)+($a3)*$j]


		vis5d_set_view $ctx $alt $phi $az  1.0  0.0 0.0 0.0
		vis5d_draw_frame $dtx
		vis5d_draw_frame $dtx
		if {$anim == 1} {
#	puts "$i $j $frame $alt $az $phi"
			set name $basename$frame$ext
			savepic $name
			set frame [expr $frame + 1]
		} else { 
			vis5d_sleep 20 
		}
	}
}

# write the initial frame
vis5d_draw_frame $dtx
vis5d_draw_frame $dtx
if {$anim == 1} {
	set name $basename$frame$ext
#	savepic $name
#	set frame [expr $frame + 1]
}

###########  Put your animation script here
vis5d_set_color $ctx VIS5D_ISOSURF D1 $Riso $Giso $Biso 1.0
vis5d_alpha_mode $ctx 1
vis5d_set_isosurface_color_var_and_owner $ctx D1 $ctx -1
vis5d_set_view $ctx $alt $phi $az  1.0  0.0 0.0 0.0
#vis5d_graphics_mode $ctx VIS5D_PRETTY VIS5D_ON
vis5d_set_isosurface $ctx D1 1.0
vis5d_make_isosurface $ctx 1 D1 0
