#include "InspTri.h"
#include <qprogressdialog.h>

#ifdef UBUNTU
	#include <qapplication.h>
#else	//UBUNTU
	#include <qapp.h>
#endif	//UBUNTU

#define Inherited InspTriData

InspTri::InspTri(QWidget* parent,const char* name):Inherited( parent, name ) {

mode=CLASS;
im1o=new EMData;
im1=new EMData;
im2=new EMData;
im2->setSize(4,4,1);
im2->zero();
refs=NULL;
mode=NONE;
mxang=NULL;

//connect(brite,SIGNAL(valueChanged(int)),this,SLOT(newBC(int)));
//connect(cont,SIGNAL(valueChanged(int)),this,SLOT(newBC(int)));
connect(imgn,SIGNAL(valueChanged(int)),this,SLOT(update(int)));
connect(calc,SIGNAL(clicked()),this,SLOT(calcOrient()));
connect(calc2,SIGNAL(clicked()),this,SLOT(calcClasses()));
connect(calc3,SIGNAL(clicked()),this,SLOT(calcMatrix()));
connect(save,SIGNAL(clicked()),triv,SLOT(saveEPS()));
connect(clr,SIGNAL(clicked()),SLOT(clear()));
connect(triv,SIGNAL(select(float,float,int,float,int)),this,SLOT(newRef(float,float,int,float,int)));
connect(image1,SIGNAL(mousePress(QMouseEvent *)),this,SLOT(imClick(QMouseEvent *)));
}


InspTri::~InspTri() {
if (im1) delete im1;
if (im1o) delete im1o;
if (im2) delete im2;
}

void InspTri::setFile(const char *file) {
int i,n;

filespec=file;
//if (filespec.contains("start")) mode=START;

subflag=0;

n=fileCount(filespec);
if (n!=0) imgn->setRange(0,n-1);
else imgn->setRange(0,0);

if (refs) {
	for (i=0; i<refs->count(); i++) delete (EMData *)refs->objectAt(i);
	delete refs;
	refs=NULL;
}

// If this is a classes file, we start out by displaying the
// distribution of source data for the eulers in the file
if (filespec.contains("classes") && mode==CLASS) calcClasses();
if (mode==MATRIX) calcMatrix();

update(imgn->value());
}

void InspTri::clear() {
mode=NONE;
update(0);
imgn->setValue(0);
}

void InspTri::update(int n) {
int i;

if (mode==MATRIX) {
	EMData dat;
	triv->setColor(0);
	triv->clear();
	int n=im1->xSize();

	for (i=0; i<n; i++) {
		triv->addPoint(mxang[i*2+1],mxang[i*2],im1->valueAt(i,n),i);
	}
	triv->update();
	return;
}

im1o->readImage(filespec,n);
if (im1) delete im1;
im1=im1o->copy();

if (mode==CLASS) {
	triv->selPointMap(n);
	stat.sprintf("%1d ptcl (%1.0f,%1.0f)",im1->NImg(),im1->alt()*180.0/PI,im1->az()*180.0/PI);
	stats->setText(stat);
	triv->update();
}
else {
	triv->clear();
	im2->zero();
	triv->update();
	stats->setText("");
}

image1->setData(im1);
image2->setData(im2);
subflag=0;
}

void InspTri::calcMatrix() {
EMData dat;

mode=MATRIX;

int i;
nang=fileCount("proj.hed");
mxang=(float *)realloc(mxang,nang*sizeof(float)*2);
for (i=0; i<nang; i++) {
	dat.readImage("proj.hed",i,1);
	mxang[i*2]=dat.alt();
	mxang[i*2+1]=dat.az();
}
im1->readImage(filespec,0);
image1->setData(im1);
imgn->setRange(0,im1->ySize()-1);

update(imgn->value());
}

void InspTri::calcClasses() {
EMData dat;
int i,n;

mode=CLASS;

triv->setColor(0);
triv->clear();
stats->setText("");

n=fileCount(filespec);
for (i=0; i<n; i++) {
	dat.readImage(filespec,i,1);
	if (dat.NImg()>0) {
		triv->addPoint(dat.az(),dat.alt(),dat.NImg(),i);
//		triv->addPoint(dat.az(),dat.alt(),log10(dat.NImg()),i);
	}
}
triv->update();

}

void InspTri::calcOrient() {
float bst,dot,norm;
int bstn,i;
EMData *ali,*rf,*im1of;
QString pfile(filespec);

mode=ORIENT;

i=pfile.findRev('/');
pfile.truncate(i+1);
pfile.append("proj.hed");
//puts(pfile.data());
if (!refs) {
	refs=readImages(pfile,-1,-1);
	if (!refs) return;
	for (i=0; i<refs->count(); i++)  { 
		rf=(EMData *)refs->objectAt(i); 
//		rf->edgeNormalize();
		rf->applyMask(-1,4);
//		(rf->makeRFP(1))->normalize();
	}
}
if (refs && refs->count()==0) { delete refs; refs=NULL; return; }

QApplication::setOverrideCursor( waitCursor );
QProgressDialog progress( "Calculating", "Abort", refs->count(), this, 0 ,TRUE );
progress.setProgress( 0 );

triv->setColor(1);
triv->clear();

im1o->edgeNormalize();
//im1o->applyMask(-1,4);
//im1o->makeRFP(1);
im1of=im1o->copy(0,0);
im1of->hFlip();
//im1of->makeRFP(1);


norm=im1->xSize()*im1->ySize();
bst=0;
bstn=0;
for (i=0; i<refs->count(); i++) {
	rf=(EMData *)refs->objectAt(i);
//	dot=im1o->rotAlign(rf);
//	float dot2=im1of->rotAlign(rf);
//	if (dot2>dot) dot=dot2;
//	Euler e = *rf->getEuler();
//	ali=im1o->RTFAlignSlow(rf,im1of);
//	rf->setRAlign(&e);
	ali=im1o->RTFAlign(rf,im1of,1);
//	ali=im1o->RFAlign(rf,NULL,1);
	ali->refineAlign(rf,1);
/*	dot=rf->dot(ali);
	dot=(rf->Sigma()+SQR(rf->Mean()))*rf->xSize()*rf->ySize()+
			(ali->Sigma()+SQR(ali->Mean()))*ali->xSize()*ali->ySize()-2*dot;
	dot/=rf->xSize()*rf->ySize();
	dot=(1.0-dot)*10.0;*/
printf("(%f,%f)%1.4g\t%f\t%f",ali->Dx(),ali->Dy(),ali->alt()*180./PI,rf->az()*180./PI,rf->alt()*180./PI);
//	dot=2.0-rf->lcmp(ali,1,0);
printf("\t%f\n",dot);
//	dot=PI/2.0-ali->pcmp(rf);
	dot=1.0+ali->fscmp(rf);
	if (dot>bst) { bst=dot; bstn=i; }
	delete ali;

	triv->addPoint(rf->az(),rf->alt(),dot);
	progress.setProgress( i );
	if ( progress.wasCancelled() ) break;
}

delete im1of;

im2->readImage(pfile,bstn);
//im2->normalize();
ali=im1o->RTFAlign(im2,NULL);
//ali=im1o->RTFAlignSlow(im2,NULL);
//ali=im1o->RFAlign(im2,NULL,1);
//ali->refineAlign(im2,1);
if (im1) delete im1;
im1=ali;
triv->selPoint(bstn);
triv->update();
printf("%f %f,%f\n",ali->alt()*180.0/PI,ali->Dx(),ali->Dy());

stat.sprintf("%1d ptcl (%1.0f,%1.0f)",im2->NImg(),im2->alt()*180.0/PI,im2->az()*180.0/PI);
stats->setText(stat);

image1->setData(im1);
image2->setData(im2);

//im1->writeIMAGIC("abc.hed",-1);
//im2->writeIMAGIC("abc.hed",-1);

QApplication::restoreOverrideCursor();

}

void InspTri::newRef(float x,float y, int n,float val,int map) {
int i;
QString pfile(filespec);

switch (mode) {
case CLASS:
	imgn->setValue(map);
	update(map);
	im2->zero();
	image2->setData(im2);	
//	stat.sprintf("%1d ptcl (%1.0f,%1.0f)",(int)pow(10.0,val),y*180.0/PI,x*180.0/PI);
//	stats->setText(stat);
	break;
case MATRIX:
	i=pfile.findRev('/');
	pfile.truncate(i+1);
	pfile.append("proj.hed");

	im2->readImage(pfile,n);
	image2->setData(im2);

	stat.sprintf("%1.3g (%1.0f,%1.0f) %d",val*10.0,y*180.0/PI,x*180.0/PI,n);
	stats->setText(stat);

	subflag=0;
	break;
case ORIENT:
	EMData *ali;

	i=pfile.findRev('/');
	pfile.truncate(i+1);
	pfile.append("proj.hed");

	im2->readImage(pfile,n);
//	im2->normalize();
//	ali=im1o->RTFAlignSlow(im2,NULL);
	ali=im1o->RFAlign(im2,NULL,1);
	//ali->refineAlign(im2,1);
	printf("%f %f,%f\n",ali->alt()*180.0/PI,ali->Dx(),ali->Dy());
	if (im1) delete im1;
	im1=ali;

	image1->setData(im1);
	image2->setData(im2);

	stat.sprintf("%1.3g (%1.0f,%1.0f) %d",val*10.0,y*180.0/PI,x*180.0/PI,n);
	stats->setText(stat);

	subflag=0;
	break;
}

}

void InspTri::imClick(QMouseEvent *me) {
float *d1,*d2;
int i,n;
float a,b;

if (im1->Sigma()==0 || im2->Sigma()==0) return;

if (subflag) {
	im1->add(im2);
	im1->normalize();
	image1->setData(im1);
	subflag=0;
	return;
}

im2->normalizeTo(im1);

// now we subtract
im1->subtract(im2);
image1->setData(im1);
subflag=1;
}
