#include <qgl.h>
#include <Euler.h>
#include "Vect.h"
#include <qtimer.h>

class MatrixView:public QGLWidget {
    Q_OBJECT

enum { MV_SKIP, MV_CUBE, MV_POINT, MV_POINTS, MV_CONNECT };

#define DIM 6		// x,y,z  error  alt,az

QTimer *timer;

int npoints;
float *points;	// array x DIM of x/y/z points and distance quality match
float *matrix;	// The distance matrix data (optional)
float pscale;	// this is the scaling that was applied between the points in the file and the display space
float dscale;	// zoom in visualization

int sel0,sel1,selalt;

float alt0,alt1,az0,az1;

enum { MV_TRI = 1, MV_IMAGE = 2, MV_ALTLINE = 4, MV_CYCLESEL = 8, MV_ALTPLANE = 16 };
int modes;

char *imagefile;

Vect lastpos;
Vect curpos;
Vect destpos;

float mdx,mdy;		// used for interactive rotation
Euler angle;		// camera viewing angle

GLUquadric *spherequad;

public:
MatrixView( const QGLFormat & format, QWidget * parent=0, const char * name=0, const QGLWidget * shareWidget = 0,WFlags f=0 );
~MatrixView();

// points must contain n*DIM floats
// MatrixView 'owns' points after this call
void setPoints(int n,float *Points);

// Matrix must be npoints x npoints
// MatrixView 'owns' matrix after this call
void setMatrix(float *Matrix) { matrix=Matrix; }

void setGeom();
void setPointSize(float s);
void setImageFile(char *fsp) { imagefile=fsp; update(); }

virtual void initializeGL() ;
virtual void paintGL();
virtual void mousePressEvent ( QMouseEvent * );
virtual void mouseReleaseEvent ( QMouseEvent * );
virtual void mouseMoveEvent ( QMouseEvent * );
virtual void resizeGL( int width, int height );
virtual void keyPressEvent ( QKeyEvent *e );

public slots:
void timeout();

};
