/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/


void Control::fileOpenMicro()
{
QString s1( QFileDialog::getOpenFileName() );
if ( s1.isNull() ) return;
QFileInfo file(s1);
mgraph_id=file.baseName();

micro.readImage((const char *)s1,0);
image->show();
image->setData(&micro);
imResized(image->width(),image->height());
}

void Control::setData(char *s1)
{
QString s0(s1);
QFileInfo file(s0);
mgraph_id=file.baseName();

micro.readImage(s1,0);
image->show();
image->setData(&micro);
imResized(image->width(),image->height());
}

void Control::setScale(char *s)
{
QString ss(s);
scale=ss.toFloat();
image->setScale(scale);
imResized(image->width(),image->height());
}

void Control::setContrast(char *s)
{
QString ss(s);
contrast=ss.toFloat();
image->setCont(contrast);
imResized(image->width(),image->height());
}


EMData *getPtcl(EMData *src,ImShape *s) {
    float x2=s->x1-s->x0;
    float y2=s->y1-s->y0;
    float ln=hypot(x2,y2);
    float px= y2/ln;
    float py=-x2/ln;
	x2/=ln;
	y2/=ln;
	ln=floor(ln);

	// x2,y2 and px,py now form an orthogonal basis for boxing
	EMData *sv = new EMData;
	sv->setSize(s->r*2,ln);
	float x,y;
	for (y=0; y<ln; y+=1.0) {
		for (x=-s->r; x<s->r; x+=1.0) {
			float v=src->valueAtInterp(s->x0+x*px+y*x2,s->y0+x*py+y*y2);
			sv->setValueAt((int)x+s->r,(int)y,0,v);
		}
	}
	sv->getData();	//after the unsafe 'setvalue' operations
	sv->doneData();

	return sv;
}

void Control::fileSaveParticles()
{
int i;
QString defaultClipfile = mgraph_id + QString(".img");
QString t( QFileDialog::getSaveFileName(defaultClipfile,"EM Images (*.hed *.img *.spi *.ssw *.mrc)") );
if ( t.isNull() ) return;

int type=0;
char name[80];
if (t.contains(".hed")||t.contains(".img")) type=1;
else if (t.contains(".spi")) type=2;	// spider with machine native byte-order
else if (t.contains(".ssw")) type=4;	// spider with swapped byte-order
else if (t.contains(".mrc")) type=3;
else { type=1; error(ERR_INFO,"File didn't end in .hed, .spi, .ssw or .mrc. Using IMAGIC."); }

ImShape *s;
int overwrite=0;
for (i=0;  i<image->nShapes(); i++) {
    s=image->shapeAt(i);
	EMData *sv=getPtcl(&micro,s);
	sprintf(name,"From %d, %d to %d, %d width=%d",s->x0, s->y0, s->x1, s->y1, (s->x1-s->x0));
	sv->setName(name);
	char u[10];
	sprintf(u,".%0d",i);
	QString tt(t);
	tt.insert(t.length()-4,u);
	if (!overwrite && !access((const char *)tt,F_OK)) {
	    overwrite=QMessageBox::warning ( this,"File Warning","One or more particle image files already exist. Do you wish to overwrite any existing files?","No","Yes",QString::null,1,0);
	    if (!overwrite) break;
	}

	switch (type) {
	case 1:
		sv->writeIMAGIC((const char *)tt,0);
		break;
	case 2:
		sv->writeSingleSPIDER((const char *)tt);
		break;
	case 4:
		sv->writeSingleSPIDER((const char *)tt,1);
		break;
	case 3:
		sv->writeMRC((const char *)tt);
		break;
	}
	delete sv;
}

}

void Control::fileExit()
{
FILE *out = DFopenw("hboxerwin");
if (out) {
	fprintf(out,"%d %d %d %d\n",x(),y(),width(),height());
	fprintf(out,"%d %d %d %d\n",particle->x(),particle->y(),particle->width(),particle->height());
	fprintf(out,"%d %d %d %d\n",image->x(),image->y(),image->width(),image->height());
	fclose(out);
}
emit(exit());
}

void Control::helpIndex()
{

}

void Control::helpContents()
{

}

void Control::helpAbout()
{

}


void Control::fileSaveDB()
{
int i;    

QString defaultBoxfile = mgraph_id + QString(".box");
QString t( QFileDialog::getSaveFileName(defaultBoxfile,"*.box") );
if ( t.isNull() ) return;

if (t.contains(".box") <= 0) t+=".box";

FILE *out=fopen((const char *)t,"w");

ImShape *s;
for (i=0;  i<image->nShapes(); i++) {
    s=image->shapeAt(i);
    fprintf(out,"%1.0f\t%1.0f\t%1.0f\t%1.0f\t-1\n",s->x0-s->r,s->y0-s->r,s->r*2,s->r*2);
    fprintf(out,"%1.0f\t%1.0f\t%1.0f\t%1.0f\t-2\n",s->x1-s->r,s->y1-s->r,s->r*2,s->r*2);
}
fclose(out);
}

void Control::fileReadDB(char *t)
{

FILE *in=fopen((const char *)t,"r");
while (fgets(t,120,in)) {
    ImShape *s;
    int a0,a1,a2,a3,a4=0,a5,a6;
    sscanf(t," %d %d %d %d %d",&a0,&a1,&a2,&a3,&a4);
    
    if (a4==-1) {
	fgets(t,120,in);
	sscanf(t," %d %d %d %d %d",&a2,&a3,&a4,&a5,&a6);
	if (a6!=-2) continue;
	s=new ImShape;
	s->x0=a0+a4/2;
	s->y0=a1+a4/2;
	s->x1=a2+a4/2;
	s->y1=a3+a4/2;
	s->r=a4/2;
	s->color=green;
	s->type=ImShape::HELIXBOX;
	image->addShape(s);
    }
}
fclose(in);

image->update();
}


void Control::fileReadDB()
{
QString s( QFileDialog::getOpenFileName() );
char t[121];
if ( s.isNull() ) return;

FILE *in=fopen((const char *)s,"r");
while (fgets(t,120,in)) {
    ImShape *s;
    int a0,a1,a2,a3,a4=0,a5,a6;
    sscanf(t," %d %d %d %d %d",&a0,&a1,&a2,&a3,&a4);
    
    if (a4==-1) {
	fgets(t,120,in);
	sscanf(t," %d %d %d %d %d",&a2,&a3,&a4,&a5,&a6);
	if (a6!=-2) continue;
	s=new ImShape;
	s->x0=a0+a4/2;
	s->y0=a1+a4/2;
	s->x1=a2+a4/2;
	s->y1=a3+a4/2;
	s->r=a4/2;
	s->color=green;
	s->type=ImShape::HELIXBOX;
	image->addShape(s);
    }
}
fclose(in);

image->update();
}


void Control::init()
{
image=new Image();
image->setScale(1.0);
image->setBackgroundMode(NoBackground);

particle=new Image();
particle->setScale(1.0);
particle->setBackgroundMode(NoBackground);

connect(image,SIGNAL(mousePress(QMouseEvent *)),SLOT(mousePress(QMouseEvent *)));
connect(image,SIGNAL(mouseMove(QMouseEvent *)),SLOT(mouseMove(QMouseEvent *)));
connect(image,SIGNAL(mouseRelease(QMouseEvent *)),SLOT(mouseRelease(QMouseEvent *)));
connect(image,SIGNAL(resized(int,int)),SLOT(imResized(int,int)));
connect(image,SIGNAL(moved(int,int)),SLOT(imMoved(int,int)));
curshape=-1;

image->resize(500,500);
particle->resize(100,500);

// This restores the window geometries
FILE *in = in=DFopenr("hboxerwin");
if (in) {
	int x,y,w,h;
#ifndef SGI
	if (fscanf(in," %d %d %d %d",&x,&y,&w,&h)==4) {
		resize(QSize(w,h));
		move(QPoint(x,y)); 
	}
	if (fscanf(in," %d %d %d %d",&x,&y,&w,&h)==4) {
		particle->resize(QSize(w,h));
		particle->move(QPoint(x,y));
	}
	if (fscanf(in," %d %d %d %d",&x,&y,&w,&h)==4) {
		image->resize(QSize(w,h));
		image->move(QPoint(x,y));
	}
#endif
	fclose(in);
}
image->show();
particle->show();

}

void Control::destroy()
{
//   printf("destroy/n");
FILE *out = DFopenw("hboxerwin");
if (out) {
	fprintf(out,"%d %d %d %d\n",x(),y(),width(),height());
	fprintf(out,"%d %d %d %d\n",particle->x(),particle->y(),particle->width(),particle->height());
	fprintf(out,"%d %d %d %d\n",image->x(),image->y(),image->width(),image->height());
	fclose(out);
}

delete image;
delete particle;
}


void Control::setWidth( int )
{
if (curshape<0) return;

}


void Control::mouseMove( QMouseEvent *e )
{
if (curshape<0) return;

int x=image->pxtodx(e->x());
int y=image->pytody(e->y());

ImShape *s = image->shapeAt(curshape);



if (curshapever==1||curshapever<0) {
    s->x1+=x-mx0;
    s->y1+=y-my0;
}

if (curshapever<=0) {
    s->x0+=x-mx0;
    s->y0+=y-my0;
}

mx0=x;
my0=y;

image->update();

// Statusbar display
QString st;
st.sprintf("(%0.0f,%0.0f) - (%0.0f,%0.0f)  %0.0f x %0.0f",s->x0,s->y0,s->x1,s->y1,s->r*2,floor(hypot(s->x0-s->x1,s->y0-s->y1)));
statusBar()->message(st,4000);
}

void Control::mousePress( QMouseEvent *e )
{
int i;
ImShape *s;
int x=image->pxtodx(e->x());
int y=image->pytody(e->y());


// Specify width, but ImShape uses 'radius'
int w=boxwidth->value();
if (w%2==1) { boxwidth->setValue(w+1); w++; }
w/=2;

int bst=-1;
float ba,bc,bstd=1.0e6;
for (i=0;  i<image->nShapes(); i++) {
    s=image->shapeAt(i);
    float b=hypot(s->x0-s->x1,s->y0-s->y1);			// current shape length
    float a=hypot(s->x0-x,s->y0-y);
    float c=hypot(s->x1-x,s->y1-y);
    if ((a>w && c>b) || (c>w && a>b)) continue;
    float ld=a*sqrt(1.0-SQR((a*a+b*b-c*c) / (2.0*a*b)));		// ld is the distance from the line to the mouse pointer
    if (ld<s->r && ld<bstd) { bstd=ld; ba=a; bc=c; bst=i; }
}

// Control-left click will delete
if ((e->state()&ControlButton)) {
	if (bst<0) return;
	image->delShape(bst);
	image->update();
	curshape=-1;
	return;
}

// Not inside any existing shape, so make a new one
if (bst<0) {
    mx0=x;
    my0=y;
    s=new ImShape();
    s->type=ImShape::HELIXBOX;
    s->x0=s->x1=x;
    s->y0=s->y1=y;
    s->r=w;
    s->color=blue;
    curshape=image->addShape(s);
    curshapever=1;
    return;
}

// Figure out which vertex we're moving
s=image->shapeAt(bst);
curshape=bst;
mx0=x;
my0=y;
boxwidth->setValue(s->r*2);

if (ba<bc && ba<s->r) curshapever=0;
else if (bc<ba && bc<s->r) curshapever=1;
else curshapever=-1;
s->color=blue;

}

void Control::mouseRelease( QMouseEvent *e )
{
if (curshape<0) return;
if (particle->getData()) {
	EMData *old=particle->getData();
	particle->setData(NULL);
	delete old;
}
ImShape *s=image->shapeAt(curshape);
EMData *ptcl = getPtcl(&micro,s);
particle->setData(ptcl);
s->color=green;
curshape=-1;
image->update();
}

void Control::Panned( float x, float y)
{
image->setOrigin(x,y);

}

void Control::imResized(int w, int h)
{

float xh,yh;
float ls=image->lscale;
if (ls==0.0) ls=1.0;

if (micro.xSize()>micro.ySize())
	pan->resize(140,140*micro.ySize()/micro.xSize());
else pan->resize(140*micro.xSize()/micro.ySize(),140);
pan->setXRange(0,micro.xSize()*ls-w);
pan->setYRange(0,micro.ySize()*ls-h);
if (micro.xSize()*ls<w) xh=1.0;
else xh=w/(micro.xSize()*ls);
if (micro.ySize()*ls<h) yh=1.0;
else yh=h/(micro.ySize()*ls);

pan->setHandleSize(xh,yh); 
pan->update();
}

void Control::imMoved( int x, int y)
{
pan->setValue(x,y);
}


void Control::bye()
{
//printf("destroy\n");
/*FILE *out = DFopenw("hboxerwin");
if (out) {
	fprintf(out,"%d %d %d %d\n",x(),y(),width(),height());
	fprintf(out,"%d %d %d %d\n",particle->x(),particle->y(),particle->width(),particle->height());
	fprintf(out,"%d %d %d %d\n",image->x(),image->y(),image->width(),image->height());
	fclose(out);
}
*/
}


