#include "EMHist.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "util.h"

EMHist::EMHist(char *str) {
id=0;
etime=0;
fintime=0;
type=0;
ppid=0;
file=NULL;
info=NULL;
command=NULL;
tstr=NULL;
rtstr=(char *)malloc(16);
strcpy(rtstr," - ");
dir=NULL;
if (str) parse(str);
}

EMHist::~EMHist() {
if (file) free(file);
if (info) free(info);
if (tstr) free(tstr);
if (rtstr) free(rtstr);
if (command) free(command);
if (dir) free(dir);
}

void EMHist::parse(const char *str) {
int n;
char *s1,*s2;

if (file) { free(file); file=NULL; }
if (info) { free(info); info=NULL; }
if (tstr) { free(tstr); tstr=NULL; }
if (command) { free(command); command=NULL; }

if (sscanf(str,"%d %d %d%n",&id,&etime,&type,&n)<3) {
	printf("History error '%s'\n",str);
	return;
}
s1=(char *)str+n+1;
s2=strchr(s1,'\t');
if (s2) {
	file=(char *)malloc(s2-s1+1);
	strncpy(file,s1,s2-s1);
	file[s2-s1]=0;

	if (type==LOG_BEGIN && file[0]!='-') ppid=atoi(file);

	s2++;
	if (*s2) {
		info=(char *)malloc(strlen(s2)+1);
		strcpy(info,s2);
	}
}
else {
	file=(char *)malloc(strlen(s1)+1);
	strcpy(file,s1);
	if (info) free(info);
	info=NULL;
}

tstr=(char *)malloc(25);
struct tm *lt=localtime(&etime);
sprintf(tstr,"%2d/%02d/%02d %2d:%02d:%02d",lt->tm_mon+1,lt->tm_mday,lt->tm_year%100,lt->tm_hour,lt->tm_min,lt->tm_sec);
	
command=Command();
return;
}

char *EMHist::Command() {
char *ret,*s;

if (!info) return "";
s=strchr(info,' ');
if (!s) {
	ret=(char *)malloc(strlen(info)+1);
	strcpy(ret,info);
	return ret;
}

ret=(char *)malloc(s-info+1);
strncpy(ret,info,s-info);
ret[s-info]=0;
return (ret);
}

void EMHist::setDir(const char *d) {
dir=(char *)malloc(strlen(d)+1);
strcpy(dir,d);
}

char *EMHist::getDir() {
return dir;
} 

void EMHist::setFinTime(time_t tm) {
fintime=tm;
if (fintime-etime<60) sprintf(rtstr,"      %2d",fintime-etime);
else if (fintime-etime<3600) sprintf(rtstr,"   %2d:%02d",(fintime-etime)/60,(fintime-etime)%60);
else sprintf(rtstr,"%2d:%02d:%02d",(fintime-etime)/3600,((fintime-etime)%3600)/60,(fintime-etime)%60);
}
