#include <stdio.h>
#include "EMData.h"
#include "List.h"
#include "util.h"
#include <math.h>
#define IQUEST 2 
            // possible values are 0 or 1; 1 means use phase 
			//     residuals to calculate cross-common lines		
		

void com2angs(ANG *ang,char *argv,float RADIUS, int peaks, int n) {
int i,j,ij,ji,sinopix,ithetaA,ithetaB,iquest=IQUEST,ip,isize;
int iq,ix,iy,index,index2,iradius=RADIUS;
List *data;
EMData *d,*d2,*d3;
float *p;
data=readImages(argv,0,-1);
//int n=data->count();

for (i=0; i<n; i++) ((EMData*)data->objectAt(i))->toCorner();


for (i=0; i<n; i++) {
		d =(EMData*)data->objectAt(i);

	for (j=i+1; j<n; j++) {		
		d2=(EMData*)data->objectAt(j);
		d3=new EMData;

		d3->commonLines(d,d2,iquest);  
		p=d3->getData();
		if (i+j==1)	isize = d3 -> xSize(); 
		ji=i+j*n;
		ij=j+i*n;		
		
		if (iquest==1 ) { for (index=0; index< isize*isize; index++){
						p[index] = 180.- p[index];}}
				
//  ang[ij].a1[0] is the angle of the common line as it appears in the ith micrograph.
//                if i=0 and j represents B, then its equal to AB =  azB
//
//  ang[ji].a1[0] is the angle of the common line as it appears in the jth micrograph
//                if i=0 and j represents B, then its equal to BA = -phiB
//

//		ang[ij].a1[0]=ang[ji].a2[0]=ang[ij].a2[0]=ang[ji].a1[0]=-180.0;
//		ang[ij].l[0]=ang[ji].l[0]=-1.0;
		
		for (ithetaB=sinopix=0; ithetaB<isize/2; ithetaB++) { // ithetaB is the thetaB variable
			for (ithetaA=0; ithetaA<isize; ithetaA++,sinopix++) { // ithetaA is the thetaA variable
//		printf("ithetaA =%d		ithetaB =%d \n",ithetaA,ithetaB);
		
				                             // sinopix is loc of the sino pixel = (ithetaA, ithetaB)
											 // actually sinopix= (ithetaA-270) + isize*(ithetaB-270);
				
//				if ( p[sinopix] > p[sinopix-1] && p[sinopix] > p[sinopix+1] 
//				&& p[sinopix]>p[sinopix-361]   && p[sinopix] > p[sinopix-360] && p[sinopix] > p[sinopix-359] 
//				&& p[sinopix]>p[sinopix+359]   && p[sinopix] > p[sinopix+360] && p[sinopix] > p[sinopix+361]) {
//					iquest = 1; } else iquest=0;
			  
			  	iquest =1;
		  		for (iy=-iradius; iy <= iradius; iy++){
				for (ix=-iradius; ix <= iradius; ix++){
					if (ix ==iy && iy==0) ix++;
					ip = ix + isize*iy;   // this is the delta index
					if ((ix*ix + iy*iy < RADIUS*RADIUS) &&  (p[sinopix] < p[sinopix+ip]) ){
						iquest=0;ix=iy=iradius;
					}  // then a near neighbor stronger
				}} // ends for ix,iy neighborhood search
				
				if (iquest){						               // if it winds up being the strong peak
					for (index=peaks-1; index  >= 0; index--) { // Move towards the top of the 
															     // stack, which is labelled 0;
						if ( p[sinopix] > ang[ij].l[index] && (         // find out where it fits;
						(index >0 && p[sinopix] < ang[ij].l[index-1] )  // or it's the top value
						|| index==0) ){ 
							
							// Push the stack below, down
							for (index2=peaks-1; index2 >= index ; index2-- ) {
								ang[ij].a1[index2+1]=ang[ji].a2[index2+1]=ang[ij].a1[index2];
								ang[ji].a1[index2+1]=ang[ij].a2[index2+1]=ang[ji].a1[index2];
								ang[ij].l[index2+1] =ang[ji].l[index2+1] =ang[ij].l[index2];
							}
							
				// Reset the values at index
							ang[ij].a1[index]=ang[ji].a2[index]= 270.5 + ((float) ithetaA*360.)/((float) isize);
							ang[ji].a1[index]=ang[ij].a2[index]= 270.5 + ((float) ithetaB*360.)/((float) isize);
							ang[ij].l[index] =ang[ji].l[index] =   p[sinopix];

		if (ang[ij].a1[index] > 360.0) ang[ij].a1[index] += -360.;
		if (ang[ji].a1[index] > 360.0) ang[ji].a1[index] += -360.;
//							
					} // ends   if p[sinopix] 	
					} // ends index loop
				} // ends  if segmentation statement
			}  // ends ithetaA loop
		}	   // ends ithetaB loop			

		d3->doneData();
		delete d3;
					
		printf(" %d,%d done\r",i+1,j+1);
		fflush(stdout);
//		for (iq=0; iq  < peaks; iq++) { 
//			printf("%f		%f		%f	\n", ang[ij].a1[iq],360-ang[ji].a1[iq],ang[ij].l[iq]);}
		
	}  //ends j loop
}      //ends i loop

	return;
}
// **************************************************************************
//         symsearch: finds the most symmetric particle of the first n
//         		csymnum is 4 for C4 symmetry
//         		returns the integer is most symmetrical wrt that symmetry

void symsearch(char *argv,float radius, int csymnum, int *best, int *middle) {
int i,j,iquest,isize,index;
int sinopix,sinoaddx,sinoaddy;
int ithetaA, ithetaB;
int ibest, indexmostsym;
int n;
List *data;
EMData *d,*d2,*d3;
float *p, *quality, sympix,qualitymax;

//unlink("self.img");unlink("self.hed");
unlink("reordered.img");unlink("reordered.hed");

data=readImages(argv,0,-1);
n=data->count();


quality = (float *)calloc(n,sizeof(float));
for (i=0; i<n; i++) ((EMData*)data->objectAt(i))->toCorner();


for (i=0; i<n; i++) {
		quality[i]=0;
		d =(EMData*)data->objectAt(i);
		d2=(EMData*)data->objectAt(i);
		d3=new EMData;
		
//		printf(" isize = %d, csymnum = %d, ratio = %d \n",isize,csymnum, isize/csymnum);
		iquest=0;     //  This determines whether to use phase residual or not;
		d3->commonLines(d,d2,iquest);   
		p=d3->getData();
		isize = d3 -> xSize(); 

		if (iquest==1) { for (index=0; index< isize*isize; index++){
						p[index] = 180.- p[index];}}
		
		for (ithetaB=0; ithetaB<isize/csymnum; ithetaB++) {     
										// ithetaB is the thetaB variable
			ithetaA=ithetaB;			// ithetaA is the thetaA variable
			                            // sinopix is loc of the sino pixel
			sinopix = ithetaA + isize*ithetaB;
			
			sympix =0;                  // sympix is the symmetrization of p[sinopix]
			for (sinoaddy=0; sinoaddy< csymnum; sinoaddy++){
				for (sinoaddx=0; (sinoaddx< csymnum && sinoaddx != sinoaddy); sinoaddx++) {
					sympix += p[sinopix+(sinoaddx+ sinoaddy*isize)*isize/csymnum];}}
			sympix = sympix/(csymnum*(csymnum-1)* p[sinopix]); // should be about 1
//			printf(" sympix should be about unity %f \n",sympix);
			quality[i] += sqrt(sympix*sympix);

		}	   // ends ithetaB loop					
		d3->doneData();
		printf("\n %d why aren't you writing out self.img?????  \n",i+1);
		d3 -> writeIMAGIC("self.img",-1);   // CHNAGE THIS LINE IF YOU WANT
		delete d3;								// to see self sinecorrs
		
		printf("\n %d self search has quality %f \n",i+1,quality[i]*csymnum/isize);
		fflush(stdout);
		
}	// ends i loop		
for (j=0;j<n;j++) {
	qualitymax=-1000;
	for (i=0;i<n;i++) {
		if (quality[i] >qualitymax) {	
			qualitymax  = quality[i];
			ibest = i;}
	}										
	quality[ibest]	= -2000;
	d3 =  (EMData*)data->objectAt(ibest);
	d3 -> toCorner();
//	d3 -> writeIMAGIC("reordered.img",-1); 
	delete d3;
	if (j==0) indexmostsym = ibest;
	if (j==n/2) *middle = ibest;
}  // ends j loops
// return indexmostsym;
	*best = indexmostsym;
	
// 
}

// ******************************************************************************************
//         symcenter: returns the value of the symmetry search of the particle
//         		csymnum is 4 for C4 symmetry
//         		returns the integer is most symmetrical wrt that symmetry


float symcenter(char *argv,int ilist, int csymnum) {
int n,iquest=IQUEST,isize,index;
int ithetaA, ithetaB;
List *data;
EMData *d,*d2,*d3;
float *sinodata, quality;

// unlink("self.img");unlink("reordered.img");
// unlink("self.hed");unlink("reordered.hed");

data=readImages(argv,0,-1);
n=data->count();



// quality = (float *)calloc(n,sizeof(float));



((EMData*)data->objectAt(ilist))->toCorner();


		quality=0;
		d =(EMData*)data->objectAt(ilist);
		d2=(EMData*)data->objectAt(ilist);
		d3=new EMData;
		
//		printf(" isize = %d, csymnum = %d, ratio = %d \n",isize,csymnum, isize/csymnum);
		d3->commonLines(d,d2,iquest);   
		sinodata=d3->getData();
		isize = d3 -> xSize(); 

		if (IQUEST==1) { for (index=0; index< isize*isize; index++){
						sinodata[index] = 180.- sinodata[index];}}
						
		quality = 0;
		
		for (ithetaA=0; ithetaA<isize/2; ithetaA++) {
			ithetaB = ithetaA + isize/4;
			if (ithetaB >= isize) ithetaB += - isize;     

			index = ithetaA + isize*ithetaB;
			
			quality += sinodata[index];
		}
		
//		printf(" qulaity = %f \n", quality);
		return quality;
			

}





/*	      EXCISED FROM symsearch
// float *listing;
//listing = (float *)calloc(3*n*peaks,sizeof(float));
//     0,1, ...,     peaks-1  is the 1st angle for the 0th particle
//     peaks, ...,2 *peaks-1  is the 2nd angle for the 0th particle
//    2*peaks,...,3 *peaks-1  is the amplitude of that peak
		  	iquest =1;
		  		for (iy=-iradius; iy <= iradius; iy++){
				for (ix=-iradius; ix <= iradius; ix++){
					if (ix ==iy && iy==0) ix++;
					ip = ix + isize*iy;   // this is the delta index
					if ((ix*ix+ iy*iy < radius*radius) &&  (p[sinopix] < p[sinopix+ip]) ){
						iquest=0;ix=iy=iradius;
					}  // then a near neighbor stronger
				}} // ends for ix,iy neighborhood search
				
				if (iquest){						               // if it winds up being the strong peak
					for (index=peaks-1; index  >= 0; index--) { // Move towards the top of the 
															     // stack, which is labelled 0;
						if ( p[sinopix] > listing[peaks*(3*i+2)+index] && (         // find out where it fits;
						(index >0 && p[sinopix] < listing[peaks*(3*i+2)+index-1] )  // or it's the top value
						|| index==0) ){ 
							
							// Push the stack below, down
							for (index2=peaks-1; index2 >= index ; index2-- ) {
								listing[peaks*(3*i+0)+index2+1]= listing[peaks*(3*i+0) +index2];
								listing[peaks*(3*i+1)+index2+1]= listing[peaks*(3*i+1) +index2];
								listing[peaks*(3*i+2)+index2+1]= listing[peaks*(3*i+2) +index2];
							} // ends index2 loop
							
				// Reset the values at index
							listing[peaks*3*i     +index]= 270.5 + ((float) ithetaA*360.)/((float) isize);
							listing[peaks*(3*i+1) +index]= 270.5 + ((float) ithetaB*360.)/((float) isize);
							listing[peaks*(3*i+2) +index] =   p[sinopix];

		while (listing[peaks*3*i     +index] > 360.0) listing[peaks*3*i     +index] += -360.;
		while (listing[peaks*(3*i+1) +index] > 360.0) listing[peaks*(3*i+1) +index] += -360.;
//							
					} // ends   if p[sinopix] 	
					} // ends index loop
				} // ends  if segmentation statement
//		for (index=0; index  < peaks; index++) { 
//			printf("%f		%f		%f	\n", listing[peaks*(3*i) +index],
//				360-listing[peaks*(3*i+1) +index],listing[peaks*(3*i+2) +index]);}
*/
