#include <stdio.h>
#include "EMData.h"
#include "List.h"
#include "util.h"
#include <math.h>



float tiltfunc(float ang1, float ang2, float ang3){ // arguments are given in radians
		float answer, pi =3.1415926,piover=1.;      //  answer given in radians
		answer = (cos(ang1*piover) * cos(ang2*piover) + cos(ang3*piover))/
				(sin(ang1*piover) * sin(ang2*piover) );
     if (answer*answer < 1) { answer = acos(answer) ;
             } else { if(answer*answer>1.2) {
			  				answer=100000.*pi/180.;}
					  else{
							if (answer >=  0.) {answer = 0. ;}
			  				else {answer = pi; } }}
// printf("from tiltfunc %f	\n" ,answer);				
	return	answer;}

float tiltfunc2(float ang1, float ang2, float ang3){ // arguments are given in radians
		float answer, pi =3.1415926,piover=pi/pi;      //  answer given in radians
		answer = (cos(ang1*piover) * cos(ang2*piover) - cos(ang3*piover))/
				(sin(ang1*piover) * sin(ang2*piover) );
     if (answer*answer < 1) { answer = acos(answer) ;
             } else { if(answer*answer>1.0) {
			  				answer=10000.*pi/180.;}
					  else{
							if (answer >=  0.) {answer = 0. ;}
			  				else {answer = pi; } }}				
	return	answer;}


float tiltfunc3(float ang1, float ang2, float ang3){ // arguments are given in radians
		float answer, pi =3.1415926,piover=1; //pi/180.;      //  answer given in radians
		answer = (cos(ang1*piover) * cos(ang2*piover) - cos(ang3*piover))/
				(sin(ang1*piover) * sin(ang2*piover) );
     if (answer*answer < 1) { answer = acos(answer) / piover ;
             } else { if(answer*answer>.9) {
			  				answer=100000.*pi/180.;}
					  else{
							if (answer >=  0.) {answer = 0. ;}
			  				else {answer = 180.; } }}
// printf("from tiltfunc %f	\n" ,answer);				
	return	answer;}

/*******************************************************************************/
	
void triforsides(float alpha, float beta, float gamma, float *tiltxAB, float *tiltxCA, float *tiltxBC) {
		float pi=3.1415926;
//      The following is iA iB
       *tiltxAB = tiltfunc2(alpha,beta,gamma);	// answer is in radians	
		
//      Now comes iA iC
       *tiltxCA = atan2( sin(beta) *sin(*tiltxAB)/sin(gamma),
	   				cos(tiltfunc2(gamma,alpha,beta)));	
		if (*tiltxCA >0) *tiltxCA += -pi;
//		
//		originally was	
//		tiltxAC = - tiltxCA; if (tiltxAC <0) tiltxAC += pi;
//							 if (tiltxAC <0) tiltxAC *= -1;
//     Now comes iB iC
       *tiltxBC  = atan2( sin(alpha) *sin(*tiltxAB)/sin(gamma),
	   		cos(tiltfunc2(beta,gamma,alpha))); if (*tiltxBC <0) *tiltxBC += pi;

		return; }

void triangles(float alpha, float beta, float gamma, float *tiltxBC, float *tiltxCA, float *tiltxAB) {
		float pi =3.1415926,piover=1; //pi/180.;      //  answer given in radians

      *tiltxBC = tiltfunc3(beta,gamma,alpha);	//   input  given in radians
	  
	  if (alpha<0) alpha += 4*pi/piover;
	  while (alpha> 2*pi/piover) alpha += -2*pi/piover;
//	  if (alpha >pi/piover) *tiltxBC *= -1;
		
      *tiltxCA = atan2( sin(beta*piover) *sin(*tiltxBC*piover)/sin(alpha*piover),
	   				cos(tiltfunc3(gamma,alpha,beta) *piover))     /piover;	
//		if (*tiltxCA >0) *tiltxCA += -pi/piover;

      *tiltxAB  = atan2( sin(gamma*piover) *sin(*tiltxBC*piover)/sin(alpha*piover),
	   		cos(tiltfunc3(alpha,beta,gamma) *piover))   / piover; 
//			if (*tiltxBC <0) *tiltxBC += pi/piover;

		return; }

/*******************************************************************************/

    
void eulermult(euler *bc, euler *ab, euler *ac) { //  find ac = bc ab
float abalt,abaz,abphi,  bcalt,bcaz,bcphi,  acalt,acaz,acphi;
float a, b, c, alpha, beta, gamma, pi = 3.1415926,piover=pi/180.;
float cosb;

// c->alt=a->alt*b->alt;
abalt = ab ->alt; abaz = ab ->az; abphi = ab->phi;
bcalt = bc ->alt; bcaz = bc ->az; bcphi = bc->phi;
acalt = ac ->alt; acaz = ac ->az; acphi = ac->phi;

while (abalt >= 180.) abalt += -360.;
while (bcalt >= 180.) bcalt += -360.;

// This function takes the rotation                  The input is in degrees
// matrix ab and multiplies it on the left
// by bc. What we want is to find the new 
// euler angles of the resulting matrix ac.      The answer is returned in degrees

a = bcalt*piover;  bcaz *= piover; bcphi *= piover;  // None of the ac quantities are known
b = acalt*piover;  acaz *= piover; acphi *= piover;  //  We know a=bcalt, c = abalt,
c = abalt*piover;  abaz *= piover; abphi *= piover;  //           but not b = acalt

alpha = pi - acaz  + abaz;  
beta  = pi + bcaz  + abphi; beta += 8*pi; while (beta>2*pi) beta += -2*pi; 
gamma = pi - acphi + bcphi;   //  We only know  beta

//printf("alpha = %f beta= %f gamma = %f \n", alpha, beta, gamma);
 
// At this point, we know what two sides are and the angle
//   between these sides. We can use the law of cosines
// to determine the third side.

cosb = (cos(a) * cos(c)  + sin(a) *sin(c) * cos(beta));
b = acos(cosb);
//	gamma =atan2( sin(c) * (pi-beta)  , (cos(c) - cos(b) * cos(a) )/ sin(a)  );
//	alpha = atan2( sin(a) *(pi-beta)  , (cos(a) - cos(c) * cos(b) )/ sin(c)  );} else{
//  Now we know three sides and an angle
//   Determine the other two angles from the law of sines, 
//                                    and law of cosines.
// 
if  (sqrt((beta-pi)*(beta-pi)) < .001) {
	b = a+c + 8*pi; while (b > pi) b += -2*pi;
	if (b<0) b *= -1;
	gamma = atan2( sin(c) * (pi-beta),  sin(a+c) - 
	           sin(c) * cos(a) * (beta-pi)* (beta-pi)/2);
  	alpha = atan2( sin(a) * (pi-beta) , sin(a+c)- cos(c) * sin(a) *(beta-pi)*(beta-pi)/2 );
	} else {
    	if   (sqrt(sin(beta)*sin(beta)) < .001) {
			b = a-c + 8*pi; while (b > pi) b += -2*pi;
			if (b<0) b *= -1;
			gamma = atan2(sin(c) * beta,sin(a-c)+sin(c)*cos(a)*beta*beta/2);
  			alpha = atan2(sin(a) * beta,sin(c-a)+cos(c)*sin(a)*beta*beta/2);
		} else {
//	gamma = bcphi; alpha = abaz; else
//	printf("gamma in if = %f \n", gamma);
//gamma = atan2( sin(c) * sin(beta)  , (cos(c) - cos(b) * cos(a) )/ sin(a) );
				gamma=atan2(sin(c)*sin(beta),cos(c)*sin(a)-cos(a)*sin(c)*cos(beta));
				alpha=atan2(sin(a)*sin(beta),cos(a)*sin(c)-cos(c)*sin(a)*cos(beta));
		}} // ends the two elses
//            Notice b > 0. So don't have to worry about flipping gamma, alpha
		
		acaz  = abaz  + pi - alpha ; acaz  *= 1./piover;
		acphi = bcphi + pi - gamma ; acphi *= 1./piover;
		acalt = -b /piover;
if (acalt <0) {  acalt *= -1.; acaz += 180.; acphi += 180. ;}  // CHANGE ME!!!!!
acaz  += 720; while (acaz >= 360.) acaz  += -360.;
acphi += 720; while (acphi>= 360.) acphi += -360.;
ac->alt = acalt; ac->az = acaz; ac->phi = acphi;
	
//printf("%f	%f \n",cos(alpha),(-cos(a) +cos(c) * cos(b) )/(sin(c) * sin(b)));
//		gamma*=180./pi;	alpha*=180./pi;	beta*=180./pi;

/*
printf("acalt =	%2.2f	%2.2f	%2.2f	%2.2f	%2.2f \n ",acalt,tiltfunc(gamma,alpha,beta)/piover,alpha,beta,gamma);	
printf("bcalt =	%2.2f	%2.2f	 \n ",bcalt,tiltfunc(gamma,beta,alpha) /piover);	
printf("abalt =	%2.2f	%2.2f	 \n\n ",abalt,tiltfunc(beta,alpha,gamma)/piover);	
*/

//printf("acalt =%f  from eulermult \n ",acalt);

return;
}

/***********************************************************************************************************/
    
float eulermult11(euler *b0T, euler *a0) { //  find xhat dot 0b a0 dot xhat
float b0alt,b0az,b0phi,  a0alt,a0az,a0phi;
float answer, pi = 3.1415926;

// c->alt=a->alt*b->alt;
b0alt = -(b0T ->alt); b0az =-(b0T ->phi); b0phi = -(b0T->az);
a0alt = a0 ->alt    ; a0az = a0 ->az    ; a0phi = a0->phi;

a0alt *= pi/180.;  a0az *= pi/180.; a0phi *= pi/180.;
b0alt *= pi/180.;  b0az *= pi/180.; b0phi *= pi/180.; 

// This function takes the rotation                  The input is in degrees
// matrix a0 and multiplies it on the left
// by 0b. What we want is to find the 11 
// component of the resulting matrix. The answer is returned in degrees

answer = (cos(a0az)*cos(b0az) + sin(a0az)*sin(b0az)*cos(a0alt)*cos(b0alt) )*cos(a0phi-b0phi) ;
answer+= (cos(a0az)*sin(b0az)*cos(b0alt)  - sin(a0az)*cos(b0az)*cos(a0alt))*sin(a0phi-b0phi) ;
answer += sin(a0az)*sin(b0az)*sin(a0alt)*sin(b0alt);

return answer;
}


/****************************************************************/
    
float eulercomp11(euler *ab) { //  find  xhat dot Rab dot xhat
float abalt,abaz,abphi;
float answer, pi = 3.1415926;

abalt = ab ->alt; abaz = ab ->az; abphi = ab->phi;
abalt *= pi/180.;  abaz *= pi/180.; abphi *= pi/180.;
answer = cos(abphi) * cos(abaz) - sin(abphi) * cos(abalt) * sin(abaz);

return answer;
}


/****************************************************************/

// The following program multiplies two matrices together  
//     as in          m3 = m1*m2  Works!!!



void matmulmat(float *m1,float *m2,float *m3){
int i, j, k;

for (i=0; i <3; i++){
	for (j=0; j<3; j++){ m3[j+3*i]=0;
		for (k=0;k<3;k++){
			m3[j+3*i] += m1[k+3*i] * m2[j+3*k];
	
}}} // end k j i loops
return;
}

/*****************eulertomat converts eulers(degrees) to a matrix  ************************/
void eulertomat(euler *a,float *m){
float phia,alta,aza, pi=3.1415926;

phia  =a->phi  ; alta  =a->alt  ;  aza  = a->az   ;
phia *=pi/180. ; alta *=pi/180. ;  aza *= pi/180. ;

/*
float phimat[9],altmat[9],azmat[9], mtemp[9]; // seems to work
phimat[0] = cos(phia);  phimat[1] = sin(phia); phimat[2] = 0;
phimat[3] =-sin(phia);  phimat[4] = cos(phia); phimat[5] = 0;
phimat[6] = 0; 		phimat[7] = 0	     ; phimat[8] = 1;
altmat[0] = 1; altmat[1] = 0	     ; altmat[2] = 0;
altmat[3] = 0; altmat[4] = cos(alta) ; altmat[5] = sin(alta);
altmat[6] = 0; altmat[7] =-sin(alta) ; altmat[8] = cos(alta);
azmat[0] = cos(aza);  azmat[1] = sin(aza); azmat[2] = 0;
azmat[3] =-sin(aza);  azmat[4] = cos(aza); azmat[5] = 0;
azmat[6] = 0; 	      azmat[7] = 0       ; azmat[8] = 1;

matmulmat(phimat,altmat,m);
matmulmat(m,azmat,mtemp);*/


m[0]=  cos(phia) * cos(aza) - sin(phia) * cos(alta)*sin(aza);
m[1]=  cos(phia) * sin(aza) + sin(phia) * cos(alta)*cos(aza);
m[2]=  sin(phia) * sin(alta);
m[3]= -sin(phia) * cos(aza) - cos(phia) * cos(alta)*sin(aza);
m[4]= -sin(phia) * sin(aza) + cos(phia) * cos(alta)*cos(aza);
m[5]=  cos(phia) * sin(alta);
m[6]=  sin(alta) * sin(aza) ;
m[7]= -sin(alta) * cos(aza) ;
m[8]=  cos(alta);

return;
}

/*****************mattoeuler converts matrix to eulers (degees) ************************/
void mattoeuler(float *m, euler *a){
float phia,alta,aza,pi=3.1415926;

phia = a->phi; alta = a->alt;  aza = a->alt;

alta = 180.*acos( m[8]     )/pi;
phia = 180.*(atan2(m[2], m[5]))/pi + 360;
aza  = 180.*(atan2(m[6],-m[7]))/pi + 360;

// if (m[7]>0) aza  += 180.; 
// if (m[5]<0) phia += 180.;

while (aza >= 360) aza += -360. ;
while (phia >= 360) phia += -360. ;

a->alt = alta; a->az = aza; a->phi = phia;	

return;
}
