
// Boost Includes ==============================================================
#include <boost/python.hpp>
#include <boost/cstdint.hpp>

// Includes ====================================================================
#include <Quaternion.h>

// Using =======================================================================
using namespace boost::python;

// Module ======================================================================
void export_Quaternion()
{

    class_< Quaternion >("Quaternion", init<  >())
        .def(init< const Quaternion& >())
        .def(init< double, double, double, double >())
        .def(init< const Euler& >())
        .def(init< double, double, double >())
//        .def(init< float* >())
 //       .def(init< double* >())
        .def_readwrite("w", &Quaternion::w)
        .def_readwrite("x", &Quaternion::x)
        .def_readwrite("y", &Quaternion::y)
        .def_readwrite("z", &Quaternion::z)
//        .def_readwrite("m_f", &Quaternion::m_f)
//        .def_readwrite("m", &Quaternion::m)
        .def("setQuaternion", (void (Quaternion::*)(const Quaternion&) )&Quaternion::setQuaternion)
        .def("setQuaternion", (void (Quaternion::*)(double, double, double, double) )&Quaternion::setQuaternion)
        .def("setQuaternion", (void (Quaternion::*)(Euler&) )&Quaternion::setQuaternion)
        .def("setQuaternion", (void (Quaternion::*)(double, double, double) )&Quaternion::setQuaternion)
        //.def("setQuaternion", (void (Quaternion::*)(float*) )&Quaternion::setQuaternion)
        //.def("setQuaternion", (void (Quaternion::*)(double*) )&Quaternion::setQuaternion)
        .def("setQuaternionAngleAxis", &Quaternion::setQuaternionAngleAxis)
        .def("setQuaternionAxisUP", &Quaternion::setQuaternionAxisUP)
        .def("setQuaternionFlip", &Quaternion::setQuaternionFlip)
        .def("setQuaternionRotation", &Quaternion::setQuaternionRotation)
        .def("getAngle", &Quaternion::getAngle)
        .def("dotQuaternion", (double (Quaternion::*)(const Quaternion&) )&Quaternion::dotQuaternion)
        .def("multQuaternion", (void (Quaternion::*)(const Quaternion&) )&Quaternion::multQuaternion)
        .def("invMultQuaternion", (void (Quaternion::*)(const Quaternion&) )&Quaternion::invMultQuaternion)
        .def("dotQuaternion", (double (Quaternion::*)(double, double, double, double) )&Quaternion::dotQuaternion)
        .def("multQuaternion", (void (Quaternion::*)(double, double, double, double) )&Quaternion::multQuaternion)
        .def("invMultQuaternion", (void (Quaternion::*)(double, double, double, double) )&Quaternion::invMultQuaternion)
        //.def("matrixToQuaternion", &Quaternion::matrixToQuaternion)
        .def("calMatrix", &Quaternion::calMatrix)
        .def("getEuler", &Quaternion::getEuler)
        .def("getQuaternion", &Quaternion::getQuaternion)
        .def("getAngleAxis", &Quaternion::getAngleAxis)
        .def("getAngleAxisUp", &Quaternion::getAngleAxisUp)
        .def("GetXCoef", &Quaternion::GetXCoef)
        .def("GetYCoef", &Quaternion::GetYCoef)
        .def("GetZCoef", &Quaternion::GetZCoef)
        .def("GetNormal", &Quaternion::GetNormal)
        .def("MatrixTransform", &Quaternion::MatrixTransform)
        .def("InverseMatrixTransform", &Quaternion::InverseMatrixTransform)
        .def("Transform", &Quaternion::Transform)
        .def("InverseTransform", &Quaternion::InverseTransform)
        .def("genUniformQuaternion", &Quaternion::genUniformQuaternion)
        .def("genUniformQuaternionInARange", &Quaternion::genUniformQuaternionInARange)
        .def("slerp", &Quaternion::slerp)
        .def("threeFoldAxes", &Quaternion::threeFoldAxes)
        .def("generateIcosSymRotations", &Quaternion::generateIcosSymRotations)
        .def("getIcosSymRotations", &Quaternion::getIcosSymRotations)
        .def("generateIcosSymQuaternions", &Quaternion::generateIcosSymQuaternions)
        .def("isItInAsym", &Quaternion::isItInAsym)
        .def("getAsymQuaternion", &Quaternion::getAsymQuaternion)
        .def("convertToAsym", &Quaternion::convertToAsym)
#if 1
        .def( self + self )
        .def( self - self )
        .def( self * self )
        .def( self / self )
        .def( self ^ other< double >() )
        .def( ~self )
        .def( self += self )
        .def( self -= self )
        .def( self *= self )
        .def( self /= self )
        .def( self ^= other< double >() )
#endif
    ;
}
