
// Boost Includes ==============================================================
#include <boost/python.hpp>
#include <boost/cstdint.hpp>
#include <boost/python/class_fwd.hpp>

// Includes ====================================================================
#include "EMData.h"
#include "crossCommonLine.h"
// Using =======================================================================
using namespace boost::python;


// Module ======================================================================
void export_ccmlParm()
{

    class_< ccmlParm >("ccmlInputParm", init<  >())
        .def(init< const ccmlParm& >())
        .def_readwrite("searchMode", &ccmlParm::searchMode)
        .def_readwrite("scalingMode", &ccmlParm::scalingMode)
        .def_readwrite("residualMode", &ccmlParm::residualMode)
        .def_readwrite("weightMode", &ccmlParm::weightMode)
	.def_readwrite("refEulerConvention", &ccmlParm::refEulerConvention)
	.def_readwrite("sym", &ccmlParm::sym)
	.def_readwrite("rMask", &ccmlParm::rMask)
	.def_readwrite("rMask1", &ccmlParm::rMask1)

        .def_readwrite("rawImageFN", &ccmlParm::rawImageFN)	
        .def_readwrite("refImagesFN", &ccmlParm::refImagesFN)
        .def_readwrite("rawImagePhaseCorrected", &ccmlParm::rawImagePhaseCorrected)
        .def_readwrite("rawImageIniParmFN", &ccmlParm::rawImageIniParmFN)
        .def_readwrite("thisRawImageSN", &ccmlParm::thisRawImageSN)
        .def_readwrite("numOfRefImages", &ccmlParm::numOfRefImages)
        .def_readwrite("iniCx", &ccmlParm::iniCx)
        .def_readwrite("iniCy", &ccmlParm::iniCy)
        .def_readwrite("iniAlt", &ccmlParm::iniAlt)
        .def_readwrite("iniAz", &ccmlParm::iniAz)
        .def_readwrite("iniPhi", &ccmlParm::iniPhi)
        .def_readwrite("iniQw", &ccmlParm::iniQw)
        .def_readwrite("iniQx", &ccmlParm::iniQx)
        .def_readwrite("iniQy", &ccmlParm::iniQy)
        .def_readwrite("iniQz", &ccmlParm::iniQz)

        .def_readwrite("refCx", &ccmlParm::refCx)
        .def_readwrite("refCy", &ccmlParm::refCy)
        .def_readwrite("refAlt", &ccmlParm::refAlt)
        .def_readwrite("refAz", &ccmlParm::refAz)
        .def_readwrite("refPhi", &ccmlParm::refPhi)
        .def_readwrite("refQw", &ccmlParm::refQw)
        .def_readwrite("refQx", &ccmlParm::refQx)
        .def_readwrite("refQy", &ccmlParm::refQy)
        .def_readwrite("refQz", &ccmlParm::refQz)
	
        .def_readwrite("orientationSearchRange", &ccmlParm::orientationSearchRange)
        .def_readwrite("centerSearchRange", &ccmlParm::centerSearchRange)
        .def_readwrite("scateringFactor", &ccmlParm::scateringFactor)
        .def_readwrite("rawImage", &ccmlParm::rawImage)
        .def_readwrite("refImages", &ccmlParm::refImages)

        .def_readwrite("deltaR", &ccmlParm::deltaR)
        .def_readwrite("RMin", &ccmlParm::RMin)
        .def_readwrite("RMax", &ccmlParm::RMax)
        .def_readwrite("FFTOverSampleScale", &ccmlParm::FFTOverSampleScale)

        .def_readwrite("numOfStartConfigurations", &ccmlParm::numOfStartConfigurations)
        .def_readwrite("numOfRandomJump", &ccmlParm::numOfRandomJump)
        .def_readwrite("numOfFastShrink", &ccmlParm::numOfFastShrink)
        .def_readwrite("maxNumOfIteration", &ccmlParm::maxNumOfIteration)
        .def_readwrite("maxNumOfRun", &ccmlParm::maxNumOfRun)
        .def_readwrite("zScoreCriterion", &ccmlParm::zScoreCriterion)
        .def_readwrite("residualCriterion", &ccmlParm::residualCriterion)
        .def_readwrite("solutionCenterDiffCriterion", &ccmlParm::solutionCenterDiffCriterion)
        .def_readwrite("solutionOrientationDiffCriterion", &ccmlParm::solutionOrientationDiffCriterion)

	.def_readwrite("verbose", &ccmlParm::verbose)

	.def("setRefCenterAndOrientationFromRandom", &ccmlParm::setRefCenterAndOrientationFromRandom)
        .def("setRefCenterAndOrientationFromInput", (void (ccmlParm::*)(float, float, Quaternion&) )&ccmlParm::setRefCenterAndOrientationFromInput)
	.def("setRefCenterAndOrientationFromIniParmFile", &ccmlParm::setRefCenterAndOrientationFromIniParmFile)
 	.def("setRefCenterAndOrientationFromParticle", &ccmlParm::setRefCenterAndOrientationFromParticle)
	.def("setRefCenterAndOrientationFromInitializedParms", &ccmlParm::setRefCenterAndOrientationFromInitializedParms)

	.def("initializeCenterAndOrientationFromRandom", &ccmlParm::initializeCenterAndOrientationFromRandom)
        .def("initializeCenterAndOrientationFromInput", (void (ccmlParm::*)(float, float, Quaternion&) )&ccmlParm::initializeCenterAndOrientationFromInput)
	.def("initializeCenterAndOrientationFromIniParmFile", &ccmlParm::initializeCenterAndOrientationFromIniParmFile)
	.def("initializeCenterAndOrientationFromParticle", &ccmlParm::initializeCenterAndOrientationFromParticle)
	.def("initializeCenterAndOrientationFromSetRefParms", &ccmlParm::initializeCenterAndOrientationFromSetRefParms)
    ;



    class_< ccmlOutputParm >("ccmlOutputParm", init<  >())
        .def(init< const ccmlOutputParm& >())

        .def_readwrite("rawImageSN", &ccmlOutputParm::rawImageSN)

	.def_readwrite("cx", &ccmlOutputParm::cx)
        .def_readwrite("cy", &ccmlOutputParm::cy)
        .def_readwrite("alt", &ccmlOutputParm::alt)
        .def_readwrite("az", &ccmlOutputParm::az)
        .def_readwrite("phi", &ccmlOutputParm::phi)
        .def_readwrite("sym", &ccmlOutputParm::sym)
        .def_readwrite("qw", &ccmlOutputParm::qw)
        .def_readwrite("qx", &ccmlOutputParm::qx)
        .def_readwrite("qy", &ccmlOutputParm::qy)
        .def_readwrite("qz", &ccmlOutputParm::qz)
        .def_readwrite("q", &ccmlOutputParm::q)

        .def_readwrite("iniCx", &ccmlOutputParm::iniCx)
        .def_readwrite("iniCy", &ccmlOutputParm::iniCy)
        .def_readwrite("iniAlt", &ccmlOutputParm::iniAlt)
        .def_readwrite("iniAz", &ccmlOutputParm::iniAz)
        .def_readwrite("iniPhi", &ccmlOutputParm::iniPhi)
        .def_readwrite("iniQw", &ccmlOutputParm::iniQw)
        .def_readwrite("iniQx", &ccmlOutputParm::iniQx)
        .def_readwrite("iniQy", &ccmlOutputParm::iniQy)
        .def_readwrite("iniQz", &ccmlOutputParm::iniQz)
        .def_readwrite("iniQ", &ccmlOutputParm::iniQ)

        .def_readwrite("refCx", &ccmlOutputParm::refCx)
        .def_readwrite("refCy", &ccmlOutputParm::refCy)
        .def_readwrite("refAlt", &ccmlOutputParm::refAlt)
        .def_readwrite("refAz", &ccmlOutputParm::refAz)
        .def_readwrite("refPhi", &ccmlOutputParm::refPhi)
        .def_readwrite("refQw", &ccmlOutputParm::refQw)
        .def_readwrite("refQx", &ccmlOutputParm::refQx)
        .def_readwrite("refQy", &ccmlOutputParm::refQy)
        .def_readwrite("refQz", &ccmlOutputParm::refQz)
        .def_readwrite("refQ", &ccmlOutputParm::refQ)

        .def_readwrite("asymAlt", &ccmlOutputParm::asymAlt)
        .def_readwrite("asymAz", &ccmlOutputParm::asymAz)
        .def_readwrite("asymPhi", &ccmlOutputParm::asymPhi)
        .def_readwrite("asymQ", &ccmlOutputParm::asymQ)

        .def_readwrite("numOfRun", &ccmlOutputParm::numOfRun)
        .def_readwrite("residual", &ccmlOutputParm::residual)
        .def_readwrite("refResidual", &ccmlOutputParm::refResidual)
        .def_readwrite("zScore", &ccmlOutputParm::zScore)
        .def_readwrite("zScoreCriterion", &ccmlOutputParm::zScoreCriterion)
        .def_readwrite("sigma", &ccmlOutputParm::sigma)
        .def_readwrite("passAllCriteria", &ccmlOutputParm::passAllCriteria)

        .def_readwrite("centerDiff", &ccmlOutputParm::centerDiff)
        .def_readwrite("orientationDiff", &ccmlOutputParm::orientationDiff)
        .def_readwrite("maxAxisDiff", &ccmlOutputParm::maxAxisDiff)
        .def_readwrite("maxEulerAngleDiff", &ccmlOutputParm::maxEulerAngleDiff)

	.def_readwrite("totalIgnoredCommonLines", &ccmlOutputParm::totalIgnoredCommonLines)
	.def_readwrite("verbose", &ccmlOutputParm::verbose)

	.def("convertCalculatedOrientationToAsymmetricUnit", &ccmlOutputParm::convertCalculatedOrientationToAsymmetricUnit)
        .def("convertIniOrientationToAsymmetricUnit", &ccmlOutputParm::convertIniOrientationToAsymmetricUnit)
        .def("convertRefOrientationToAsymmetricUnit", &ccmlOutputParm::convertRefOrientationToAsymmetricUnit)

	.def("isItInAsym", (int (ccmlOutputParm::*)(float, float) )&ccmlOutputParm::isItInAsym)
	.def("convertToAsymmetricUnit", (int (ccmlOutputParm::*)(float, float, float) )&ccmlOutputParm::convertToAsymmetricUnit)

        .def("copyIniParm", (void (ccmlOutputParm::*)(ccmlParm*) )&ccmlOutputParm::copyIniParm)
        .def("copyRefParm", (void (ccmlOutputParm::*)(ccmlParm*) )&ccmlOutputParm::copyRefParm)
        .def("setRefCenterAndOrientation", (void (ccmlOutputParm::*)(float, float, Quaternion&) )&ccmlOutputParm::setRefCenterAndOrientation)
        .def("setCalculatedCenterAndOrientation", (void (ccmlOutputParm::*)(float, float, Quaternion&) )&ccmlOutputParm::setCalculatedCenterAndOrientation)

	.def("calculateDifferenceWithIniParm", &ccmlOutputParm::calculateDifferenceWithIniParm)
	.def("calculateDifferenceWithRefParm", &ccmlOutputParm::calculateDifferenceWithRefParm)
	.def("outputResult", (void (ccmlOutputParm::*)(char*) )&ccmlOutputParm::outputResult)

    ;

}


