#include "Image.h"
#include <qfile.h>
#include <qdragobject.h>
#include <qprinter.h>
#include <qmessagebox.h>
#include <sys/stat.h>
#include <ctime>
Image::Image(QWidget* parent,const char* name):QWidget( parent, name ) {
//initMetaObject();

resize(200,200);

qp=new QPainter();
qpm=new QPixmap(size());
// spinbox = new QSpinBox(0,200000);
// spinbox->show();
qpd=NULL;

datar=dcopy=data=NULL;
 slicea = 0; 

setBackgroundMode(NoBackground);

shapes.setAutoDelete(TRUE);
lscale=1.0;

mtstr="No Image";
imagefile =""; 

#ifdef WIN32
	setCursor(arrowCursor);
#else
	setCursor(crossCursor);
#endif

mode=0;
cont=.1;
brite=0;
needupd=1;
scale=0.0;
invert=0;
originx=originy=0;
showfft=0;
imc=NULL;
 
}

Image::~Image() {
if (imc) delete imc;
 if(slicea) delete slicea;
 // if(dcopy) delete dcopy;
delete qp;
delete qpm;
}

void Image::resizeEvent ( QResizeEvent *qe ) {
if (!datar) {
	qp->begin(this);
	qp->eraseRect(qp->window());
	qp->end();
	return;
}

qpm->resize(size().width(),size().height());
needupd=1;
emit(resized(size().width(),size().height()));
}

void Image::setScale(float sca) { scale=sca;lscale=scale;needupd=1; update(); emit(resized(size().width(),size().height())); }

void Image::paintEvent( QPaintEvent *pe ) {
char *d;
//float mm,b,me;
int i,sx,sy;
ImShape *cur;

if (datar && datar->xSize() && datar->ySize() && datar->zSize() && showfft && ! datar->isComplex() && (!data || !(data->isComplex()))) {
	if (datar->xSize()%2 || datar->ySize()%2) {
		EMData *cp=datar->clip(0,0,datar->xSize()&(~1),datar->ySize()&(~1));
		data=cp->doFFT();
		cp->gimmeFFT();
		delete cp;
	}
	else {
		data=datar->doFFT();
		datar->gimmeFFT();
	}
	data->ri2ap();
	data->setValueAt(0,data->ySize()/2,0,0);
	data->getData();
	data->doneData();
	emit imChanged(data);
}
else if (datar && datar->xSize() && datar->ySize() && datar->zSize() && showfft  && datar->isComplex() && (!data || data->isComplex())) {
	datar->ap2ri();
	data=datar->doIFT();
	datar->gimmeFFT();
	data->getData();
	data->doneData();
	emit imChanged(data);
}

if (datar && data && data!=datar &&(!showfft) && data->isComplex()) { delete data; data=datar; emit imChanged(data);}
else if (datar && data && data!=datar &&(!showfft) && datar->isComplex()) { delete data; data=datar; emit imChanged(data);}

if (!data) { data = datar; emit imChanged(data); }


//sz=width()<height()?width():height();
sx=qpm->width();
sy=qpm->height();
if (data && scale==0.0) {
	lscale=(float)sy/(data->ySize()-.5);
	originx=originy=0;
}
else lscale=scale; 

if (!data) {
	qp->begin(this);
	qp->fillRect(0,0,size().width(),size().height(),white);
	qp->setPen(black);
	qp->drawText(0,0,size().width(),size().height(),AlignCenter,mtstr.data());
	qp->end();
//	printf(" NULL\n");
	return;
}
else if (needupd||qpd) {
	if (data->zSize()==1) {

//		mm=-data->Min()<data->Max()?data->Max():-data->Min();
//		b=mm*brite;
//	    mm*=(1.0-sqrt(cont));

//		mm=(data->Max()-data->Min())/2.0;
//		me=(data->Max()+data->Min())/2.0;
//		b=mm*brite*2.0;
//		mm*=(1.0-sqrt(cont));

		// This is a rather bizzare little histogram-based algorithm
		// to try to improve the usability of the brightness/contrast settings
		// The mean grey-value will be the peak of the histogram by default
		// the contrast specifies the percentage of pixels that should have contrast

		// find peak of histogram
/*		float pk=0;		// peak value of histogram
		int pki=0;		// cell with peak value
		float sum=0;		// integral of histogram
		for (i=0; i<256; i++) {
			if (hist[i]>pk) { pk=hist[i]; pki=i; }
			sum+=hist[i];
		}

		float bi;
		if (brite>0) bi=pki-brite*pki;
		else bi=pki-brite*(255-pki);		// cell of middle of greyspace
		if (bi>255.0) bi=255.0;
		if (bi<0) bi=0;
		float b=data->Min()+bi/255.0*(data->Max()-data->Min());		// density value at middle of greyspace

		// now we try ot determine the width in the histogram that
		// satisfies our desired visability
		int bf=floor(bi+.5);	// adjusted center cell in histogram
		float goal=(1.0-cont*cont)*sum;		// number of pixels we want in the greyspace
		float lsum=hist[bf];
		int w;
		for (w=1; w<256; w++) {
			if (lsum>=goal) break;
			if (bf-w>=0) lsum+=hist[bf-w];
			if (bf+w<256) lsum+=hist[bf+w];
		}

		float didx=0.001;
		if (bf-w>=0) didx+=hist[bf-w];
		if (bf+w<256) didx+=hist[bf+w];
		float wf=(goal-lsum+didx)/didx+w-1.0;	//fractional width in # histogram bins
		wf*=(data->Max()-data->Min())/256.0;*/

		d=(char *)malloc(sx*sy+80);
		memset(d,127,sx*sy+80);

		sprintf(d,"P5\n%d %d\n255\n",sx,sy);
		i=strlen(d);

		float b,wf;
		float mm=(data->Max()-data->Mean())>(data->Mean()-data->Min())?(data->Max()-data->Mean()):(data->Mean()-data->Min());
		if (data->isComplex()) {
			b=data->Mean();
			if (brite>0) b-=brite*(data->Mean()-data->Min());
			else b-=brite*(data->Max()-data->Mean());

			wf=SQR(1.001-cont)*mm;
			data->renderAmp8((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx,
				lscale,invert?254:1,invert?1:254,b,b+wf*2.0);
		}
		else {
			b=data->Mean();
			if (brite>0) b-=brite*(data->Mean()-data->Min());
			else b-=brite*(data->Max()-data->Mean());

			wf=SQR(1.001-cont)*mm;
			data->renderAmp8((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx,
				lscale,invert?254:1,invert?1:254,b-wf,b+wf);
		}

		if (imc) imc->imageMinMax(b-wf,b+wf);
		qpm->loadFromData((uchar *)d,(uint)(i+sx*sy));

//pr->renderAmp8((unsigned char *)d+i,0,0,width(),height(),width(),
//	scale,1,254,-mm-b,mm-b);

/*QFile out("abc.pgm");
out.open(IO_WriteOnly);
out.writeBlock(d,(i+height()*width()));
out.close();*/

		free(d);
		needupd=0;
//printf("%d,%d  %d,%d\n",size().width(),size().height(),qpm->size().width(),qpm->size().height());
	}
	else if (dcopy) {
		EMData *pr;
		float mm,b,me;
		if (mode) {
			pr=dcopy->project3d(angle.alt(),angle.az(),angle.phi(),-1,(brite+1.0)*dcopy->Max()/2.0);
			mm=-pr->Min()<pr->Max()?pr->Max():-pr->Min();
//			b=mm*brite;
			mm*=(1.0-cont);
		} else {
			pr=dcopy->project3d(angle.alt(),angle.az(),angle.phi(),-2);
			mm=-pr->Min()<pr->Max()?pr->Max():-pr->Min();
			b=mm*brite;
			mm*=(1.0-cont);
		}

		d=(char *)malloc(sx*sy+80);
		memset(d,0,sx*sy+80);

		sprintf(d,"P5\n%d %d\n255\n",sx,sy);
		i=strlen(d);
		if (pr->isComplex()) pr->ri2ap();
		pr->renderAmp8((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx,
			lscale,invert?254:1,invert?1:254,-mm-b,mm-b);

		if (imc) imc->imageMinMax(-mm-b,mm-b);
		qpm->loadFromData((uchar *)d,(uint)(i+sx*sy));

		free(d);
		needupd=0;
	}
}

if (shapes.count()==0 && select.type==ImShape::NONE) bitBlt( this, 0,0, qpm );
else {
	QPixmap qpm2(*qpm);

	qp->begin(&qpm2);
//	bitBlt( this,pe->rect().topLeft(),qpm,pe->rect());
//	qp->begin(this);
	qp->setPen(red);

	shapes.append(&select);
	for (cur=shapes.first(); cur!=NULL; cur=shapes.next()) {
//printf("%d %d  %d %d\n",cur->x0,cur->y0,dxtopx(cur->x0),dytopy(cur->y0));

		qp->setPen(QPen(cur->color,cur->lw));
		if (cur->type==ImShape::FILL_CIRCLE) qp->setBrush(QBrush(cur->color,SolidPattern));
		switch(cur->type) {
		case ImShape::LINE:
			qp->drawLine(dxtopx(cur->x0),dytopy(cur->y0),dxtopx(cur->x1),dytopy(cur->y1));
			if (!cur->text.isEmpty()) {
				qp->setBackgroundMode(OpaqueMode);
				qp->setBackgroundColor(white);
				qp->setPen(black);
				if (cur->y1>cur->y0) qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)+12,cur->text);
				else qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)-5,cur->text);
				qp->setPen(red);
			}
			break;
		case ImShape::DOTBOX:
			qp->drawEllipse(dxtopx(cur->x0+cur->x1/2)-1,dytopy(cur->y0+cur->y1/2)-1,3,3);
		case ImShape::BOX:
			qp->drawRect(dxtopx(cur->x0),dytopy(cur->y0),cur->x1*lscale,-cur->y1*lscale);
			if (!cur->text.isEmpty()) {
				qp->setBackgroundMode(OpaqueMode);
				qp->setBackgroundColor(white);
				qp->setPen(black);
				qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)+12,cur->text);
			}
			break;
		case ImShape::HELIXBOX: {
			float x0=dxtopx(cur->x0);
			float y0=dytopy(cur->y0);
			float x1=dxtopx(cur->x1);
			float y1=dytopy(cur->y1);
			float x2=x1-x0;
			float y2=y1-y0;
			if (x2==0 && y2==0) break;
			float px= y2/hypot(x2,y2);
			float py=-x2/hypot(x2,y2);
			float r=cur->r*scale;
			qp->drawLine((int)(x0),(int)(y0),(int)(x1),(int)(y1));
			qp->drawLine((int)(x0+px*r),(int)(y0+py*r),(int)(x1+px*r),(int)(y1+py*r));
			qp->drawLine((int)(x0-px*r),(int)(y0-py*r),(int)(x1-px*r),(int)(y1-py*r));
			qp->drawLine((int)(x0+px*r),(int)(y0+py*r),(int)(x0-px*r),(int)(y0-py*r));
			qp->drawLine((int)(x1+px*r),(int)(y1+py*r),(int)(x1-px*r),(int)(y1-py*r));
			}
			break;
		case ImShape::CIRCLE:
		case ImShape::FILL_CIRCLE:
			qp->drawEllipse(dxtopx(cur->x0),dytopy(cur->y0),cur->x1*lscale,-cur->y1*lscale);
			break;
		//centered ellipse, x0 is major radius, y0 is minor radius, userf is angle in degrees
		case ImShape::CENELLIPSE:
			if (data) qp->translate(dxtopx(data->xSize()/2),dytopy(data->ySize()/2));
			else qp->translate(width()/2,height()/2);
			qp->rotate(-cur->userf);
			qp->drawEllipse(-cur->x0,-cur->y0,cur->x0*2,cur->y0*2);
			qp->resetXForm();
//			printf("cene %d %d %1.2f \n",cur->x0,cur->y0,cur->userf);
			break;
		case ImShape::TEXT:
			if (!cur->text.isEmpty()) qp->drawText(dxtopx(cur->x0),dytopy(cur->y0),cur->text);
			break;
		}
		if (cur->type==ImShape::FILL_CIRCLE) qp->setBrush(NoBrush);
	}
	shapes.last();
	shapes.take();
	qp->end();

//	bitBlt( this, 0,0, &qpm2 );
	bitBlt( this,pe->rect().topLeft(),&qpm2,pe->rect());
}

}

// This returns the original image pixel value displayed as 128/255
float Image::get128() {
float b=data->Mean();
if (brite>0) b-=brite*(data->Mean()-data->Min());
else b-=brite*(data->Max()-data->Mean());

return b;
}

float Image::pxtodx(int px) {
return ((px+originx-1)/lscale+.5);
}

float Image::pytody(int py) {
return ((height()-py+originy)/lscale)+.5;
}

int Image::dxtopx(int dx) {
return (int)(dx*lscale-originx-lscale/2+1);
}

int Image::dytopy(int dy) {
return (int)(-(dy*lscale-originy-height())+lscale/2);
}


void Image::print(QPaintDevice *dev) {
int x,y;

update();
}

void Image::setData(EMData *d) {
char s[140];

if (data && data!=datar) delete data;
datar=d;
data=NULL;
if (!d) { imageChanged(); return; }
if (d && datar->ufloat==0) datar->ufloat=datar->Max();

if (dcopy) { delete dcopy; dcopy=NULL; }
if (d && d->zSize()>1) dcopy=datar->copy();

strncpy(s,d->Path(),100);
s[100]=0;
strcat(s," (middle mouse for controls)");
setCaption(s);
qpm->resize(size().width(),size().height());
/*if (d->isComplex() && brite==0 && cont==0) {
	brite=.5;
	cont=.33;
}*/
imageChanged();
emit(resized(size().width(),size().height()));
}

void Image::mouseDoubleClickEvent(QMouseEvent *e) { };

void Image::mouseEnter(int) { };

void Image::mouseLeave(int) { };

void Image::keyPressEvent(QKeyEvent *e) { emit(keyPress(e)); }

void Image::keyReleaseEvent(QKeyEvent *) { };

void Image::mousePressEvent(QMouseEvent *e) {
if (!datar || !data) return;

int x=pxtodx(e->x());
int y=pytody(e->y());
if (data->isComplex()) { x+=1; y+=1; }

if ((e->button()&LeftButton)) {
	if ((e->state()&ShiftButton) && qpm) {
		
		QImageDrag *idr = new QImageDrag(qpm->convertToImage(),this);
		if (idr) idr->dragCopy();
		else printf("Drag error\n");
	}
	else {
		if (mode==4) {
		emit probe(NULL,-1,x-data->xSize()/2,y-data->ySize()/2,0,1);
		}
		else emit(mousePress(e));
	}
}
/*if ((e->button()&MidButton)) { 
	invert^=1; 
	if (imc) imc->setup(brite,cont,invert,-1); 
	needupd=1;
	update();
}*/
/*if ((e->button()&RightButton) && data && (e->state()&ShiftButton)) {
	mode^=1;
	needupd=1;
	update();
}
else*/
if ((e->button()&MidButton) || (e->button()&RightButton && e->state()&ControlButton)) {
	if ((e->state()&ShiftButton) && qpm) {
		mode^=1;
		needupd=1;
		update(); 
	}
	else {
		if (!imc) {	
			imc=new ImageMxCon; 
			connect(imc,SIGNAL(setBC(float,float)),SLOT(setBC(float,float)));
			connect(imc,SIGNAL(invToggle(int)),SLOT(setInvert(int)));
			connect(imc,SIGNAL(fftToggle(int)),SLOT(setFFT(int)));
			connect(imc,SIGNAL(saveImage()),SLOT(saveImage()));
			connect(imc,SIGNAL(setScale(float)),SLOT(setScale(float)));
			connect(imc,SIGNAL(print()),SLOT(doPrint()));
			connect(imc,SIGNAL(newMode(int)),SLOT(setMode(int)));
			connect(this,SIGNAL(imChanged(EMData *)),imc,SLOT(imageChanged(EMData *)));
			connect(this,SIGNAL(probe(unsigned char *,int,int,int,float,int)),imc,SLOT(doProbe(unsigned char *,int,int,int,float,int)));
			imc->setup(brite,cont,invert,-1,-1);
		}
		imc->show();
		imc->raise();
		if (data) emit imChanged(data);
		needupd=1;
		update();
	}
}

mdx=e->x();
mdy=e->y();

}

void Image::doPrint() {
QPrinter pr;
pr.setup();
QPainter pa(&pr);

pa.drawPixmap(0,0,*qpm);
pa.end();
}

void Image::saveImage() {
QString s1( QFileDialog::getSaveFileName(getenv("PWD"),"*.png") );
if ( s1.isNull() ) return;

qpm->save(s1.data(),"PNG");
}

void Image::setBC(float b,float c) { cont=c; brite=b; needupd=1; update();}

void Image::setInvert(int i) { invert=i; needupd=1; update(); }

void Image::setFFT(int i) { 
if (i && (datar->getFlags()&EMDATA_NEWFFT) && datar->xSize()*datar->ySize()>2000000 && 
	QMessageBox::warning(this,"BIG IMAGE",
	"This is a pretty large image\n\nAre you sure you want me to do a FFT?","Yes","No")) return;
if (i && (datar->getFlags()&EMDATA_NEWFFT) && ( ! datar->isComplex() && datar->xSize()!=datar->ySize() && 
	QMessageBox::warning(this,"NOT SQUARE",
	"This image isn't square\n\nAre you sure you want me to do a FFT?","Yes","No"))) return;
showfft=i; 
imageChanged();
}

void Image::notVisible() { if (imc) imc->hide(); }

void Image::mouseReleaseEvent(QMouseEvent *e) {
int *a,b;

int x=pxtodx(e->x());
int y=pytody(e->y());

//when no image loaded in ctfit, mouse click will crash ctfit, this is the fix
if(!data) return;

if (data->isComplex()) { x+=1; y+=1; }

if ((e->button()&LeftButton) && data) {
	if (!(e->state()&ShiftButton)) {
		if (mode==4) {
			emit probe(NULL,-1,x-data->xSize()/2,y-data->ySize()/2,0,-1);
		}
		else emit(mouseRelease(e));
	}
}

mdx=e->x();
mdy=e->y();

}

void Image::mouseMoveEvent(QMouseEvent *e) {
if (!datar || !data) return;

int x,y,sz,nx;
float *d,az,r,a=0,c=0,scale;

emit(mouseMoveAll(e));

x=e->x();
y=e->y();

if ((e->state()&LeftButton)) {
	if (!(e->state()&ShiftButton)) {
		if (mode==4) {
			unsigned char mx[49];
			float mm=(data->Max()-data->Mean())>(data->Mean()-data->Min())?(data->Max()-data->Mean()):(data->Mean()-data->Min());
			float b,wf;
			memset(mx,0,49);

			x=pxtodx(x);
			y=pytody(y);
//			data->renderAmp8(mx,x+originx/lscale-3,y+originy/lscale-3,7,7,7,1.0,invert?254:1,invert?1:254,me-mm-b,me+mm-b);
//			emit probe(mx,x+originx/lscale,y+originy/lscale,data->valueAt(x+originx/lscale,y+originy/lscale));
			if (data->isComplex()) {
				int x1 = x-data->xSize()/2+1;
				int y1 = y-data->ySize()/2+1;
				if (x1<0) { x1*=-1; y1*=-1; }
				x1*=2;
				y1+=data->ySize()/2;
				
				b=data->Mean();
				if (brite>0) b-=brite*(data->Mean()-data->Min());
				else b-=brite*(data->Max()-data->Mean());
				wf=SQR(1.001-cont)*mm;
				data->renderAmp8(mx,x-3,y-3,7,7,7,1.0,invert?254:1,invert?1:254,b,b+wf*2.0);
				
				emit probe(mx,-1,x-data->xSize()/2+1,y-data->ySize()/2+1,data->valueAtSafe(x1,y1),0);
			}
			else {
				b=data->Mean();
				if (brite>0) b-=brite*(data->Mean()-data->Min());
				else b-=brite*(data->Max()-data->Mean());
				wf=SQR(1.001-cont)*mm;
				data->renderAmp8(mx,x-3,y-3,7,7,7,1.0,invert?254:1,invert?1:254,b-wf,b+wf);
				
				emit probe(mx,-1,x-data->xSize()/2,y-data->ySize()/2,data->valueAtSafe(x,y),0);
			}
		}
		else emit(mouseMove(e));
	}
	return;
}
else if (e->state()&RightButton) {
	if (data->zSize()>1) {
		if (y-mdy==0 && x-mdx==0) return;
		angle.setAngle(angle.alt()-(y-mdy)/40.0,angle.az()-(x-mdx)/40.0,angle.phi());
		needupd=1;
		update();
		mdy=y;
		mdx=x;
		return;
	}
	else {
		setOrigin(originx-(x-mdx),originy+y-mdy);
		needupd=1;
		update();
		mdy=y;
		mdx=x;
	}
}
else {
}

}

void Image::hilight(int i) { 
	if (i<0 || i>=shapes.count()) { select.type=ImShape::NONE; return; }
	select.x0=(*shapes.at(i)).x0; 
	select.y0=(*shapes.at(i)).y0; 
	select.x1=(*shapes.at(i)).x1; 
	select.y1=(*shapes.at(i)).y1; 
	select.user=(*shapes.at(i)).user; 
	select.type=(*shapes.at(i)).type;
	select.color=green;
}

// This will reload the image from a file
// If it changed since the last reload
void Image::reload() {
struct stat st;
if (stat(datar->Path(),&st)) return;
if (st.st_mtime > datar->unum3) {
	datar->readImage(datar->Path(),datar->PathN());
	imageChanged();
	datar->unum3=std::time(NULL);
}

}

void Image::imageChanged() {
if (!datar) { update(); return; }
//datar->calcHist(hist,256,datar->Min(),datar->Max(),0);
needupd=1;
update();
}

int Image::addShape(ImShape *s,int n) {
if (n<0) {
	shapes.append(s);
	return shapes.count()-1;
}
shapes.insert(n,s);
return n;
}

void Image::delShape(int n) {
shapes.remove(n);
}

void Image::clearShapes() {
shapes.clear();
}

ImShape *Image::shapeAt(int n) {
if (n<0||n>=shapes.count()) return NULL;
return shapes.at(n);
}

void Image::setOrigin(int x,int y) {
if (!datar || !datar) return;

originx=x; 
originy=y; 
if (originx<0) originx=0;
if (originy<0) originy=0;
if (originx>data->xSize()*scale-width() && data->xSize()*scale-width()>0) 
	originx= data->xSize()*scale-width();
if (originy>data->ySize()*scale-height() && data->ySize()*scale-height()>0) 
	originy= data->ySize()*scale-height();
//printf("%d %d %d %d\n",originx,originy,width()-data->xSize(), height()-data->ySize());
needupd=1; 
update(); 
emit(moved(x,y));
}
void Image::changeslice(int val){
    
    //    EMData *a;
    // printf("this one was call\n");
    if(val<0) val = 0;
    if(slicea) delete slicea;
    slicea = new EMData;
    // printf("%s\n", imagefile.data());
    slicea->readImage(imagefile.data(),val);
    setData(slicea);
    // delete a;
    update();
    
}
