#include "QTextBrowser2.h"
#include <stdio.h>
#include <stdlib.h>
#include <qmessagebox.h>
#include <qlayout.h>
#include <qpushbutton.h>

QTextBrowser2::QTextBrowser2(QWidget *parent, const char *name):QWidget( parent, name ) {
QGridLayout *grid = new QGridLayout( this, 3,2 );

QPushButton *but=new QPushButton(this);
but->setText("Top");
connect(but,SIGNAL(pressed()),this,SLOT(gotoTop()));
grid->addWidget(but,0,0);
but->show();

but=new QPushButton(this);
but->setText("Back");
connect(but,SIGNAL(pressed()),this,SLOT(goBack()));
grid->addWidget(but,0,1);
but->show();

qle=new QLineEdit2(this);
connect(qle,SIGNAL(returnPressed()),this,SLOT(newAddr()));
connect(qle,SIGNAL(lostFocus()),this,SLOT(newAddr()));
grid->addWidget(qle,0,2);
qle->show();

browser=new MyQTextBrowser(this);
grid->addMultiCellWidget ( browser, 1,1,0,2) ;
browser->show();
connect(browser,SIGNAL(textChanged()),this,SLOT(bChanged()));

grid->setColStretch(0,0);
grid->setColStretch(1,0);
grid->setColStretch(2,10);
grid->setRowStretch(0,0);
grid->setRowStretch(1,10);

history.setAutoDelete(TRUE);

return;
}

QTextBrowser2::~QTextBrowser2() {
};

void QTextBrowser2::bChanged() {
if (home.isNull() || home.isEmpty()) home=browser->source();
qle->setText(browser->source());
}

void QTextBrowser2::setHome(QString str) { home=str; }

void QTextBrowser2::setSource(const QString& name) {

setLSource(name);
/*QString st;
if (name.find("http:")==0) st="netscape -remote 'openURL(";
else st="netscape -remote 'openfile(";
st+=name;
st+=",new-window)'";
if (system((const char *)st)) {
	QMessageBox::warning ( NULL, "Run Netscape", "The EMAN Reconstruction tutorial uses Netscape.\nPlease start netscape running, then click DONE on the form again.", 1,0,0 );
}*/

}

void QTextBrowser2::gotoTop() { setSource(home); }

void QTextBrowser2::goBack() { browser->backward(); }

void QTextBrowser2::newAddr() {
setSource(qle->text());
}

void QTextBrowser2::setLSource(const QString& name) {
browser->setSource(name);
browser->reload();
//if ((history.top()==NULL) || name!=*(history.top())) history.push(new QString(name));
}

void QTextBrowser2::keyReleaseEvent ( QKeyEvent *e ) {
switch (e->key()) {
case Key_Left:
	browser->backward();
	break;
case Key_Right:
	browser->forward();
	break;
}

}


void MyQTextBrowser::setSource( const QString & name )
{
    if (name.find("http://") >= 0) {
        QTextBrowser::setSource("nolink.html");
    }
    else {
        QTextBrowser::setSource(name);
    }
}

