// classesalign.C 8/99  Steve Ludtke

//N classesalign
//F This realigns class averages 
//1
//P <input>	Input classes file
//P <output>	Output
//U classesalign classes.1.hed aligned.hed
//D Pretty self explanatory.


#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

void test(EMData *d1,EMData *d2);

main(int argc, char *argv[]) {
EMData r,d,*da;
int n;

appinit(argc,argv);

if (argc<2) { printf("Usage: classesalign <input> <output>\n"); exit(0); }

n=fileCount(argv[1]);

for (int i=0; i<n; i+=2) {
	r.readImage(argv[1],i);
	d.readImage(argv[1],i+1);
//	da=d.RTFAlign(&r);

	test(&d,&r);

//	delete da;
} 

}

void test(EMData *d1,EMData *d2) {
EMData *r1,*r2;
float a,ba,bd,d,ba2,dam;

r1=d1->makeRFP()->copy();
r2=d2->makeRFP();
r1->normalize();
r2->normalize();
//r1->writeIMAGIC("test.hed",-1);
r2->writeIMAGIC("test.hed",-1);

dam=atan2(1.0,d1->xSize()/2.0)/2.0;

ba=0;
bd=-1.0e10;
for (a=0; a<PI; a+=PI/45.0) {
	r1->setTAlign(0,0,0);
	r1->setRAlign(a,0,0);
	r1->rotateAndTranslate();
	d=r1->dot(r2);
	if (d>bd) { bd=d; ba=a; putchar('*'); }
	printf("%1.1f\t%1.6g\n",a/PI*180.0,d);
r1->writeIMAGIC("test.hed",-1);
}

delete r1;
}
