#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

struct ANG { 
float a1[4];
float a2[4];
float l[4];
};

main(int argc, char *argv[]) {
int i,j,k,l,ji,ij,jj,n;
int ia, ib ,ic,id, iabest,ibbest,icbest,idbest;
int iref, index, indexstart,icount;
FILE *out;
List *data, *dlist;
EMData *d,*d2,*d3;
char s[80];
float f,mean, pi= 3.1415926;
float AB, BC, CA, AC, CB, BA;
float tiltxAB, tiltxBC, tiltxCA, *tiltx ;
float quality, qualitymax;
float *p;
ANG *ang;

if (argc<3) { printf("eulerccl\nUsage: eulerccl <input file><output file>\n"); exit(0); }

data=readImages(argv[1],0,-1);
n=data->count();
for (i=0; i<n; i++) ((EMData*)data->objectAt(i))->toCorner();

ang=(ANG *)calloc(n*n,sizeof(ANG));

for (i=0; i<n; i++) {
	for (j=i+1; j<n; j++) {
		d=(EMData*)data->objectAt(i);
		d2=(EMData*)data->objectAt(j);

		d3=new EMData;
		d3->commonLines(d,d2);

		p=d3->getData();
		ji=i+j*n;
		ij=j+i*n;
		
		ang[ij].a1[0]=ang[ji].a2[0]=ang[ij].a2[0]=ang[ji].a1[0]=-180.0;
		ang[ij].l[0]=ang[ji].l[0]=-1.0;
		
		for (l=jj=0; l<180; l++) {
			for (k=0; k<360; k++,jj++) {
				if (ang[ji].l[0] < p[jj]) { 
				
//  ang[ij].a1[0] is the angle of the common line
//     as it appears in the ith micrograph.
//
					ang[ij].a1[0]=ang[ji].a2[0]=k+.5-90.0;
					ang[ij].a2[0]=ang[ji].a1[0]=90.0-(l+.5);
					ang[ij].l[0]=ang[ji].l[0]=p[jj];
				} 
			}
		}
		d3->doneData();
		delete d3;


		printf(" %d,%d done\r",i,j);
		fflush(stdout);
	}
}

out=fopen(argv[2],"w");

for (i=0; i<n; i++) {
	for (j=0; j<n; j++) {
		printf("%f  ", ang[i+j*n].a1[0]);
	}
}


if (n*n*n*n>25000000) { 
	printf("WARNING: over 100M of memory used!\n");
	sleep(10); 
}
tiltx=(float *)malloc(n*n*n*n*sizeof(float));
printf("%d bytes allocated\n",n*n*n*n*4);


// ************  Here is Phil's section    *****************
// AB BC CA AC CB BA; tiltxAB, tiltxCA, tiltx[], index

  printf(" \n\n");


for (iref =0 ; iref < n ; iref++) {
for (i=iref+1 ; i < n-1  ; i++) {
   for (j=i+1 ; j < n  ;  j++) {
      BC =  pi*((float)(ang[j + i *n].a1[0]))/180.;
      CB =  pi*((float)(ang[i + j *n].a1[0]))/180.;
      BA =  pi*((float)(ang[iref + i *n].a1[0]))/180.;
      AB =  pi*((float)(ang[i + iref *n].a1[0]))/180.;
      AC =  pi*((float)(ang[j + iref *n].a1[0]))/180.;
      CA =  pi*((float)(ang[iref + j *n].a1[0]))/180.;

    printf(" %f %f %f %f %f %f \n ", 180*AB/pi,180*AC/pi,180*CB/pi,180*CA/pi,180*BA/pi,180*BC/pi); 
    
    
//    printf(" %f %f  \n ", (CB-CA), (BA-BC+AC-AB)); 


//
//           Recall  A is iref ; B is i ; C is j ;  iref < i < j
//
//     There are N-2 readings for each tilt,  
//        Fill in first non-zero one
 
 
//      The following is iref i
       tiltxAB =  (cos(BA-BC) * cos(AC-AB) - cos(CB-CA))
                              /(sin(BA-BC) * sin(AC-AB) );
//	tiltxAB = sqrt(tiltxAB*tiltxAB);
        if (tiltxAB*tiltxAB < 1) { tiltxAB = acos(tiltxAB) ;}
              else { tiltxAB =  100000.*pi/180 ;}

// Now comes iref j
       tiltxCA  = (cos(AC-AB) * cos(CB-CA) - cos(BA-BC))
                         /(sin(AC-AB) * sin(CB-CA) );
//	tiltxCA = sqrt(tiltxCA*tiltxCA);
        if (tiltxCA*tiltxCA < 1) { tiltxCA = acos(tiltxCA) ;}
                else  { tiltxCA =  100000*pi/180. ;}
		
// Now comes i j
       tiltxBC  = (cos(CB-CA) * cos(BA-BC) - cos(AC-AB))
                         /(sin(CB-CA) * sin(BA-BC) );
//	tiltxBC = sqrt(tiltxBC*tiltxBC);
        if (tiltxBC*tiltxBC < 1) { tiltxBC = acos(tiltxBC) ;}
                else  { tiltxBC =  100000*pi/180. ;}

//    if (tiltxAB + tiltxCA + tiltxBC < 30) {
    indexstart = (n-2)*(-iref*(iref+1)/2 + (n-1)*iref + i  -1);
  for (index= indexstart; index < indexstart + n-2; index++) { 
     if (tiltx[index] == 0) { printf(" %f ", 180.*tiltxAB/pi); 
           tiltx[index] = tiltxAB ; index += n-2; }
	   } // ends for loop

    indexstart = (n-2)*(-iref*(iref+1)/2 + (n-1)*iref + j  -1);
  for (index= indexstart; index < indexstart + n-2; index++) { 
     if (tiltx[index] == 0) { printf(" %f ", 180.*tiltxCA/pi); 
           tiltx[index] = tiltxCA ; index += n-2; }}

      indexstart = (n-2)*(-i*(i+1)/2 + (n-1)*i + j  -1);
  for (index= indexstart; index < indexstart + n-2 ; index++) { 
     if (tiltx[index] == 0) { printf(" %f \n", 180.*tiltxBC/pi); 
            tiltx[index] = tiltxBC ; index += n-2; }}
// }  // ends if statement 

}}}   // ends i , j , and iref loops

printf(" \n\n"); 

// ****************  Find the best 4 ****************************//
//   ia,ib,ic, id, iabest, (3 more), quality, qualitymax

quality = -5;

 for (ia=0 ; ia < n-3; ia++){       for (ib=ia+1 ; ib < n-2; ib++){
       for (ic=ib+1 ; ic < n-1; ic++){       for (id=ic+1 ; id < n; id++){

	
      indexstart  = (n-2)*(-ia*(ia+1)/2 + (n-1)*ia + ib  -1);
       quality  = cos(tiltx[indexstart + ic-2] 
                        -  tiltx[indexstart + id-2]); 
	if (tiltx[indexstart+ic-2] +tiltx[indexstart+id-2] > 20) quality += -20;
           
       indexstart  = (n-2)*(-ia*(ia+1)/2 + (n-1)*ia + ic  -1);
       quality += cos(tiltx[indexstart + ib-1] 
	                        -  tiltx[indexstart + id-2]); 
        if (tiltx[indexstart+ib-1] +tiltx[indexstart+id-2] > 20) quality += -20;
	
       indexstart  = (n-2)*(-ia*(ia+1)/2 + (n-1)*ia + id  -1);
       quality += cos(tiltx[indexstart + ib-1] 
                        -  tiltx[indexstart + ic-1]); 
     	if (tiltx[indexstart+ib-1] +tiltx[indexstart+ic-1] > 20) quality += -20;
	
       indexstart  = (n-2)*(-ib*(ib+1)/2 + (n-1)*ib + ic  -1);
       quality += cos(tiltx[indexstart + ia] 
                        -  tiltx[indexstart + id-2]); 
  	if (tiltx[indexstart+ia] +tiltx[indexstart+id-2] > 20) quality += -20;
	
       indexstart  = (n-2)*(-ib*(ib+1)/2 + (n-1)*ib + id  -1);
       quality += cos(tiltx[indexstart + ia] 
                        -  tiltx[indexstart + ic-1]); 
	if (tiltx[indexstart+ia] +tiltx[indexstart+ic-1] > 20) quality += -20;
	    
       indexstart  = (n-2)*(-ic*(ic+1)/2 + (n-1)*ic + id  -1);
       quality += cos(tiltx[indexstart + ia] 
                        -  tiltx[indexstart + ib]); 
	if (tiltx[indexstart+ia] +tiltx[indexstart+ib] > 20) quality += -20;
				
// 	printf("got to here , quality = %f \n ", quality); 
				
	if (quality > qualitymax) { 
		iabest=ia; 
		ibbest =ib;   
		icbest =ic; 
		idbest = id;
		qualitymax= quality;} 
				
			
}}}} // end id, ic , ib ,ia


//************* Note in the following that one can tell exactly how far down
//            the list a certain value appeared


	printf("The best 4 pics %d %d %d %d  \n\n", iabest+1, ibbest+1, icbest+1, idbest+1);
	
       indexstart  = (n-2)*(-iabest*(iabest+1)/2 + (n-1)*iabest + ibbest  -1);
       printf("%f    %f  \n", 180.*tiltx[indexstart + icbest-2] /pi ,
                         180.*tiltx[indexstart + idbest-2] /pi); 
             
       indexstart  = (n-2)*(-iabest*(iabest+1)/2 + (n-1)*iabest + icbest  -1);
       printf("%f    %f  \n",180.*tiltx[indexstart + ibbest-1]  /pi,
                          180.*tiltx[indexstart + idbest-2] /pi); 
       
       indexstart  = (n-2)*(-iabest*(iabest+1)/2 + (n-1)*iabest + idbest  -1);
       printf("%f    %f  \n",180.*tiltx[indexstart + ibbest-1] /pi, 
                          180.*tiltx[indexstart + icbest-1] /pi); 
       
       indexstart  = (n-2)*(-ibbest*(ibbest+1)/2 + (n-1)*ibbest + icbest  -1);
       printf("%f    %f  \n",180.*tiltx[indexstart + iabest] /pi ,
                          180.*tiltx[indexstart + idbest-2] /pi); 
       
       indexstart  = (n-2)*(-ibbest*(ibbest+1)/2 + (n-1)*ibbest + idbest  -1);
       printf("%f    %f  \n",180.*tiltx[indexstart + iabest] /pi ,
                          180.*tiltx[indexstart + icbest-1] /pi); 
       
       indexstart  = (n-2)*(-icbest*(icbest+1)/2 + (n-1)*icbest + idbest  -1);
       printf("%f    %f  \n",180.*tiltx[indexstart + iabest] /pi ,
                          180.*tiltx[indexstart + ibbest] /pi); 
			
// ****************  Just found the best 4 ****************************//       
       
//  *********************   Reshuffle the pictures        *******************
   	icount = 0;
	unlink ("shuffle.img");
	unlink ("shuffle.hed");
	dlist = new List;
	dlist=readImages(argv[1],0,-1);
	
	 for (index = 0; index < n ; index++) {
        	 if (index == iabest && icount == 0) { 
			 icount += 1; 
			 d=(EMData *)dlist->objectAt(index);
			 d -> writeIMAGIC("shuffle.img",-1); 
			 index = -1;}
	         if (index == ibbest && icount == 1) { 
			 icount += 1; 
			 d=(EMData *)dlist->objectAt(index);
			 d -> writeIMAGIC("shuffle.img",-1); 
			 index = -1;}
	         if (index == icbest && icount == 2) { 
			 icount += 1; 
			 d=(EMData *)dlist->objectAt(index);
			 d -> writeIMAGIC("shuffle.img",-1); 
			 index = -1;}
	         if (index == idbest && icount == 3) { 
			 icount += 1; 
			 d=(EMData *)dlist->objectAt(index);
			 d -> writeIMAGIC("shuffle.img",-1); 
			 index = -1;}
         if ( (icount > 3) && (index > -1) ) { 
	      if(  (index != iabest) && (index != ibbest)) { 
	      if(  (index != icbest) && (index != idbest) ) {
	      		  	icount += 1;  
			 d=(EMData *)dlist->objectAt(index);
			 d -> writeIMAGIC("shuffle.img",-1); }}} // ends three if statements
			 
			 delete d; // printf("%d \n",index);
		 
}  // ends for loop


// **********************        Print out results

 for (i=indexstart=0; i < n; i++) {   
	for (j=i+1; j < n ; indexstart++, j++) {
	printf("%d %d \n\n",i+1, j+1);
   for ( index = indexstart*(n-2) ; index < (indexstart+1)*(n-2); index++) { 
 if ( tiltx[index] != 0)	
   printf("%f %f %f\n", 180.*tiltx[index]/pi, ang[j+n*i].a1[0],  ang[i+n*j].a1[0] );
}   // ends jq loop 
   printf(" \n\n\n");
   }}   // ends j,i loops 



// ************  End Phil's section    *****************

}
