#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

inline float SQR(float x) { return x*x; }

main(int argc, char *argv[]) {
int i,j,k,l;
EMData *d,*d2,*d3;
float *dat,r;

d=new EMData;			// new empty data object
d->setSize(64,64,64);	// this allocates memory for a 64^3 image

dat=d->getData();		// 'checks out' the raw data (array of floats)

// generate a 3d gaussian with 1/2 width 6.0 at the center of the image
l=0;
for (i=0; i<64; i++) {
	for (j=0; j<64; j++) {
		for (k=0; k<64; k++) {
			r=sqrt(SQR(j-31.5)+SQR(k-31.5)+SQR(l-31.5));
			dat[l]=exp(-r*r/36.0);
			l++;
		}
	}
}
d->doneData();			// 'check in' the raw data when we're done
d->update();			// update the statistics on the image

d2=d->doFFT();
if (!d2) { printf("FFT unsucessful\n"); exit(1); }
d3=d2->doIFT();

// ideally d3 should now be a copy of d1
// compare them
d->subtract(d3);

dat=d->getData();
r=0;
for (i=0; i<64*64*64; i++) r+=dat[i];
r/=64.0*64.0*64.0;
printf("Mean difference = %f\n",r);
d->doneData();
}
