#include "InspPlot.h"
#include "InspPlotGen.h"
#include "InspPlotDset.h"
#include "LSPlotInsp.h"
//#include <qwidgetstack.h>
#include "qtabwidget.h"
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qlabel.h>
#define Inherited inspPlotBase

InspPlot::InspPlot(QWidget* parent,const char* name):Inherited( parent, name )
{
    InspPlotGen *i0;
    InspPlotDset *i2;
    LSPlotInsp *i1;

    insp[0]=i0=new InspPlotGen();
    insp[2]=i2=new InspPlotDset();
    insp[1]=i1=new LSPlotInsp();
    tabs2->addTab(i0,"InspPlotGen");
    tabs2->addTab(i1,"LSPlot");
    tabs2->addTab(i2,"InspPlotDset");
//stack->addWidget(i0,0);
//stack->addWidget(i1,1);
//stack->addWidget(i2,2);

    ci=0;
    target2=NULL;

//stack->setFrameStyle( QFrame::Panel | QFrame::Sunken );
}


InspPlot::~InspPlot()
{
    for (int i=0; i<3; i++) delete insp[i];
}

void InspPlot::refresh()
{
    // printf("inspPlot was called \n");
    DataSet *ds;
	int i = 0;

    for (i=0; i<target->nPlots(); i++)
    {
	ds=target->plotAt(i)->getData();
	if (plotlist->text(i)!=ds->title) break;
    }
    if (i<target->nPlots()) {
    	plotlist->clear();
    	for (int j=0; j<target->nPlots(); j++)
    	{
		ds=target->plotAt(j)->getData();
		plotlist->insertItem(ds->title);
    	}
    }
    else {
	int ci=tabs2->currentPageIndex();
        insp[ci]->refresh();
    }

    

}

void InspPlot::newPlotTab() {
    
if (!target) return;
// printf("newPlotTab was called \n");	
//if (n<0 || n>2) return;
ci=tabs2->currentPageIndex();

insp[ci]->setTarget(target2);

//stack->raiseWidget(n);
}

void InspPlot::newLegend(bool b) { 
	if (!target) return;
	if (b) target->setFlags(D2_OPT_LEGEND);
	else target->resetFlags(D2_OPT_LEGEND);
	target->update();
}

void InspPlot::newPlotList(int v) {
    //        printf("newPlotList was called \n");
	if (!target) return; 
	plotname->setText(plotlist->text(v));
	target2=target->plotAt(v);
	ci = tabs2->currentPageIndex();
	insp[ci]->setTarget(target2);
	//	if(ci == 2)//this is data display
	//	{
	    // DataSet *ds=target2->getData();
	//	    insp[ci]->refresh();
	//	}
}

void InspPlot::newPlotName() {
    //         printf("newPlotName was called \n");
	if (!target) return;
	int n=plotlist->currentItem();
	plotlist->changeItem(plotname->text(),n);
	DataSet *ds=target->plotAt(n)->getData();
	ds->title=plotname->text();
}
//ListBox* InspPlot::getlistbox()
//{
//  return plotlist;
//}
