#include "LSPlotInsp.h"
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qcolordialog.h>
#define Inherited lsPlotInspBase

LSPlotInsp::LSPlotInsp(QWidget* parent,const char* name):Inherited( parent, name ) {

}

LSPlotInsp::~LSPlotInsp()
{
}

void LSPlotInsp::refresh()
{
    LSPlot *tar=(LSPlot *)target;
    if (!tar) return;
    QArray<int> col=tar->getCols();
    //    printf("LSPPlot:refresh \n");
    xcol->setText(QString::number(col[0]));
    ycol->setText(QString::number(col[1]));
    vxcol->setText(QString::number(col[2]));
    vycol->setText(QString::number(col[3]));
    c1col->setText(QString::number(col[4]));
    c2col->setText(QString::number(col[5]));
    c3col->setText(QString::number(col[6]));
    symtog->setOn(tar->getFlags()&LS_SYM);
    linetog->setOn(tar->getFlags()&LS_LINE);
    symsel->setCurrentItem(tar->getSym());
    lwsel->setCurrentItem(tar->getLW());
    linesel->setCurrentItem(tar->getLS());
    drawcol->setPalette(tar->getColor());

    if (tar->getFlags()&LS_RGB) colsel->setCurrentItem(2);
    else if (tar->getFlags()&LS_HSV) colsel->setCurrentItem(1);
    else colsel->setCurrentItem(0);

    if (tar->getFlags()&LS_VECXY) vecsel->setCurrentItem(4);
    else if (tar->getFlags()&LS_VECRT) vecsel->setCurrentItem(5);
    else if ((tar->getFlags()&LS_XERROR)&&((tar->getFlags()&LS_YERROR))) vecsel->setCurrentItem(3);
    else if (tar->getFlags()&LS_XERROR) vecsel->setCurrentItem(1);
    else if (tar->getFlags()&LS_YERROR) vecsel->setCurrentItem(2);
    else vecsel->setCurrentItem(0);
}


void LSPlotInsp::setLS(int l)
{
    //    printf("call setLS: %d\n",l);
    
    LSPlot *tar=(LSPlot *)target;
    tar->setLine(l,-1);
    tar->dataChanged();
    //   target->update();
    
}

void LSPlotInsp::setLW(int l)
{
    //    printf("call setLW: %d\n",l);
    LSPlot *tar=(LSPlot *)target;
    tar->setLine(-1,l);
    tar->dataChanged(); 
    //    target->update();
    
}

void LSPlotInsp::setSym(int s)
{
    //    printf("call setSym: %d\n",s) ;
    LSPlot *tar=(LSPlot *)target;
    tar->setSym(s,-1);
    tar->dataChanged();
    //    target->update();
}

void LSPlotInsp::setSSz(int s)
{
    //    printf("call setSSz: %d\n",s);
    LSPlot *tar=(LSPlot *)target;
    tar->setSym(-1,s);
    tar->dataChanged();
    //     target->update();
}

void LSPlotInsp::setVec(int s)
{
    //  printf("call setVec, %d\n",s);
    LSPlot *tar=(LSPlot *)target;
    int f=tar->getFlags();

    switch (s) {
    case 0:
	tar->setFlags(f&(~LS_VECERR)); break;
    case 1:
	tar->setFlags((f&(~LS_VECERR))|LS_XERROR); break;
    case 2:
	tar->setFlags((f&(~LS_VECERR))|LS_YERROR); break;
    case 3:
	tar->setFlags((f&(~LS_VECERR))|LS_XERROR|LS_YERROR); break;
    case 4:
	tar->setFlags((f&(~LS_VECERR))|LS_VECXY); break;
    case 5:
	tar->setFlags((f&(~LS_VECERR))|LS_VECRT); break;
    }
    tar->dataChanged();
    //     target->update();

}

void LSPlotInsp::lineTog(bool b)
{
    //    printf("call lineTog\n");
    LSPlot *tar=(LSPlot *)target;
    int f=tar->getFlags();

    if (b) tar->setFlags(f|LS_LINE);
    else tar->setFlags(f&~LS_LINE);
    tar->dataChanged();
    //  target->update();
}

void LSPlotInsp::symTog(bool b)
{
    //    printf("call symTog\n");
    LSPlot *tar=(LSPlot *)target;
    int f=tar->getFlags();
    if (b) tar->setFlags(f|LS_SYM);
    else tar->setFlags(f&~LS_SYM);
    tar->dataChanged();
    // target->update();
}

void LSPlotInsp::setCol()
{
    //    printf("call setCol\n");
    LSPlot *tar=(LSPlot *)target;
    tar->setCols(xcol->text().toInt(),ycol->text().toInt(),
	vxcol->text().toInt(),vycol->text().toInt(),
	c1col->text().toInt(),c2col->text().toInt(),c3col->text().toInt());
    // target->update();
    tar->dataChanged();
}


void LSPlotInsp::setCMode(int m)
{
    //        printf("call setCMode: %d\n",m);
    LSPlot *tar=(LSPlot *)target;
    int f=tar->getFlags()&~LS_COLOR;

    switch (m) {
    case 0: tar->setFlags(f); break;
    case 1: tar->setFlags(f|LS_HSV); break;	
    case 2: tar->setFlags(f|LS_RGB); break;
   	
    }
    tar->dataChanged();
    // target->update();

}
void LSPlotInsp::colEnable()
{
    int item;
    LSPlot *tar=(LSPlot *)target;
    item = colsel->currentItem();
    if(item ==0)
    {
	 c1col->setDisabled(TRUE);
	 c2col->setDisabled(TRUE);
	 c3col->setDisabled(TRUE);
	 //	 drawcol->setEnabled(TRUE);
    }
    else if((item == 1) || (item == 2))
    {
	 c1col->setEnabled(TRUE);
	 c2col->setEnabled(TRUE);
	 c3col->setEnabled(TRUE);
	 //	 drawcol->setDisabled(TRUE);
    }
     tar->dataChanged();
	
    
}
//void LSPlotInsp::setConstCol(int x)
//{
//   printf("this was call in setConstCol, x: %d \n", x);
//    LSPlot *tar=(LSPlot *)target;
    
//    switch(x){
//    case 0: tar->setColor((QColor *)&black); break;
//    case 1: tar->setColor((QColor *)&red); break;
//    case 2: tar->setColor((QColor *)&darkRed); break;
//    case 3: tar->setColor((QColor *)&green); break;
//    case 4: tar->setColor((QColor *)&darkGreen); break;
//    case 5: tar->setColor((QColor *)&blue); break;
//    case 6: tar->setColor((QColor *)&darkBlue); break;
//    case 7: tar->setColor((QColor *)&cyan); break;
//    case 8: tar->setColor((QColor *)&darkCyan); break;
//    case 9: tar->setColor((QColor *)&magenta); break;
//    case 10: tar->setColor((QColor *)&darkMagenta); break;
//    case 11: tar->setColor((QColor *)&yellow); break;
//    case 12: tar->setColor((QColor *)&darkYellow); break;
//    case 13: tar->setColor((QColor *)&gray); break;
//    case 14: tar->setColor((QColor *)&darkGray); break;
//    case 15: tar->setColor((QColor *)&lightGray); break;
//    }
    //    tar->setColor();
//    tar->dataChanged();
//}
void LSPlotInsp::newConstColor( )
{
    LSPlot *tar=(LSPlot *)target;
    QColor nc;
    nc=QColorDialog::getColor ( tar->getColor());
    drawcol->setPalette(QPalette(nc));
    tar->setColor((QColor *) &nc);
    tar->dataChanged();
} 
    

