#include "Panner.h"
#include "qpainter.h"
#include <math.h>
#include "qdrawutil.h"
#include <math.h>

Panner::Panner( QWidget *parent, const char *name ): QWidget( parent, name ) {
//initMetaObject();                           // initialize meta object
setBackgroundMode(NoBackground);
busy=0;
}

Panner::~Panner() {

}

void Panner::validate() {
if (X[3]>X[1]) X[3]=X[1];
if (X[3]<X[0]) X[3]=X[0];
if (Y[3]>Y[1]) Y[3]=Y[1];
if (Y[3]<Y[0]) Y[3]=Y[0];
if (X[2]>1.0) X[2]=1.0;
if (Y[2]>1.0) Y[2]=1.0;
if (X[1]<=X[0]) X[1]=X[0]+fabs(X[0])*.01+.00001;
if (Y[1]<=Y[0]) Y[1]=Y[0]+fabs(Y[0])*.01+.00001;
}

void Panner::mousePressEvent ( QMouseEvent *me ) {
int w=width()-4;
int h=height()-4;
int x=me->x()-w*X[2]/2.0-2;
int y=(h-me->y())-h*Y[2]/2.0-2;

pressed=1;

X[3]=x/(w*(1.0-X[2]))*(X[1]-X[0])+X[0];

Y[3]=y/(h*(1.0-Y[2]))*(Y[1]-Y[0])+Y[0];
validate();
if (!busy) {
	busy=1;
	emit(newValue(X[3],Y[3]));
	busy=0;
}
update();
}

void Panner::mouseMoveEvent ( QMouseEvent *me ) {
if (pressed) mousePressEvent(me);
}

void Panner::mouseReleaseEvent ( QMouseEvent *me ) {
pressed=0;
}

void Panner::paintEvent ( QPaintEvent * pe ) {
QPainter qp;
int w=width()-4;
int h=height()-4;
QBrush b(backgroundColor());

validate();

qp.begin(this);
qDrawShadePanel(&qp, 0,0,width(),height(), colorGroup(), TRUE, 2, &b);
qDrawShadePanel(&qp,2+w*(1.0-X[2])*(X[3]-X[0])/(X[1]-X[0]),
			2+h-(h*(1.0-Y[2])*(Y[3]-Y[0])/(Y[1]-Y[0]))-h*Y[2],
			w*X[2],h*Y[2],colorGroup(),FALSE,2,NULL);

qp.end();
}

void Panner::setHandleSize(float x,float y) {
X[2]=x;
Y[2]=y;
update();
}


void Panner::setXRange(float min,float max) {
X[0]=min;
X[1]=max;
update();
}


void Panner::setYRange(float min,float max) {
Y[0]=min;
Y[1]=max;
update();
}


void Panner::setValue(float x, float y) {
X[3]=x;
Y[3]=y;
validate();
if (!busy) {
	busy=1;
	emit(newValue(x,y));
	busy=0;
}
update();
}


void Panner::setXValue(float x) {
X[3]=x;
validate();
if (!busy) {
	busy=1;
	emit(newValue(x,Y[3]));
	busy=0;
}
update();
}


void Panner::setYValue(float y) {
Y[3]=y;
validate();
if (!busy) {
	busy=1;
	emit(newValue(X[3],y));
	busy=0;
}
update();
}
