#include <stdio.h>
#include <stdlib.h>
#include "Plot.h"

//#define DEBUG

Plot::Plot()
{
//initMetaObject();                           // initialize meta object
data=NULL;
cols.resize(7);
cols[0]=0;
cols[1]=1;
cols[2]=2;
cols[3]=3;
cols[4]=1;
cols[5]=1;
cols[6]=1;
Label=(char *)malloc(1);
Label[0]=0;
lfont=new QFont("times",12);
lmet=new QFontMetrics(*lfont);
}

Plot::~Plot()
{
delete lfont;
delete lmet;
}

void Plot::dataChanged() { 
#ifdef DEBUG2
printf("Plot %p: data change\n",this);
#endif
emit changed(); 
}

void Plot::setData(DataSet *dat) {
if (data) QObject::disconnect(data);
data=dat;
QObject::connect(data,SIGNAL(changed()),this,SLOT(dataChanged()));
}

void Plot::setCols(int *c,int n) {
int i;

cols.assign(c,n);
}

void Plot::setCols(int c1,int c2,int c3,int c4,int c5,int c6,int c7) {
cols.resize(7);
cols[0]=c1;
cols[1]=c2;
cols[2]=c3;
cols[3]=c4;
cols[4]=c5;
cols[5]=c6;
cols[6]=c7;
}

void Plot::display(QPainter *qp,Axes2d *axis,int x0,int y0,int x1,int y1) {
printf("Plot display. Probably an error.\n");
return;
}

int Plot::legend(QPainter *qp,Axes2d *axis,int x,int y) {
return 0;
}


fRect Plot::getLimits() {
fRect ret;

if (!data || cols.size()<2) return ret;

ret.setx0(data->getColumn(cols[0])->getMin());
ret.setx1(data->getColumn(cols[0])->getMax());
ret.sety0(data->getColumn(cols[1])->getMin());
ret.sety1(data->getColumn(cols[1])->getMax());

#ifdef DEBUG1
printf("Plot Limit: %f,%f - %f,%f\n",ret.x0,ret.y0,ret.x1,ret.y1);
#endif
return ret;
}
