#include "config.h"
#include <stdio.h>
#include "util.h"
#include "../libqEM/qutil.h"
#include "qfile.h"
#include "Axes2d.h"
#include "LSPlot.h"
#include "qwidget.h"

#ifdef UBUNTU
	#include <qapplication.h>
#else	//UBUNTU
	#include "qapp.h"
#endif	//UBUNTU

int initdone=0;

int lineparm[24][4] = { 0,0,0,0, 0,0,0,1, 0,0,0,3, 0,0,0,2,                                  0,0,240,0, 0,0,240,1, 0,0,240,3, 0,0,240,2,                                                 240,0,0,0, 240,0,0,1, 240,0,0,3, 240,0,0,2,                                                 200,0,200,0, 200,0,200,1, 200,0,200,3, 200,0,200,2,                                                                                                                                     0,240,0,0, 0,240,0,1, 0,240,0,3, 0,240,0,2,                                                 0,200,200,0, 0,200,200,1, 0,200,200,3, 0,200,200,2 };

int main( int argc, char **argv )
{
QFont *newdf;
QApplication a( argc, argv );
int i,j;

appinit(argc,argv);

EMQInit(&a);

Equation::init();

a.processEvents();

Axes2d *ax=new Axes2d(NULL,"Name");
ax->resize(500,400);
ax->setBackgroundMode(QWidget::NoBackground);
ax->setAction(Qt::LeftButton,D2_ACT_XVALUE|D2_ACT_YVALUE|D2_ACT_MPOS);
//ax->setAction(Qt::MidButton,D2_ACT_YLOG);
ax->setAction(Qt::LeftButton|Qt::ControlButton,D2_ACT_LEGEND);
ax->setAction(Qt::RightButton,D2_ACT_ZOOM);
ax->setOptions(D2_OPT_AUTOSCALE|D2_OPT_FRAME|D2_OPT_SHOWY0,D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_CSCA|D2_OPT_AXIS, D2_OPT_SCALE|D2_OPT_TIC);
//ax->setlabfn(labfn);
ax->setXLabel("X");
ax->setYLabel("Y");

ax->show();
a.setMainWidget(ax);

float hist=0;
for (i=1; i<argc; i++) {
	if (strncmp(argv[i],"hist=",5)==0) { sscanf(argv[i]+5," %f",&hist); continue; }
	DataSet *d=new DataSet;
	LSPlot *p=new LSPlot;
	d->readFile(argv[i]);
	if (hist) {
		float min=1.0e20,max=-1.0e20;
		int cp=d->cols()-1;
		for (j=0; j<d->rows(); j++) {
			if (d->dataAt(cp,j)>max) max=d->dataAt(cp,j);
			if (d->dataAt(cp,j)<min) min=d->dataAt(cp,j);
		}
		int n=(max-min)/hist;
		if (n>10000) error(ERR_EXIT,"More than 10000 bins in histogram");

		// new data set has histogram
		DataSet *d2=new DataSet;
		d2->setXYdata(min,max,n+1);
		Column *c=d2->getColumn(1);
		for (j=0; j<n; j++) c->setData(j,0.0);
		for (j=0; j<d->rows(); j++) {
			int k=(int)((d->dataAt(cp,j)-min)/hist);
			c->setData(k,c->dataAt(k)+1.0);
		}
		delete d;
		d=d2;
	}
	p->setData(d);
	p->setCols(0,1);
	p->setLabel(argv[i]);
	int j=(i-1)%24;
	p->setColor(lineparm[j][0],lineparm[j][1],lineparm[j][2]);
	p->setLine(lineparm[j][3],1);
	p->setSym(SYM_PLUS,4);
	ax->addPlot(p);
}

return a.exec();

}
