#ifndef SLIMAGEH
#define SLIMAGEH

#include "Image.h"

class SliceImage:public Image {
    Q_OBJECT

EMData *segdata;
int segdisp;		// 0-n colors 1 segment only, -1 colors all segments
int drawseg;
int drawrad;

float max,min;

public:
SliceImage( QWidget *parent=0, const char *name=0 );
~SliceImage();

void setSegData(EMData *data);
EMData *getSegData();
void setSegDisp(int mode);
int getSegDisp();
void setDrawSeg(int ds);
void setDrawRad(int dr);
void setMin(float Min);
void setMax(float Max);
void paint(int x, int y, int seg);

virtual void paintEvent( QPaintEvent *qp );
virtual void mousePressEvent(QMouseEvent *);
virtual void mouseReleaseEvent(QMouseEvent *);
virtual void mouseDoubleClickEvent(QMouseEvent *e);
virtual void mouseMoveEvent(QMouseEvent *);
virtual void mouseEnter(int);
virtual void mouseLeave(int);

signals:
	void doubleclicked(int,int,int);

};

inline EMData *SliceImage::getSegData() { return segdata; }
inline int SliceImage::getSegDisp() { return segdisp; }
inline void SliceImage::setSegData(EMData *data) { segdata=data; imageChanged(); }
inline void SliceImage::setSegDisp(int mode) { segdisp=mode; imageChanged(); }
inline void SliceImage::setDrawSeg(int ds) { drawseg=ds; }
inline void SliceImage::setDrawRad(int dr) { drawrad=dr; }
inline void SliceImage::setMin(float Min) { min=Min; }
inline void SliceImage::setMax(float Max) { max=Max; }

#endif
