// cenalign.C 1997 - Steve Ludtke
// Copyright 1997 Baylor College of Medicine
// This iteratively centers a set of particles


#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

main(int argc, char *argv[]) {
int i,j,k,nx,nm,n,NS;
List *data,*data2,*bad;
EMData *d,*d2;
char s[80];
float f,mean;

appinit(argc,argv);

if (argc<2) { printf("cenalign.c\nUsage: cenalign <input file> [ # ]\n"); exit(0); }
if (argc>=3) nm=atoi(argv[2]);
else nm=0;

n=fileCount(argv[1]);
NS=n/3+1;
if (nm==0) data=readImages(argv[1],0,n);		// read all input images
else data=readImages(argv[1],(nm-1)*NS,nm*NS-1);
if (data==NULL) error("Cannot read input",ERR_EXIT);
printf("Read %d images.\n",data->count());
data2=new List;
for (i=0; i<data->count(); i++) {
	d2=(EMData *)data->objectAt(i);
	d2->normalize();
//	d2->applyMask(-1,1);		// noise mask
//	d2->applyMask(-1,0);		// mean mask
	data2->addObject(d2->copy());
}
nx=d2->xSize();
bad=new List;

printf("Images copied and normalized.\n");

/*unlink("avg.img");
unlink("avg.hed");
unlink("ali.img");
unlink("ali.hed");*/

for (i=0; i<12; i++) {
	printf("Loop %d\n",i);
	d=new EMData;
	d->makeAverage(data2);
	d->radialAverage();
	
//	if (i==7) 
		d->writeIMAGIC("avg",-1);

//	sprintf(s,"/tmp/tst%d.img",i);
//	d2=(EMData *)data2->objectAt(0);
//	d2->writeMRC(s);

	mean=0;
	for (j=0; j<data2->count(); j++) {
		d2=(EMData *)data2->objectAt(j);
		f=d2->transAlign(d,1);
		mean+=f;
		printf("%d. %1.3f\t%1.3f\t%1.2f\n",j,d2->Dx(),d2->Dy(),f);

// delete ones that need too much alignment
		if ((i>4 && f>nx/15)||(hypot(d2->Dx(),d2->Dy())>nx/5 && i>2)) {
			bad->addObject(d2->Parent());
			delete d2;
			data->removeObjectAt(j);
			data2->removeObjectAt(j);
			printf("DELETE %d, %f\n",j,f);
			j--;
			continue;
		}
		
		((EMData *)data2->objectAt(j))->rotateAndTranslate();
	}
	delete(d);
	mean/=data2->count();
	if (mean<.1) break;
}
printf("%d loops completed\n",i);

//unlink("bad.img");
//unlink("bad.hed");
for (i=0; i<data2->count(); i++) ((EMData *)data2->objectAt(i))->applyMask(nx*90/200,1);
for (i=0; i<data2->count(); i++) ((EMData *)data2->objectAt(i))->writeIMAGIC("ali",-1);
for (i=0; i<bad->count(); i++) ((EMData *)bad->objectAt(i))->writeIMAGIC("bad",-1);

printf("%d good, %d bad\n",data2->count(),bad->count());

}
