#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

#define RADIUS 2.5   // This is the exclusion limit for peak


void eulermult(euler *bc, euler *ab, euler *ac) ;

void com2angs(ANG *ang,char *argv,float radius, int peaks) ;

float tiltfunc(float ang1, float ang2, float ang3); 
float tiltfunc2(float ang1, float ang2, float ang3);
void triforsides(float alpha, float beta, float gamma, float *tiltxAB, float *tiltxCA, float *tiltxBC);
void triangles(float gamma, float alpha, float beta, float *tiltxBC, float *tiltxCA, float *tiltxAB) ;	

void symsearch(char *argv,float radius, int csymnum, int *best, int *middle) ;

//                     eulercclshort2.4.C
//     This is a rather short version of eulerccl
//       It does not search for the 4best pictures from
//           which to form consistency relations
//   It calls on com2angs to assign ang[ij].a1           3/22/98

main(int argc, char *argv[]) {
int i,j,k,n;
// int ia, ib ,ic,id, iabest,ibbest,icbest,idbest;
// int inew, jnew, ibest, minnew, maxnew;  
int PEAKS = PEAKMAX, csymnum; 
int iA,iB, iC, index, indexstart, icount,indexbestsym,middle;
FILE *outeulerccl;
List *data, *dlist;
EMData *d2,*d;
char s[80];
float pi= 3.1415926, piover = pi/180.;
float alpha,beta,gamma,sigma, tempy;
float AB, BC, CA, AC, CB, BA;
float tiltxAB, tiltxBC, tiltxCA,tiltxAC; // How about that?
float  *numbat, *tiltx, *tiltxfinal ;
float quality, qualitymax, thing, numbatmost, meancount, finterval=20., kept;
ANG *ang;

appinit(argc,argv);

PEAKS =2;

if (argc<4) { printf("eulerccl\nUsage: eulerccl <input file><output file> <csymnum>\n"); exit(0); }
printf(" RADIUS= %f		\n",RADIUS);
csymnum = atoi(argv[3]);
printf("csymnum = %d  \n", csymnum);

data=readImages(argv[1],0,-1);
n=data->count();

unlink ("projnorm.img");
unlink ("projnorm.hed");

tiltx     =(float *)calloc(n*(n-1)*(n-2)/2,sizeof(float));
tiltxfinal=(float *)calloc(n*(n-1)*(n-2)/2,sizeof(float));
numbat    =(float *)calloc(3600,sizeof(float));

for (i=0; i<n; i++) ((EMData*)data->objectAt(i))->toCorner();


// *************** 0. Symmetry Search; Sort List      ******************
if (csymnum > 1) {	
	printf("self-searching and writing to self.img \n");
	symsearch(argv[1],RADIUS,csymnum, &indexbestsym, &middle);
	printf("the most symmetrical particle was originally labelled by %d \n", indexbestsym+1);
	printf("the middle symmetrical particle was originally labelled by %d \n", middle+1);
}

data->swap(0, indexbestsym);
data->swap(1, middle      );

// **************  1. Read in Peaks;   
//     
// *********  Assign the az, phi variables
// *********    ang[ij].a1

ang=(ANG *)calloc(n*n,sizeof(ANG));

printf("reading in peaks \n");

// gets phi, az  info from the emdata uses RADIUS, PEAKS, argv[1]
//     writes ang[ij], rewrites argv[1]
//  
//       argv[1] = "reordered.img";                    
com2angs(ang,argv[1],RADIUS, PEAKS);

//	n=4;
//	ang[1].a1[0] = 102.5; ang[4].a1[0]=360-1.5;
//	ang[2].a1[0] = 290.5; ang[8].a1[0]=360-358.5;
//	ang[3].a1[0] = 101.5; ang[12].a1[0]=360-359.5;
//	ang[6].a1[0] = 169.5; ang[9].a1[0]=360-18.5;
//	ang[7].a1[0] =  12.5; ang[13].a1[0]=360-.5;
//	ang[11].a1[0]= 177.5; ang[14].a1[0]=360-351.5; 

// **************    2. Start Determining Tilts  *****************
// 
// AB BC CA AC CB BA; tiltxAB, tiltxCA, tiltx[], index

  printf(" Finished reading peaks. Start determining tilts\n\n");

//		printf("iA	iB	iC	sumangs		alpha		beta		gamma 	\n\n ");    
		printf("iB+1	iC+1	tiltxBC bctemp.phi	ang[i+iC*n].a1[0]	bctemp.az	ang[j+i*n].a1[0]\n\n ");    

for (iA =0   ; iA < n   ; iA++) {
for (iB=iA+1 ; iB < n-1 ; iB++) {
for (iC=iB+1 ; iC < n   ; iC++) {
	AB  =  piover*ang[iB + iA*n].a1[0]; 
	BA  =  piover*ang[iA + iB*n].a1[0]; // these start out zero
	CA  =  piover*ang[iA + iC*n].a1[0]; // these start out zero 
	AC  =  piover*ang[iC + iA*n].a1[0];
	BC  =  piover*ang[iC + iB*n].a1[0];
	CB  =  piover*ang[iB + iC*n].a1[0]; 
	  
//
//           Recall  A is iA ; B is iB ; C is iC ;  iA < iB < iC
//
//     There are N-2 readings for each tilt,  
 //        Fill in first non-zero one
	triforsides(AB-AC,BC-BA,CA-CB,&tiltxAB,&tiltxCA,&tiltxBC);
	tiltxAC = - tiltxCA; if (tiltxAC <0) tiltxAC += pi;
	triangles(CA-CB,AB-AC,BC-BA,&tiltxAB,&tiltxBC,&tiltxCA);

//        Store it		
	indexstart = (n-2)*(-iA*(iA+1)/2 + (n-1)*iA + iB  -1);
	tiltx[indexstart +iC-2] = tiltxAB ; 
// ****************
	indexstart = (n-2)*(-iA*(iA+1)/2 + (n-1)*iA + iC  -1);
	tiltx[indexstart+iB-1] = tiltxAC ; // that's because we want AC
// ****************
	indexstart = (n-2)*(-iB*(iB+1)/2 + (n-1)*iB + iC  -1);
	tiltx[indexstart +iA] = tiltxBC ; 



		thing =alpha+beta+gamma; thing *= 180./pi;		
		alpha *= 1./piover;	beta  *= 1./piover;	gamma *= 1./piover; 			
//		printf(" %d	%d	%d	%f	%f	%f	%f	\n ", iA+1, iB+1, iC+1, thing, alpha, beta, gamma);    

}}}   // ends iC , iB , and iA loops


//  **********************  2.    Print out relations between 1 and  1 < k <= N
//  ***********************        Also decide on "average value"
//   finterval, thing, numbatmost, mean[180],  meancount,kept      

	outeulerccl = fopen(argv[2],"wb");
		fprintf(outeulerccl,"1	0.	0.	0. \n"); 
	
//
printf("\n tilt		ang[j+n*i].a1[0]	-ang[i+n*j].a1[0] \n");
for (i=indexstart=0; i < n; i++) {   
	for (j=i+1; j < n ; indexstart++, j++) {
 		printf("\n %d %d \n",i+1, j+1);

 		for (icount=0; icount < 180 +finterval*2; icount++) numbat[icount] =0; // initialize
 	
		for ( index = indexstart*(n-2) ; index < (indexstart+1)*(n-2); index++) { 

			thing = tiltx[index]/piover; 
			if (i<n)	printf("%f %f %f\n", thing, ang[j+n*i].a1[0],  360-ang[i+n*j].a1[0]);
			thing += finterval/2;
 
//              									Here we find
   			if (thing*thing< 400*400) {  // if we have a good data point
				for (icount=thing - finterval;  icount < thing +1 ; icount ++){
   					if (icount >= 0 )	{ // numbat[icount] += 1;
// How about adding a triangle function  [1-abs(2(icount-thing)+finterval)/finterval]
						tempy = 2*(icount -thing) + finterval; if (tempy<0) tempy *= -1; 
 						numbat[icount] += 1- tempy/finterval ; } //ends icount
			}}}  // ends  icount loop and if  and index

		numbatmost = -1; 
	
		for (icount = 0; icount < 180 + ((int)(finterval)); icount++){
			if (numbat[icount] > numbatmost) { kept =1.;
				numbatmost = numbat[icount];
				meancount = (float)(icount);} // keep track of value for angle
			
			if (numbat[icount] == numbatmost) { kept +=1.;    // if same, then average
				meancount = (((float)(icount)) + (kept-1.)* meancount)/kept;} //
 	
		} // ends icount for loop 

		if (meancount > 180) meancount = 180;

//	if (j==n-1) for (icount=0;icount <180; icount++) printf(" %f \n", numbat[icount] );

		printf("  numbatmost	meancount	ang[j+n*i].a1[0]	360-ang[i+n*j].a1[0] \n ");
		printf(" %f	%f	%f	%f\n", numbatmost, meancount,ang[j+n*i].a1[0],  360-ang[i+n*j].a1[0]);

		if (i==0) {fprintf(outeulerccl,"%d	%f	%f	%f  \n", indexstart+2,meancount,
					ang[j+n*i].a1[0],  360-ang[i+n*j].a1[0]); // alt, az, phi
					tiltxfinal[(n-2)*(j-1)] =piover * meancount;}
}}   // ends j,i loops 

// ***********************Write out imagic files correctly
	i=0;
 	d2=(EMData*)data->objectAt(i);
	d2->setRAlign(0,0,0);
	d2->setNImg(1);
	d2->toCorner();
	d2->writeIMAGIC(argv[1],i); 	
	for (j=1; j < n ; j++) {
	 	d2=(EMData*)data->objectAt(j);
		d2->setRAlign(2*pi-ang[i+n*j].a1[0]*piover,tiltxfinal[(n-2)*(j-1)],ang[j+n*i].a1[0]*piover);
		d2->setNImg(1);
		d2->toCorner();
		d2->writeIMAGIC(argv[1],j);	}
		
// make3d writes out alt az phi
// setRAlign writes out phi alt az
// I write to outeulerccl  alt, az, phi

// ************  Check the answer by resubstituting    *****************


  printf(" \n Check answer by resubstituting \n");

 		printf("iA	i	j	tiltxCA	cos(tiltxfinal) \n");


for (iA =0 ; iA < n ; iA++) {
for (iB=iA+1 ; iB < n-1  ; iB++) {
   for (iC=i+1 ; iC < n  ;  iC++) {
      BC =  piover*((float)(ang[iC + iB*n].a1[0]));
      CB =  piover*((float)(ang[iB + iC*n].a1[0]));
      BA =  piover*((float)(ang[iA + iB*n].a1[0]));
      AB =  piover*((float)(ang[iB + iA*n].a1[0]));
      AC =  piover*((float)(ang[iC + iA*n].a1[0]));
      CA =  piover*((float)(ang[iA + iC*n].a1[0]));

        
		beta  =  pi- BA +BC; beta  += 4*pi; while (beta  >= 2.*pi) beta  += -2.*pi; 
		alpha =  pi- AC +AB; alpha += 4*pi; while (alpha >= 2.*pi) alpha += -2.*pi; 
		gamma =  pi- CB +CA; gamma += 4*pi; while (gamma >= 2.*pi) gamma += -2.*pi; 

//
//           Recall  A is iA ; B is iB ; C is j ;  iA < i < j
//
//     There are N-2 readings for each tilt,  
//        Fill in first non-zero one
 
//      The following is iA i
		tiltxAB =  tiltfunc(alpha,beta,gamma);
 
//      Now comes iA j	
		tiltxCA  = tiltfunc(gamma,alpha,beta);

//      Now comes i j
		tiltxBC  = tiltfunc(beta,gamma,alpha);
		
		indexstart = (-iA*(iA+1)/2 + (n-1)*iA + iB  -1);
//		printf("%d	%d	%d	%f	%f	\n",iA,iB,iC,tiltxAB,(tiltxfinal[indexstart]));
 
		indexstart = (-iA*(iA+1)/2 + (n-1)*iA + iC -1);
// 		printf("%d	%d	%d	%f	%f	\n",iA,iC,iB,tiltxCA,(tiltxfinal[indexstart]));

		indexstart = (-iB*(iB+1)/2 + (n-1)*iB + iC  -1);
//		printf("%d	%d	%d	%f	%f	\n",iB,iC,iA,tiltxBC,(tiltxfinal[indexstart]));
 
}}}   // ends i , j , and iA loops

//printf(" \n\n"); 

// ************  End Phil's section    *****************

}

