#include "EMData.h"

int main(int argc, char* argv[]) {

if(argc<4) {
	fprintf(stderr, "Usage: %s <average map> <variance map> <input map> ...\n", argv[0]);
	exit(1);
}

//int norm=atoi(argv[1]);

EMData* inmap = new EMData;
inmap->readImage(argv[3],-1, 1);	// headonly
int nx=inmap->xSize(), ny=inmap->ySize(), nz=inmap->zSize();

EMData* mean = new EMData;
EMData* var = new EMData;

mean->setSize(nx,ny,nz);	mean->zero();
var->setSize(nx,ny,nz);	var->zero();

float *mp = mean->getData(), *vp = var->getData();

int nummaps=0;
for( int i =3; i<argc; i++) {
	printf("Processing map %d/%d: %s\n",i-2,argc-3,argv[i]);
	inmap->readImage(argv[i],-1);
	if(inmap->xSize()!=nx || inmap->ySize()!=ny || inmap->zSize()!=nz){
		fprintf(stderr,"WARNING: map %s size (%dx%dx%d) != (%dx%dx%d)\n",argv[3], inmap->xSize(),inmap->ySize(),inmap->zSize(),nx,ny,nz);
		continue;
	}
	float *inp=inmap->getDataRO();
	for(int j=0; j<nx*ny*nz; j++) {
		float oldmean = mp[j];
		mp[j]=(nummaps*mp[j]+inp[j])/(nummaps+1);
		vp[j]=(nummaps*vp[j]+nummaps*oldmean*oldmean+inp[j]*inp[j]-(nummaps+1)*mp[j]*mp[j])/(nummaps+1);
	}
	inmap->doneData();
	nummaps++;
}
for(int j=0; j<nx*ny*nz; j++) vp[j]=sqrt(vp[j]);

mean->doneData();
var->doneData();
//mean->writeImage("Mean.mrc",-1);
//var->writeImage("Sigma.mrc",-1);
mean->writeImage(argv[1],-1);
var->writeImage(argv[2],-1);
}
