#include <stdio.h>
#include "EMData.h"
#include "List.h"
#include "util.h"
#include <math.h>
#include <time.h>
#include <sys/types.h>
#include <errno.h>

#define MAXPARTICLES 100
#define SKIP 6


//  This program is called from eulerrefine.C. It writes out information
// on the quality of the Euler angle assignment that is currently under 
// consideration
//   
//  stuffqualSquareGuts writes out to .tmp.qualJazz
//   for a given value of tilt the quality and the best
//    phis and azimuths
//  
//    it is then the job of eulerrefine to take that info and compare
//          it to find the best tilt.
//
//  stuffqualSquareGuts %d %d %d %d %d %d %d %d %d",ithread,Ntemp,NumProcs,
//			jofinterest,csymnum,CCLxSize,CCLySize,ithetaDmax,icostiltDmax);



inline float pabs( float x){ return sqrt(x*x);}

/****************************************************************/
main(int argc, char *argv[] ) {


	int ithread = atoi(argv[1]);
	int Ntemp = atoi(argv[2]);
	int NumProcs = atoi(argv[3]);
	int jofinterest = atoi(argv[4]);
	int csymnum = atoi(argv[5]);
	int CCLxSize = atoi(argv[6]);
	int CCLySize = atoi(argv[7]);
	int ithetaDmax = atoi(argv[8]);
	int icostiltDmax  = atoi(argv[9]);


	int itemp, ihollow, iq,  bdaz, bdphi, dbaz ;
	int iphiD;
	int ithetaD;
	int i;
	int icostiltD;
	Euler ad,ab,bd;
	float quality;
	float * qualSquareVecTheta= (float *) malloc(ithetaDmax/csymnum * sizeof(float) );
	int *  qualSquareVecPhi  =  (int  *) malloc(ithetaDmax/csymnum * sizeof( int) );

	float *qualitystrip = (float *)calloc(CCLxSize,sizeof(float));
	float *	sinecorr;
	float piover = 3.1415926;
	
	int from = (icostiltDmax*( ithread))/NumProcs;
	int to = (icostiltDmax*( ithread +1 ))/NumProcs;	

	List *imageList=readImages(".tmp.sinecorr.img",0,-1);
	int Nlist  =imageList->count(); 

	EMData *CCLof[MAXPARTICLES];
	float *CCLofData[MAXPARTICLES] ;              // 
	
	Euler *Oa = (Euler *) calloc(Ntemp,sizeof(Euler));
	FILE *tmpAngles=fopen(".tmp.angleFile","rb");
	float Alt,Az,Phi;

	float * VecAltqualSquare =  (float *) malloc(icostiltDmax  * sizeof(float)  );
	int  * VecAltiphiD       =  ( int *) malloc(icostiltDmax  * sizeof(  int)  );
	int  * VecAltithetaD     =  ( int *) malloc(icostiltDmax  * sizeof(  int)  );

	float tiltD;

	for (i=0; i<Ntemp; i++) {
		CCLof[i] = (EMData*)imageList->objectAt(i);
		CCLofData[i] = CCLof[i]-> getDataRO();
	}


	for (i=0; i < Ntemp; i++){
		fscanf(tmpAngles,"%d	%f	%f	%f	\n",&i,&Alt,&Az,&Phi);
		Oa[i].setAngle(Alt,Az,Phi);
		if (0) printf("%d	%f	%f	%f	\n",i,Alt/piover,Az/piover,Phi/piover);
	}
	
	
		for (icostiltD=from; icostiltD < to; icostiltD++){ 
											// icostiltD and ithetaD refer to jofinterest
			tiltD = acos(  ((float) (icostiltDmax - icostiltD))/ ((float) icostiltDmax));
			

			for (int ithetaD=0; ithetaD< ithetaDmax/csymnum; ithetaD++) {
											// icostiltD and ithetaD refer to jofinterest
	
//            Now calculate all
//          the eulers between N and j with 0<j<N

				ad.setAngle(tiltD,(ithetaD*2.*PI)/((float) ithetaDmax),0); 
				quality =0;
	
				// Initialize qualitystrip[] before j loop
				for	(int iphiD = 0; iphiD < CCLxSize ; iphiD++) qualitystrip[iphiD]=0;
	
// ********************************************************   //
//         %%     4.3  Here's the  J loop  %%

				for (int j =0; j<  Ntemp ; j++){  //      jjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj
//					printf("j=%d \n" , j); fflush(stdout);
					sinecorr = CCLofData[j];
					for (int m=0; m < csymnum ; m++) {
						if (j== jofinterest && m==0 && csymnum>1) m++; // Don't do m=0 self sinecorr!!!!!
	
						ab.setAngle(Oa[j].alt(),Oa[j].az() +2.*PI*m/csymnum, Oa[j].phi()); // Not much
																						// time on this
						bd = ad/ab;

						bdaz  =  (int) ( ((float) bd.az() *CCLxSize)  /(2.*PI) ) ;  // in pixels
						bdphi =  (int) ( ((float) bd.phi()*CCLxSize)  /(2*PI) ) ;  // in pixels
						dbaz  = CCLxSize - bdphi; 
//         %%  since commonLines defined funny, we need the following line %%
						bdaz = bdaz+13*CCLxSize/4;
						dbaz = dbaz+13*CCLySize/4;

						while (bdaz >= CCLxSize) bdaz += -CCLxSize; //bdaz = dbphi;
						while (dbaz >= CCLxSize) dbaz += -CCLxSize;

						if (j!=jofinterest) {
							for	(int iphiDtemp = 0; iphiDtemp < CCLxSize ; iphiDtemp++, dbaz--) {
								if (dbaz <0) dbaz += CCLxSize;  
								if (bdaz <0) bdaz += CCLxSize;  
								qualitystrip[iphiDtemp] += sinecorr[dbaz + bdaz*CCLxSize];
							} // end iphiDtemp loop
						} // j not equal to jofinterest
							
						if (j==jofinterest && m >0) { // %% self-stuff%% changing adphi afffects abphi,baaz,bdaz
							for	(int iphiDtemp = 0; iphiDtemp < CCLxSize ; iphiDtemp++, dbaz--,bdaz--) {
								if (dbaz <0) dbaz += CCLxSize;  
								if (bdaz <0) bdaz += CCLxSize;  
					
								ihollow = (tiltD > .1) && (tiltD < PI-.1);
//										ihollow = 1;
								iq = dbaz-bdaz; iq =sqrt((float)iq*iq); 
								if ((iq >SKIP*CCLxSize/360) && (CCLxSize-iq > SKIP*CCLxSize/360)&& ihollow)
									qualitystrip[iphiDtemp] += sinecorr[dbaz + bdaz*CCLxSize];
				
								if ((iq <SKIP*CCLxSize/360) && ihollow){
				   					if (dbaz >= bdaz){
										itemp =bdaz+SKIP; if (itemp>=CCLxSize) itemp+= -CCLxSize;
										qualitystrip[iphiDtemp] += sinecorr[itemp + bdaz*CCLxSize]/1.1;
									} else {
										itemp =dbaz+SKIP; if (itemp>=CCLxSize) itemp+= -CCLxSize;
										qualitystrip[iphiDtemp] += sinecorr[dbaz + itemp*CCLxSize]/1.1;
									}
								} // fills in hollow region
							} // ends iphiDtemp
						}   // skip jofinterest if loop
				}} // ends j,m loops which calculates the eulers	 jjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj
//				printf("j,m loops finished \n");fflush(stdout);
	
// ********************************************************   //
//    %% check out qualitystrip; find max value, store this 
//                                      %%  value and iphiD %%

				quality = -500.;
				for (int iphiDtemp =0; iphiDtemp < CCLxSize; iphiDtemp++) {			
						if (qualitystrip[iphiDtemp] > quality){
						quality= qualitystrip[iphiDtemp];           // Find the best in that row
						iphiD = iphiDtemp;
						if (ithetaD+icostiltD*ithetaDmax >= ithetaDmax*ithetaDmax) 
							printf("ithetaD = %d, tiltD=%d /n",ithetaD, (int)( tiltD*180./PI));fflush(stdout);
					}  // ends if goodquality
				}  // ends iphiDtemp loop
				qualSquareVecTheta[ithetaD] = quality;
				qualSquareVecPhi[ithetaD] = iphiD ;
		
			}	// ends ithetaD


//              This following loop is not out of the main ithetaD loop
			quality = -500;
			for (ithetaD=0; ithetaD < ithetaDmax/csymnum; ithetaD++) {
				if (qualSquareVecTheta[ithetaD] > quality){ 
						quality                  = qualSquareVecTheta[ithetaD];
						VecAltqualSquare[icostiltD] = quality;
						VecAltiphiD[icostiltD]      = qualSquareVecPhi[ithetaD]  ;
						VecAltithetaD[icostiltD]    = ithetaD;
				}
			}	// ends ithetaD

		}	// ends icostiltD       from .... to

	
	FILE *qualJazz=fopen(".tmp.qualJazz","ab");

	for (icostiltD=from;icostiltD < to; icostiltD++) {
		fprintf(qualJazz,"%d	%f	%d	%d	\n",icostiltD,VecAltqualSquare[icostiltD],
				VecAltiphiD[icostiltD],VecAltithetaD[icostiltD]  );
		fflush(qualJazz);
	}




	for (i=0; i<Ntemp; i++) {
		CCLof[i]-> doneData();
	}


	return NULL;
}


