// 6/98  Steve Ludtke this generates a simple stick model with c4
// symmetry to use as a starting model for Ryr reconstructions

#include <stdio.h>
#include <math.h>
#include <time.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

inline float hypot3(float x, float y,float z) { return x*x+y*y+z*z; }

float a[12][2] = {
0.000001,6.283185,
1.107148,0.000001,
1.107148,1.256637,
1.107148,2.513274,
1.107148,3.769911,
1.107148,5.026548,
2.034445,0.628319,
2.034445,1.884956,
2.034446,3.141593,
2.034445,4.398230,
2.034445,5.654867,
3.141593,3.141593 };

main(int argc, char *argv[]) {
int ii,i,j,k,l;
EMData *d;
float *dat,r;
long t;
int xc,yc,zc;

if (argc!=2) { printf("tst.c\nUsage: tst <output file>\n"); exit(0); }

d=new EMData;
d->setSize(144,144,144);

d->zero();
dat=d->getData();
for (ii=0; ii<12; ii++) {
l=0;
for (k=-72; k<72; k++) {
	for (j=-72; j<72; j++) {
		for (i=-72; i<72; i++,l++) {
			xc=50.0*sin(a[ii][0])*cos(a[ii][1]);
			yc=50.0*sin(a[ii][0])*sin(a[ii][1]);
			zc=50.0*cos(a[ii][0]);
			r=sqrt(hypot3((i-xc)/10.0,(j-yc)/10.0,(k-zc)/10.0));
			dat[l]+=exp(-r*r);
		}
	}
}
}

// center
l=0;
for (k=-72; k<72; k++) {
	for (j=-72; j<72; j++) {
		for (i=-72; i<72; i++,l++) {
			r=sqrt(hypot3((i)/25.0,(j)/25.0,(k)/25.0));
			dat[l]+=exp(-r*r);
		}
	}
}

d->doneData();
d->update();


d->writeMRC(argv[1]);
}
