#include <stdio.h>
#include "EMData.h"
#include "List.h"
#include "util.h"
#include <math.h>

EMData *topview(EMData *in);
EMData *sideview(EMData *in);

main(int argc, char *argv[]) {
EMData *d,*d2,*f,*f2,*p,*q;
float alt,az,phi,r;
float *dat;
int i,j,k;

if (argc!=2) { printf("recontest\nUsage: recontest <input file>\n"); exit(0); }

dbread();

d=new EMData;
if (d->readImage(argv[1],0)) error("Cannot read input",ERR_EXIT);
//d->setTAlign(0,8.0,0.0);
//d->setRAlign(0,.3,0);
//d->rotateAndTranslate();
d->normalize();

alt=M_PI/2;
az=0;
phi=0;

d->toCorner();
f=d->doFFT();
printf("FFT complete\n");

f2=new EMData;		// empty fft of volume to put reconstruction in
f2->setup4IS(d->xSize());

unlink("p.img");
unlink("p.hed");
unlink("q.img");
unlink("q.hed");
for (i=0; i<100; i++) {
		alt=frand(-PI/2.0,PI/2.0);
		az=frand(0,2.0*PI);

		p=f->fftSlice(alt,az,phi,3);		// projection of original image
		q=p->doIFT();
		p->gimmeFFT();
		q->toCorner();
		q->applyMask(-1,10);
//		q->writeIMAGIC("q.img",-1);		// record the projections
		q->toCorner();
		p=q->doFFT();
		q->gimmeFFT();			
		
		f2->insertSlice(p,alt,az,phi,3);	// put the data into fourier space
		
		delete p;
		delete q;
printf(" %f done\r",az); fflush(stdout);
}

f2->doneSlice();

printf("do fft/ift\n");
d2=(f2->iftSlice());
f2->gimmeFFT();
d2->toCorner();
d2->applyMask(-1,10);
d2->applyMask((int)floor(.45*d2->ySize()),2);
d2->writeMRC("m.mrc");
d2->toCorner();
f2=d2->doFFT();
d2->gimmeFFT();

// generate a projection of the new volume perpendicular to the slices used
// to generate it
p=f2->fftSlice(0,0,0,3);
q=p->doIFT();
q->toCorner();
q->applyMask(-1,10);
q->writeIMAGIC("p.img",-1);

// same projection of the original volume
p=f->fftSlice(0,0,0,3);
q=p->doIFT();
q->toCorner();
q->applyMask(-1,10);
q->writeIMAGIC("p.img",-1);

q=topview(d2);
//q->toCorner();
q->normalize();
q->writeIMAGIC("p.img",-1);

q=topview(d);
q->toCorner();
q->normalize();
q->writeIMAGIC("p.img",-1);

// generate a projection of the new volume perpendicular to the slices used
// to generate it
p=f2->fftSlice(M_PI/2,0,0,3);
q=p->doIFT();
q->toCorner();
q->applyMask(-1,10);
q->writeIMAGIC("p.img",-1);

// same projection of the original volume
p=f->fftSlice(M_PI/2,0,0,3);
q=p->doIFT();
q->toCorner();
q->applyMask(-1,10);
q->writeIMAGIC("p.img",-1);

q=sideview(d2);
//q->toCorner();
q->normalize();
q->writeIMAGIC("p.img",-1);

q=sideview(d);
q->toCorner();
q->normalize();
q->writeIMAGIC("p.img",-1);

q->writeIMAGIC("p.img",-1);
q->writeIMAGIC("p.img",-1);
}

EMData *topview(EMData *in) {
EMData *ret;
float *dat,*din;
int i,j,k;

ret=new EMData;
ret->setSize(in->xSize(),in->ySize(),1);
dat=ret->getData();
din=in->getDataRO();
for (i=0; i<in->xSize(); i++) {
	for (j=0; j<in->ySize(); j++) {
		dat[i+j*in->xSize()]=0;
		for (k=0; k<in->zSize(); k++) {
			dat[i+j*in->xSize()]+=din[i+j*in->xSize()+k*in->xSize()*in->ySize()];
		}
	}
}
in->doneData();
ret->doneData();
ret->update();
return ret;
}

EMData *sideview(EMData *in) {
EMData *ret;
float *dat,*din;
int i,j,k;

ret=new EMData;
ret->setSize(in->xSize(),in->zSize(),1);
dat=ret->getData();
din=in->getDataRO();
for (i=0; i<in->xSize(); i++) {
	for (j=0; j<in->zSize(); j++) {
		dat[i+j*in->xSize()]=0;
		for (k=0; k<in->ySize(); k++) {
			dat[i+j*in->xSize()]+=din[i+k*in->xSize()+j*in->xSize()*in->ySize()];
		}
	}
}
in->doneData();
ret->doneData();
ret->update();
return ret;
}
