#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

// historical reasons
struct SORT { float val; };

int cmp(const void *d1, const void *d2) {
float c;
c=((SORT *)d1)->val-((SORT *)d2)->val;
if (c<0) return 1;
if (c>0) return -1;
return 0;
}


main(int argc, char *argv[]) {
int csym=0,n,imask=-1,mask=-1;
int i;
float lc,b,best[20];
List *data;
EMData *tmp,*st,*msk;
SORT *srt;

if (argc<2) { printf("symeval\nUsage: symeval <input file> [mask=<rad>] [imask=<rad>]\n"); exit(0); }

for (i=2; i<argc; i++) {	
	if (strncmp(argv[i],"mask=",5)==0) mask=atoi(&argv[i][5]);
	else if (strncmp(argv[i],"imask=",6)==0) imask=atoi(&argv[i][6]);
	else { printf("Unknown argument '%s'\n",argv[i]); exit(1); }
}

int Ref=LOGbegin(argc,argv);
LOG(Ref,argv[1],LOG_INFILE,NULL);

data=readImages(argv[1],-1,-1);
n=data->count();
srt=(SORT *)malloc(n*sizeof(SORT));

if (n<2) { printf("Not enough images to sort!\n"); exit(0); }

msk=((EMData *)data->objectAt(0))->copy();
msk->setParent(NULL);
msk->one();
msk->applyMask(mask,4);
msk->applyMask(imask,5);
msk->writeMRC("mask.mrc");
b=0;
for (csym=2; csym<13; csym++) {
	best[csym]=0;
// do the symmetry comparisons
	for (i=0; i<n; i++) {
		st=((EMData *)data->objectAt(i));
		st->normalize();
		st->mult(msk);
		tmp=st->copy();
		lc=0;
		for (float f=2.0*PI/(float)csym; f<(2.0-1.0/(float)csym)*PI; f+=2.0*PI/(float)csym) {
			tmp->setRAlign(f,0,0);
			tmp->rotateAndTranslate();
			lc+=tmp->dot(st);
		}
		delete tmp;
		lc/=(float)(csym-1);
		lc/=tmp->xSize()*tmp->ySize();
		srt[i].val=lc;		
//		if (lc>best[csym]) best[csym]=lc;
		printf(" %3d\t%4d\t%f\r",csym,i,lc); fflush(stdout);
	}
	qsort(srt,n,sizeof(SORT),cmp);
	
	for (i=0; i<n/20; i++) best[csym]+=srt[i].val;
	best[csym]/=(n/20);
	if (best[csym]>b) b=best[csym];
}

for (i=2; i<13; i++) {
	printf("%3d. %5.3f ",i,best[i]);
	for (int j=0; j<floor(59.99*best[i]/b); j++) putchar('*');
	putchar('\n');
}

}
