// 6/98  Steve Ludtke this generates a simple stick model with c4
// symmetry to use as a starting model for Ryr reconstructions

#include <stdio.h>
#include <math.h>
#include <time.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

inline float hypot3(float x, float y,float z) { return x*x+y*y+z*z; }

main(int argc, char *argv[]) {
int i,j,k,l;
EMData *d;
float *dat,r;
long t;

if (argc!=2) { printf("tst.c\nUsage: tst <output file>\n"); exit(0); }

d=new EMData;
d->setSize(100,100,100);

dat=d->getData();
l=0;
for (k=-50; k<50; k++) {
	for (j=-50; j<50; j++) {
		for (i=-50; i<50; i++,l++) {
			dat[l]=0;
			r=sqrt(hypot3((i-12.0)/14.0,(j)/14.0,(k)/30.0));
			dat[l]+=exp(-r*r*r*r);
			r=sqrt(hypot3((i+6.0)/14.0,(j+10.39)/14.0,(k)/30.0));
			dat[l]+=exp(-r*r*r*r);
			r=sqrt(hypot3((i+6.0)/14.0,(j-10.39)/14.0,(k)/30.0));
			dat[l]+=exp(-r*r*r*r);
		}
	}
}
d->doneData();
d->update();


d->writeMRC(argv[1]);
}
