#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
//#include <unistd.h>
#include <qinputdialog.h>
#include <qcstring.h>
#include <qtimer.h>
#include "Image.h"
#include "ImageMx.h"
#include "EMData.h"
#include "List.h"
#include "util.h"

#ifdef UBUNTU
	#include <qapplication.h>
#else	//UBUNTU
	#include <qapp.h>
#endif	//UBUNTU

#define  FILE_SIZE 50000000

using namespace std;

int monitor=0;


int main( int argc, char **argv )
{  
    QApplication a( argc, argv );
    Image *im = NULL;
    ImageMx *imM;
    EMData *dat;
    int i, j, k, res;
    List*  EMDataList;
    struct stat f_info;
    int nCount;
    //int *type;
    appinit(argc,argv);
    if( argc <2)
    {
	cout << "Usage: v2 [imge1] ...."<<endl;
	cout << "To display one or multiple images" << endl;
	exit(1);
    }
   

//Equation::init();
    for(i=1; i<argc; i++)
    {

	if (strcmp(argv[i],"-m")==0) {
		monitor=1;
		continue;
	}
	dat=new EMData;
	j = fileCount(argv[i]);
	
	//-----------------------------------------------------------
	//this block of code is for 3D MRC file
	EMData* tmp = new EMData;
	tmp->readImage(argv[i],0,1);	// read header only
	if (tmp->getMRCHed()) {
		j=tmp->getMRCHed()->nz;	// treat 3D mrc map as 2D image stack
		
		if( j>1 ) //j>1 means 3D MRC file
		{
			ImageMx *imx=new ImageMx;
			imx->setAutoDelete(TRUE);
			EMData *d;
			for(int ii=0; ii<j; ii++) {
				d = new EMData();
				d->readImage( argv[i], ii );
				imx->addData(d);
			}
			char caption[100] = "";
			strcpy(caption, argv[i]);
			strcat(caption, " (middle mouse for controls)\0");
			imx->setCaption( caption );
			imx->show();
			delete tmp;
			continue;
		}
	}
	delete tmp;
	//-------------------------------------------------------------
	
	if( j == 1 )
	{
	    dat->readImage(argv[i],0);
	    if(dat->zSize() == 1) {
	    	im=new Image;
	    	im->setData(dat);
	    	im->show();
	    }
	    else {	//for 3D image, display slice view along z axis
	    	imM = new ImageMx();
	    	imM->setAutoDelete(TRUE);
	    	EMData *d;
	    	int nx = dat->xSize();
	    	int ny = dat->ySize();
	    	int nz = dat->zSize();
	    	for(int zz = 0; zz<nz; ++zz) {
	    		d = new EMData();
	    		d->setSize(nx, ny, 1);
	    		d->zero();
	    		//float * pdata = d->getData();
	    		//float * pslice = dat->getDataRO() + nx*ny*zz;
	    		//memcpy(pdata, pslice, nx*ny*sizeof(float));
	    		for(int j = 0; j < ny; ++j) {
	    			for(int i = 0; i < nx; ++i) {
	    				d->setValueAt(i, j, 0, dat->valueAt(i,j,zz));
	    			}
	    		}
	    		imM->addData(d);
	    		char caption[100] = "";
				strcpy(caption, argv[i]);
				strcat(caption, " (middle mouse for controls)\0");
				imM->setCaption( caption );
				imM->show();
				continue;
	    	}
	    }
	}
	else if( j >1 )
	{
	    res = -1;
	    imM = new ImageMx;
	    imM->setAutoDelete(1);
	    if(!stat(argv[i], &f_info))
	    {
		if(f_info.st_size > FILE_SIZE)
		{
		    QCString cstr;
	
		    res = QInputDialog::getInteger( 
			    QObject::tr( "Note: Demo Images Select Dialog."),
			    cstr.sprintf("Total Images in file are : %d.\n"
					 "How many Images do you want to display?", j) );
		}

		EMDataList = readImages(argv[i], 0, -1);
		nCount = EMDataList->count();
		if(res != -1)
		{
		    if(nCount >=res)  nCount = res;
		}
		for( k = 0; k<nCount; k++)
		{
		    imM->addData( (EMData*)(EMDataList->objectAt(k)), -1);
		}
		imM->show();
	    }
	}
	else
	{
		printf("Not a valid image file ...\n");
		exit(0);
	}
	
    }
    QObject::connect(qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()));

	if (monitor && im) {
		QTimer *timer=new QTimer(&a);
		QObject::connect(timer, SIGNAL(timeout()), im, SLOT(reload()));
		timer->start(2000);
	}
    return a.exec();
}
