#include "Image2.h"

Image2::Image2(QWidget* parent,const char* name):QWidget( parent, name )
{

resize(200,200);

qp=new QPainter();
qpm=new QPixmap(size());
qpd=NULL;

data=NULL;

setBackgroundMode(NoBackground);

alt=az=phi=0;

mode=7;
cont=0;
rad=-1;

needupd=1;
}


Image2::~Image2()
{
delete qp;
delete qpm;
}

void Image2::resizeEvent ( QResizeEvent *qe )
{
/*qp->begin(this);
qp->eraseRect(qp->window());
qp->end();
*/
qpm->resize(size());
needupd=1;
}

void Image2::paintEvent( QPaintEvent *pe )
{
char *d;
float scale=1.0,mm;
int i,sz;

sz=width()<height()?width():height();
if (data) scale=(float)sz/data->xSize();

if (needupd||qpd) {
	if (!data) {
		qpm->fill();
	}
	else {
		EMData *dat;
		qpm->fill();

		if (mode==7) {
			dat=data->project3d(alt,az,phi,-4);
		}
		else dat=data->project3d(alt,az,phi,mode);
		dat->normalize();
		dat->applyMask(-1,0);
		mm=-dat->Min()<dat->Max()?dat->Max():-dat->Min();
		mm*=(1.0-cont);
		d=(char *)malloc(width()*height()+80);

		sprintf(d,"P5\n%d %d\n255\n",width(),height());
		i=strlen(d);
		dat->renderAmp8((unsigned char *)d+i,0,-1,width(),height(),width(),
			scale,1,254,-mm,mm);

		qpm->loadFromData((uchar *)d,(uint)(i+height()*width()));

		delete dat;
		free(d);
		needupd=0;

		if (qpd) qp->begin(qpd);
	}
}

bitBlt( this, 0,0, qpm );

if (!qpd) qp->begin(this);
qp->setPen(red);

if (rad>0) {
	qp->translate(sz/2,height()-sz/2);
	qp->rotate(ang+90.0);
//	qp->drawEllipse(sz/2-rad,height()-(sz/2-rad2),rad*2,-rad2*2);
	qp->drawEllipse(-rad,-rrad2,rad*2,rrad2*2);
	qp->resetXForm();
}
qp->end();
}

void Image2::mousePressEvent(QMouseEvent *e) {
int x,y;

x=e->x();
y=e->y();

//mouseMoveEvent(e);

update();
}

void Image2::mouseReleaseEvent(QMouseEvent *e) {
int x,y;
int *a,b;

x=e->x();
y=e->y();

}

void Image2::mouseMoveEvent(QMouseEvent *e) {
int x,y,sz,nx;
float *d,az,r,a=0,c=0,scale;

x=e->x();
y=e->y();

sz=width()<height()?width():height();
if (data) scale=(float)sz/(float)data->xSize();
else scale=1.0;

if ((e->state()&RightButton) && data) {
	r=floor(hypot(x-(sz/2+1-scale/2),y-(height()-sz/2+1)))/scale;
	if (r<1.0||r>=data->ySize()/2) return;
	nx=data->xSize();
	d=data->getDataRO();

	a=0;
	for (az=0; az<PI; az+=1.0/(r*PI)) {
		x=(int)floor(r*sin(az))*2;
		y=(int)floor(r*cos(az)+data->ySize()/2);
		a+=d[x+y*nx];
		c+=1.0;
//		if (d[x+y*nx]>a) a=d[x+y*nx];
	}
	data->doneData();
	data->ufloat=1.4*a/c;
	needupd=1;
	update();
	return;
}
else if ((e->state()&MidButton)) {
	rrad2=floor(hypot(x-(sz/2+1-scale/2),y-(height()-sz/2+1)));
	if (rrad2>rad) rrad2=rad;
	ang=atan2(y-(height()-sz/2+1),x-(sz/2+1-scale/2))*180.0/PI;
	emit(sChange(rad/scale,rrad2/scale,ang));
	update();
}
else {
	rad=rrad2=floor(hypot(x-(sz/2+1-scale/2),y-(height()-sz/2+1)));
	ang=atan2(y-(height()-sz/2+1),x-(sz/2+1-scale/2))*180.0/PI;
	emit(sChange(rad/scale,rrad2/scale,ang));
	update();
}
}

void Image2::setRad(float r,float r2,float a) {
int sz;
float scale;

if (!data) { rad=-1; return; }
sz=width()<height()?width():height();
scale=(float)sz/(float)data->xSize();

rad=r*scale;
rrad2=r2*scale;
ang=a;
update();
//printf("%f\n",r*scale);
}

void Image2::print(QPaintDevice *dev) {
int x,y;

update();
}

void Image2::setAngle(float nphi,float nalt, float naz) {

alt=nalt*PI/180.0;
az=naz*PI/180.0;
phi=nphi*PI/180.0;
needupd=1;
update();
}

void Image2::setMode(int val) { 
	if ((val==6 && mode!=7) ||(val!=6 && mode==7)) data->toCorner();
	mode=val+1; 
	needupd=1; 
	update(); 
}


void Image2::setData(EMData *d) {
data=d; 
if (d && data->ufloat==0) data->ufloat=data->Max();
needupd=1;
update();
}

void Image2::mouseDoubleClickEvent(QMouseEvent *e) { };
void Image2::mouseEnter(int) { };
void Image2::mouseLeave(int) { };
void Image2::keyPressEvent(QKeyEvent *) { };
void Image2::keyReleaseEvent(QKeyEvent *) { };


void Image2::imageChanged() { }
