
#include "UnixToWin.h"
#include <math.h>



// This variable causes windows to default to binary mode for reading and writing files this is the same as changing 
// all the occurences of fopen(infile, "r") to fopen(infile,"rb")
extern int _fmode=_O_BINARY; 




//  The  copysign()  function returns a value whose absolute value 
//  matches a, but whose sign matches that of b.
//  Designed to match the similar function found in math.h in UNIX

float copysign(float a,float b){
	float flip = 1.0f;
	if ((a <= 0 && b <= 0) || ( a > 0 && b > 0)) { flip=1.0f; }
	else {flip = -1.0f;}
	return a*flip;
}





double erfc(double x)
{
///////////////////////////////////////////////////////////////////////////////
// Computation of the complementary error function erfc(x).
//
// The algorithm is based on a Chebyshev fit as denoted in
// Numerical Recipes 2nd ed. on p. 214 (W.H.Press et al.).
//
// The fractional error is always less than 1.2e-7.
//
//--- Nve 14-nov-1998 UU-SAP Utrecht
///////////////////////////////////////////////////////////////////////////////

  // The parameters of the Chebyshev fit
  const double   a1 = -1.26551223,   a2 = 1.00002368,
                 a3 =  0.37409196,   a4 = 0.09678418,
                 a5 = -0.18628806,   a6 = 0.27886807,
                 a7 = -1.13520398,   a8 = 1.48851587,
                 a9 = -0.82215223,  a10 = 0.17087277;

  double v = 1; // The return value
  double z = fabs(x);

  if (z <= 0) return v; // erfc(0)=1

  double t = 1/(1+0.5*z);

  v = t*exp((-z*z) +a1+t*(a2+t*(a3+t*(a4+t*(a5+t*(a6+t*(a7+t*(a8+t*(a9+t*a10)))))))));

  if (x < 0) v = 2-v; // erfc(-x)=2-erfc(x)

  return v;
}


