(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     46254,       1467]*)
(*NotebookOutlinePosition[     46891,       1490]*)
(*  CellTagsIndexPosition[     46847,       1486]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    \(Integrate[
      E^\((\(-\((x^4)\)\)\ 8.888)\)\ Cos[2\ Pi\ x\ k], {x, \(-Infinity\), 
        Infinity}]\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{
      \(Im[k] == 0\), ",", 
        \(1.04990515451249533`\ 
            HypergeometricPFQ[{}, {1\/2, 3\/4}, 0.684976168949724595`\ k\^4]
               - 2.34952735848058624`\ k\^2\ 
            HypergeometricPFQ[{}, {3\/2, 5\/4}, 0.684976168949724595`\ k\^4]
              \), ",", 
        RowBox[{
          SubsuperscriptBox["\[Integral]", 
            InterpretationBox[\(-\[Infinity]\),
              DirectedInfinity[ -1]], 
            InterpretationBox["\[Infinity]",
              DirectedInfinity[ 1]]], 
          \(\(E\^\(\(-8.8879999999999999`\)\ x\^4\)\ Cos[2\ k\ \[Pi]\ x]\) 
            \[DifferentialD]x\)}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Integrate[
      E^\((\(-\((x^2)\)\) 8)\)\ Cos[2\ Pi\ x\ k], {x, \(-Infinity\), 
        Infinity}]\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{
      \(Im[k] == 0\), ",", 
        \(1\/2\ E\^\(\(-\(1\/8\)\)\ k\^2\ \[Pi]\^2\)\ \@\(\[Pi]\/2\)\), ",", 
        RowBox[{
          SubsuperscriptBox["\[Integral]", 
            InterpretationBox[\(-\[Infinity]\),
              DirectedInfinity[ -1]], 
            InterpretationBox["\[Infinity]",
              DirectedInfinity[ 1]]], 
          \(\(E\^\(\(-8\)\ x\^2\)\ Cos[2\ k\ \[Pi]\ x]\) 
            \[DifferentialD]x\)}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[{
        1.04990515451249533`\ 
            HypergeometricPFQ[{}, {1\/2, 3\/4}, 0.684976168949724595`\ k\^4]
               - 2.34952735848058624`\ k\^2\ 
            HypergeometricPFQ[{}, {3\/2, 5\/4}, 0.684976168949724595`\ k\^4], 
        E\^\(\(-1.2337\) k\^2\)\ }, {k, 2, 4}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928572 0.476191 0.0907333 33.803 [
[.2619 .07823 -9 -9 ]
[.2619 .07823 9 0 ]
[.5 .07823 -3 -9 ]
[.5 .07823 3 0 ]
[.7381 .07823 -9 -9 ]
[.7381 .07823 9 0 ]
[.97619 .07823 -3 -9 ]
[.97619 .07823 3 0 ]
[.01131 .00623 -42 -4.5 ]
[.01131 .00623 0 4.5 ]
[.01131 .17524 -36 -4.5 ]
[.01131 .17524 0 4.5 ]
[.01131 .25975 -30 -4.5 ]
[.01131 .25975 0 4.5 ]
[.01131 .34426 -36 -4.5 ]
[.01131 .34426 0 4.5 ]
[.01131 .42876 -24 -4.5 ]
[.01131 .42876 0 4.5 ]
[.01131 .51327 -36 -4.5 ]
[.01131 .51327 0 4.5 ]
[.01131 .59778 -30 -4.5 ]
[.01131 .59778 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .09073 m
.2619 .09698 L
s
[(2.5)] .2619 .07823 0 1 Mshowa
.5 .09073 m
.5 .09698 L
s
[(3)] .5 .07823 0 1 Mshowa
.7381 .09073 m
.7381 .09698 L
s
[(3.5)] .7381 .07823 0 1 Mshowa
.97619 .09073 m
.97619 .09698 L
s
[(4)] .97619 .07823 0 1 Mshowa
.125 Mabswid
.07143 .09073 m
.07143 .09448 L
s
.11905 .09073 m
.11905 .09448 L
s
.16667 .09073 m
.16667 .09448 L
s
.21429 .09073 m
.21429 .09448 L
s
.30952 .09073 m
.30952 .09448 L
s
.35714 .09073 m
.35714 .09448 L
s
.40476 .09073 m
.40476 .09448 L
s
.45238 .09073 m
.45238 .09448 L
s
.54762 .09073 m
.54762 .09448 L
s
.59524 .09073 m
.59524 .09448 L
s
.64286 .09073 m
.64286 .09448 L
s
.69048 .09073 m
.69048 .09448 L
s
.78571 .09073 m
.78571 .09448 L
s
.83333 .09073 m
.83333 .09448 L
s
.88095 .09073 m
.88095 .09448 L
s
.92857 .09073 m
.92857 .09448 L
s
.25 Mabswid
0 .09073 m
1 .09073 L
s
.02381 .00623 m
.03006 .00623 L
s
[(-0.0025)] .01131 .00623 1 0 Mshowa
.02381 .17524 m
.03006 .17524 L
s
[(0.0025)] .01131 .17524 1 0 Mshowa
.02381 .25975 m
.03006 .25975 L
s
[(0.005)] .01131 .25975 1 0 Mshowa
.02381 .34426 m
.03006 .34426 L
s
[(0.0075)] .01131 .34426 1 0 Mshowa
.02381 .42876 m
.03006 .42876 L
s
[(0.01)] .01131 .42876 1 0 Mshowa
.02381 .51327 m
.03006 .51327 L
s
[(0.0125)] .01131 .51327 1 0 Mshowa
.02381 .59778 m
.03006 .59778 L
s
[(0.015)] .01131 .59778 1 0 Mshowa
.125 Mabswid
.02381 .02313 m
.02756 .02313 L
s
.02381 .04003 m
.02756 .04003 L
s
.02381 .05693 m
.02756 .05693 L
s
.02381 .07383 m
.02756 .07383 L
s
.02381 .10763 m
.02756 .10763 L
s
.02381 .12454 m
.02756 .12454 L
s
.02381 .14144 m
.02756 .14144 L
s
.02381 .15834 m
.02756 .15834 L
s
.02381 .19214 m
.02756 .19214 L
s
.02381 .20904 m
.02756 .20904 L
s
.02381 .22595 m
.02756 .22595 L
s
.02381 .24285 m
.02756 .24285 L
s
.02381 .27665 m
.02756 .27665 L
s
.02381 .29355 m
.02756 .29355 L
s
.02381 .31045 m
.02756 .31045 L
s
.02381 .32735 m
.02756 .32735 L
s
.02381 .36116 m
.02756 .36116 L
s
.02381 .37806 m
.02756 .37806 L
s
.02381 .39496 m
.02756 .39496 L
s
.02381 .41186 m
.02756 .41186 L
s
.02381 .44566 m
.02756 .44566 L
s
.02381 .46257 m
.02756 .46257 L
s
.02381 .47947 m
.02756 .47947 L
s
.02381 .49637 m
.02756 .49637 L
s
.02381 .53017 m
.02756 .53017 L
s
.02381 .54707 m
.02756 .54707 L
s
.02381 .56398 m
.02756 .56398 L
s
.02381 .58088 m
.02756 .58088 L
s
.02381 .61468 m
.02756 .61468 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .49615 m
.03279 .52687 L
.04262 .5541 L
.05288 .57572 L
.06244 .58999 L
.06792 .59575 L
.07062 .59797 L
.0731 .59966 L
.07532 .60089 L
.07775 .60195 L
.07894 .60235 L
.0802 .60271 L
.08091 .60287 L
.08155 .60299 L
.0828 .60318 L
.08351 .60325 L
.08414 .60329 L
.08488 .60332 L
.08557 .60332 L
.08681 .60326 L
.0875 .6032 L
.08814 .60312 L
.08949 .60289 L
.09097 .60254 L
.09252 .60207 L
.09397 .60153 L
.09909 .59889 L
.10196 .59693 L
.10458 .59485 L
.11449 .58458 L
.12366 .572 L
.14443 .53437 L
.18369 .43959 L
.22144 .33646 L
.26165 .23115 L
.30033 .14555 L
.31998 .11008 L
.34147 .078 L
.362 .05396 L
.3811 .03717 L
.39162 .0301 L
.40155 .02475 L
.41047 .021 L
.41547 .01931 L
.42014 .01798 L
.42509 .01683 L
.42961 .01601 L
.43463 .01535 L
.43739 .01508 L
.43877 .01498 L
Mistroke
.44002 .0149 L
.44123 .01484 L
.44255 .01478 L
.44327 .01476 L
.44394 .01474 L
.44524 .01472 L
.44637 .01472 L
.4476 .01472 L
.44889 .01474 L
.45009 .01477 L
.45077 .01479 L
.45151 .01482 L
.45286 .01489 L
.45539 .01505 L
.45834 .0153 L
.46106 .01559 L
.47071 .01704 L
.47976 .01896 L
.50038 .02496 L
.53912 .0403 L
.58031 .05859 L
.61999 .0748 L
.65815 .08723 L
.6778 .09214 L
.69876 .09624 L
.70903 .09783 L
.72015 .09925 L
.72976 .10024 L
.74031 .10108 L
.74528 .1014 L
.75061 .10168 L
.75521 .10188 L
.76023 .10205 L
.76316 .10213 L
.76588 .10219 L
.76847 .10223 L
.7698 .10225 L
.77124 .10227 L
.77252 .10228 L
.7737 .10229 L
.77482 .1023 L
.77601 .1023 L
.77731 .10231 L
.77853 .10231 L
.77922 .1023 L
.77986 .1023 L
.78059 .1023 L
.78128 .1023 L
.78243 .10229 L
.78367 .10228 L
Mistroke
.7859 .10226 L
.78856 .10222 L
.79099 .10218 L
.79626 .10207 L
.80127 .10193 L
.81009 .10162 L
.81972 .10119 L
.86038 .09871 L
.89953 .09588 L
.94113 .0931 L
.97619 .09125 L
Mfstroke
.02381 .33384 m
.04262 .2904 L
.06244 .25231 L
.08426 .21812 L
.10458 .19233 L
.14264 .15644 L
.16305 .14241 L
.18163 .1321 L
.20239 .12285 L
.22156 .11605 L
.25997 .10626 L
.2787 .1029 L
.29932 .09999 L
.31873 .09786 L
.33961 .09609 L
.36075 .09472 L
.38084 .09374 L
.40064 .09299 L
.41903 .09246 L
.43955 .09201 L
.45816 .0917 L
.4774 .09145 L
.49822 .09126 L
.51816 .09112 L
.53923 .09101 L
.55887 .09093 L
.5772 .09088 L
.59755 .09084 L
.61611 .09081 L
.63519 .09079 L
.65595 .09077 L
.67573 .09076 L
.69674 .09075 L
.71621 .09075 L
.73449 .09074 L
.75467 .09074 L
.77317 .09074 L
.7921 .09074 L
.80282 .09074 L
.8128 .09074 L
.82332 .09074 L
.83326 .09073 L
.85184 .09073 L
.86156 .09073 L
.87186 .09073 L
.89031 .09073 L
.89975 .09073 L
.90988 .09073 L
.9282 .09073 L
.93833 .09073 L
Mistroke
.94937 .09073 L
.96947 .09073 L
.97619 .09073 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{408, 252},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006H0000o0P10`40000100000?l0003o0?oo0000
ool0o`3ooooooeEEELIaLG76LHj>>75aaXhhSSR>SZZZZTaaWH20P492@/K6aZFOP=[GbU]GA^SXj5]8
;k2<Fkfm_F21RKK5bC52A^c/k61PH0X:2Q@D51hN7RPX:3<c<cdm?DM7Ae5ADE]KFfIVIW1`L7YjNXB4
Q8j>SYVIVJ>SXjf][KNg]l71`Lc<c=KFe^3Ph>[Zj_Cdm;V>S^;@d6I>C]GEeI6ATBl_;jBTY2LW9d10
Y/300?oo]7mo03lo0=CDe5ADE000?g=cLda<C240<<30`9T0I_ooc000_k:b/P20P800082006IVc3<c
IP2009VIod:JYb8R8_mV<`00P00g??mVc<C4a000O`0o000o?`0oO`0o_`0oo`1o001o?`1oO`1o_`1o
o`2o002o?`2oO`2o_`2oo`3o?`3oO`3o_cl003l0?cl0Ocl0_cl0oclo?cloOclo_cloocmo03mo?cmo
Ocmo_cmoocno03no?cnoOcno_cnoocoo03oo?cooOcoo_cooogl007l0?gl0Ogl0_gl0oglo07lo?glo
Oglo_gloogmo?gmoOgmo_gmoogno07no?gnoOgno_gnoogoo07oo?gooOgoo_goookl00;l0?kl0Okl0
_kl0oklo0;lo?kloOklo_klookmo0;mo?kmoOkmo_kmookno0;no?knoOkno_knookoo0;oo?kooOkoo
_kooool0?ol0Ool0_olo0?lo?oloOolo_olooomo0?mo?omoOomo_omooono0?no?onoOono_onooooo
?oooOooo_gAdM:NWYg<7iZb/[>KViUIFE/k>cT];Ba0@400d00XHF`iK:GX<3>7QhBDU9IeiNN[MgEa7
Ah:2PX]ZJRXZ:X61PL;2`W9bL/`0c<`0ol`c0<`c<l`cI/`cVL`cc<`colaV0<aV<laVI/aVVLaVc<aV
olbI0<bI<lbII/bIVLbIc<bIolc<0<c<<lc<I/c<VLc<ool7V@L00?l7V@L00?l7V@L00?l7V@L00?l7
V@L00?l7V@L00?l7V@L00?l7V@L00?l7V@L00?l7V@L00?l7V@L00?l7V@L00?l7V@L002h700<01`L0
o`MX1`0020L200@700<01`L00`L200@70P031`@00PL300H700<01`L0o`MX1`001`L010071`081`04
00L7008700@01`L00PL00`071`061`0300L700<70`3o1fP700071`0400L700P700@01`L00PL01007
1`031`0300L700D700<01`L00`L00`071`3o1fP700000`L00002008700@01`L020L010071`021`04
00L700@700@01`L70`061`0300L70?l7J0L000L700@01`L020L010071`021`0400L700D700@01`L0
20L00`071`2G1`D0b`L000L700@01`L020L010071`021`0400L7008700@01`L00PL00`071`061`03
00L7090720041`P0``L000P70P0:1`8010L200@70P031`@01@L00`071`2=1`<050L30<07000^1`03
00L708/70P0J1`@0_0L002h70`281`<080L40;P7000^1`0300L708H70P0W1`80]PL002h700<01`L0
Q@L00`071`0Y1`80]0L002h700<01`L0P`L202h70`2a1`00;PL00`071`221`0300L703470P2_1`00
;PL00`071`211`0300L703@70P2]1`00;PL3080700<01`L0=`L30:X7000^1`0300L707l700<01`L0
>`L20:P7000^1`0300L707d70P101`80YPL002h700<01`L0O0L00`071`121`80Y0L002h700<01`L0
N`L00`071`151`<0X@L002h700<01`L0NPL00`071`191`80W`L002h70`1i1`0300L704`70P2M1`00
;PL00`071`1h1`0300L704l70`2J1`00;PL00`071`1g1`0300L705<70P2H1`00;PL00`071`1=1`@0
0`L00`071`021`<06PL00`071`0c1`808@L202d70P041`0300L700870`1A1`0300L700L7000^1`03
00L704d700<01`L030L00`071`0G1`0300L7038700@01`L08PL302T700@01`L02`L00`071`1>1`03
00L700L7000^1`0300L704h700<01`L02`L00`071`0F1`0300L703H700<01`L08`L202X700<01`L0
2@L00`071`1;1`D020L002h70`1?1`0300L700L70`0H1`0300L703D70P0X1`809PL200T70`1>1`04
00L700T7000^1`0300L7050700<01`L01PL00`071`0G1`0300L703P700<01`L09`L302D700<01`L0
1PL00`071`1?1`0300L000T7000^1`0300L704d700@01`L020L00`071`0F1`0300L703H700@01`L0
;0L401h700@01`L020L00`071`1@1`802@L002h700<01`L0CPL200T7100D1`0300L703P70P0a1`<0
70L200T7101@1`0300L700L7000^1`0300L7074700<01`L0KPL40847000^1`0300L7070700<01`L0
L`L307h7000^1`0300L706l700<01`L0M`L407X7000U1ol0M00002h700<01`L03`L00`071`0>1`03
00L700l700<01`L03PL00`071`0?1`0300L700l700<01`L010LG00D700<01`L03PL00`071`0?1`03
00L700h700<01`L03`L00`071`0?1`0300L700`7100@1`0300L700h700<01`L03`L00`071`0>1`l0
0`L00`071`0?1`0300L700L7000^1`0300L705D700<01`L03`L703l700<01`L0A@L700T700<01`L0
8`L>02@700<01`L01`L002h700<01`L0G`L800H700<01`L0S0L<01T72P0l1`00;PL00`071`1H1`L0
3@L00`071`2I1aT0APL002h700<01`L0D`L501<700<01`L0n@L002h70`1?1`@060L00`071`3i1`00
;PL00`071`1<1`<06`L00`071`3j1`00;PL00`071`181`@07@L00`071`3k1`00;PL00`071`151`<0
8@L00`071`3k1`00;PL00`071`111`@08`L00`071`3l1`00;PL00`071`0n1`<09`L00`071`3l1`00
;PL303`70P0Y1`0300L70?d7000^1`0300L703X70P0[1`0300L70?d7000^1`0300L703P70P0/1`03
00L70?h7000^1`0300L703L700<01`L0;0L00`071`3n1`00;PL00`071`0e1`80;PL00`071`3o1`00
;PL00`071`0d1`0300L702h700<01`L0o`L002h70`0b1`80<0L00`071`3o1`47000^1`0300L70347
00<01`L0<0L00`071`3o1`47000^1`0300L702l70P0b1`0300L70?l70PL002h700<01`L0;@L203@7
00<01`L0o`L21`00;PL00`071`0/1`0300L703<700<01`L0o`L31`00;PL00`071`0Z1`80=PL00`07
1`3o1`<7000^1`<0:@L00`071`0e1`0300L70?l710L002h700<01`L0:0L00`071`0f1`0300L70?l7
10L002h700<01`L09`L00`071`0f1`0300L70?l71@L002h700<01`L09PL00`071`0g1`0300L70?l7
1@L002h700<01`L09@L00`071`0g1`0300L70?l71PL000P70P041`0300L700<70P041`800`L40087
0`061`0300L702@700<01`L0>0L00`071`3o1`H700071`0400L700P700@01`L00PL010071`021`03
00L700H700<01`L00`L00`071`0R1`80>PL00`071`3o1`L700071`0400L700P700@01`L00PL01007
1`031`0300L700D700<01`L00`L3024700<01`L0>PL00`071`3o1`L700071`0400L700P700@01`L0
0PL010071`041`0400L71`<01PL00`071`0P1`0300L703/700<01`L0o`L71`001`L010071`081`04
00L7008700@01`L01@L010071`081`0300L701l700<01`L0>`L00`071`3o1`P700071`0400L700P7
00@01`L00PL010071`021`0400L7008700<01`L01PL00`071`0N1`0300L703`700<01`L0o`L81`00
20L200X70P041`8010L200<710051`0300L701d700<01`L0?0L00`071`3o1`T7000^1`0300L701`7
00<01`L0?@L00`071`3o1`T7000^1`<06`L00`071`0m1`0300L70?l72PL002h700<01`L06PL00`07
1`0n1`0300L70?l72PL002h700<01`L06@L00`071`0n1`0300L70?l72`L002h700<01`L06@L00`07
1`0n1`0300L70?l72`L002h700<01`L060L00`071`0o1`0300L70?l72`L002h700<01`L05`L00`07
1`0o1`0300L70?l730L002h70`0F1`0300L7040700<01`L0o`L<1`00;PL00`071`0E1`0300L70407
00<01`L0o`L=1`00;PL00`071`0E1`0300L7040700<01`L0o`L=1`00;PL00`071`0D1`0300L70407
00<01`L0o`L>1`00;PL00`071`0C1`0300L7044700<01`L0o`L>1`00;PL00`071`0B1`0300L70447
00<01`L0o`L?1`00;PL3018700<01`L0@@L00`071`3o1`l7000^1`0300L7014700<01`L0@@L00`07
1`3o1a07000^1`0300L7010700<01`L0@PL00`071`3o1a07000^1`0300L7010700<01`L0@PL00`07
1`3o1a07000^1`0300L700l700<01`L0@PL00`071`3o1a47000^1`0300L700h700<01`L0@`L00`07
1`3o1a47000^1`0300L700h700<01`L0@PL00`071`3o1a87000^1`<03@L00`071`131`0300L70?l7
4PL002h700<01`L030L00`071`141`0300L70?l74PL002h700<01`L030L00`071`131`0300L70?l7
4`L002h700<01`L02`L00`071`141`0300L70?l74`L002h700<01`L02`L00`071`141`0300L70?l7
4`L000h70P041`0300L700<70P041`800`L300H700<01`L02PL00`071`141`0300L70?l750L000d7
00@01`L020L010071`021`0400L700D700<01`L00`L300X700<01`L0A0L00`071`3o1a@7000=1`04
00L700P700@01`L00PL010071`051`0300L700<700<01`L02@L00`071`141`0300L70?l75@L000d7
00@01`L020L010071`021`0400L700870`061`0300L700T700<01`L0A0L00`071`3o1aD7000=1`04
00L700P700@01`L00PL010071`021`0300L700H700<01`L020L00`071`151`0300L70?l75@L000d7
00@01`L020L010071`021`0400L7008700<01`L01PL00`071`081`0300L704@700<01`L0o`LF1`00
3PL200X70P041`800`L400D700<01`L01`L00`071`151`0300L70?l75PL002h70`071`0300L704@7
00<01`L0o`LG1`00;PL00`071`061`0300L704D700<01`L0o`LG1`00;PL00`071`061`0300L704D7
00<01`L0o`LG1`00;PL00`071`051`0300L704D700<01`L0o`LH1`00;PL00`071`051`0300L704D7
00<01`L0o`LH1`00;PL00`071`041`0300L704H700<01`L0o`LH1`00;PL300@700<01`L0A@L00`07
1`3o1aT7000^1`0300L700<700<01`L0APL00`071`3o1aT7000^1`0300L700<700<01`L0A@L00`07
1`3o1aX7000^1`0300L7008700<01`L0APL00`071`3o1aX7000^1`0300L7008700<01`L0APL00`07
1`3o1aX7000^1`0500L71`00B0L00`071`3o1a/7000^1`0500L71`00B0L00`071`3o1a/7000^1`<0
00<700L0APL00`071`3o1a`7000^1`0400L704P700<01`L0o`LL1`00;PL010071`181`0300L70?l7
70L002h700<01`00B0L00`071`3o1ad7000^1`0300L004P700<01`L0o`LM1`00;PL204T700<01`L0
o`LM1`00;PL304L700<01`L0o`LN1`00;PL00`071`171`0300L70?l77PL002h700<01`L0APL00`07
1`3o1al7000^1`0300L704H700<01`L0o`LO1`00;PL00`071`161`0300L70?l77`L000P70P041`03
00L700<70P041`8010L00`071`021`<01PL00`071`151`0300L70?l780L000L700@01`L020L01007
1`021`0400L700<700<01`L01@L00`071`031`<0A@L00`071`3o1b0700071`0400L700P700@01`L0
0PL010071`041`0300L700@700<01`L00`L00`071`151`0300L70?l780L000L700@01`L020L01007
1`021`0400L700@700@01`L70`061`0300L704@700<01`L0o`LQ1`001`L010071`081`0400L70087
00@01`L01@L010071`081`0300L704@700<01`L0o`LQ1`001`L010071`081`0400L7008700@01`L0
0PL010071`021`0300L700H700<01`L0@`L00`071`3o1b8700081`802PL200@70P031`@00PL400D7
00<01`L0@`L00`071`3o1b87000^1`<0@`L00`071`3o1b87000^1`0300L7048700<01`L0o`LS1`00
;PL00`071`121`0300L70?l78`L002h700<01`L0@PL00`071`3o1b<7000^1`0300L7044700<01`L0
o`LT1`00;PL00`071`111`0300L70?l790L002h700<01`L0@0L00`071`3o1bD7000^1`<0@0L00`07
1`3o1bD7000^1`0300L7040700<01`L0o`LU1`00;PL00`071`0o1`0300L70?l79PL002h700<01`L0
?`L00`071`3o1bH7000^1`0300L703l700<01`L0o`LV1`00;PL00`071`0n1`0300L70?l79`L002h7
0`0n1`0300L70?l79`L002h700<01`L0?PL00`071`3o1bL7000^1`0300L703d700<01`L0o`LX1`00
;PL00`071`0m1`0300L70?l7:0L002h700<01`L0?0L00`071`3o1bT7000^1`0300L703`700<01`L0
o`LY1`00;PL303`700<01`L0o`LY1`00;PL00`071`0k1`0300L70?l7:PL002h700<01`L0>`L00`07
1`3o1bX7000^1`0300L703/700<01`L0o`LZ1`00;PL00`071`0j1`0300L70?l7:`L001@70P041`03
00L700<70P031`@01@L00`071`0j1`0300L70?l7:`L001<700@01`L020L010071`041`0300L700@7
0`0i1`0300L70?l7;0L001<700@01`L020L010071`041`0300L700@700<01`L0>@L00`071`3o1b`7
000C1`0400L700P700@01`L010L00`071`041`0300L703T700<01`L0o`L/1`004`L010071`081`04
00L700@700<01`L010L00`071`0h1`0300L70?l7;@L001<700@01`L020L010071`021`<01PL00`07
1`0h1`0300L70?l7;@L001@70P0:1`801@L00`071`041`0300L703P700<01`L0o`L]1`00;PL00`07
1`0g1`0300L70?l7;PL002h70`0g1`0300L70?l7;PL002h700<01`L0=PL00`071`3o1bl7000^1`03
00L703H700<01`L0o`L_1`00;PL00`071`0f1`0300L70?l7;`L002h700<01`L0=@L00`071`3o1c07
000^1`0300L703D700<01`L0o`L`1`00;PL303@700<01`L0o`La1`00;PL00`071`0d1`0300L70?l7
<@L002h700<01`L0=0L00`071`3o1c47000^1`0300L703<700<01`L0o`Lb1`00;PL00`071`0c1`03
00L70?l7<PL002h700<01`L0<PL00`071`3o1c<7000^1`<0<PL00`071`3o1c<7000^1`0300L70387
00<01`L0o`Lc1`00;PL00`071`0a1`0300L70?l7=0L002h700<01`L0<@L00`071`3o1c@7000^1`03
00L7030700<01`L0o`Le1`00;PL00`071`0`1`0300L70?l7=@L002h70`0`1`0300L70?l7=@L002h7
00<01`L0;`L00`071`3o1cH7000^1`0300L702l700<01`L0o`Lf1`00;PL202l700<01`L0o`Lg1`00
;PL202l700<01`L0o`Lg1`0020L200@700<01`L00`L200<710021`@00PL300H70P0_1`0300L70?l7
=`L000L700@01`L020L010071`041`0500L71`0020L00`071`031`80;PL00`071`3o1cP700071`04
00L700P700@01`L010L00`071`021`0300L700D700<01`L00`L302d700<01`L0o`Lh1`001`L01007
1`081`0400L700@700<01`L00`L010071`L300H700<01`00;0L00`071`3o1cT700071`0400L700P7
00@01`L010L00`071`041`0400L700P700<01`00;0L00`071`3o1cT700071`0400L700P700@01`L0
0PL300<700@01`L00PL00`071`061`0300L002`700<01`L0o`Li1`0020L200X70P051`0300L70087
0P031`@01@L010071`0Z1`0300L70?l7>PL002h700@01`L0:PL00`071`3o1cX7000^1`@0:@L00`07
1`3o1c/7000^1`0500L71`00:0L00`071`3o1c/7000^1`0500L71`009`L00`071`3o1c`7000^1`03
00L7008700<01`L090L00`071`3o1c`7000^1`0300L7008700<01`L08`L00`071`3o1cd7000^1`03
00L7008700<01`L08`L00`071`3o1cd7000^1`<00`L00`071`0Q1`0300L70?l7?PL002h700<01`L0
0`L00`071`0Q1`0300L70?l7?PL002h700<01`L010L00`071`0O1`0300L70?l7?`L002h700<01`L0
10L00`071`0N1`0300L70?l7@0L002h700<01`L010L00`071`0N1`0300L70?l7@0L002h700<01`L0
1@L00`071`0L1`0300L70?l7@@L002h70`051`0300L701`700<01`L0o`M11`00;PL00`071`061`03
00L701X700<01`L0o`M21`00;PL00`071`061`0300L701X700<01`L0o`M21`00;PL00`071`071`03
00L701P700<01`L0o`M31`00;PL00`071`071`0300L701L700<01`L0o`M41`00;PL00`071`081`03
00L701H700<01`L0o`M41`00;PL300T700<01`L050L00`071`3o1dD7000^1`0300L700T700<01`L0
50L00`071`3o1dD7000^1`0300L700X700<01`L04PL00`071`3o1dH7000^1`0300L700X700<01`L0
4@L00`071`3o1dL7000^1`0300L700/700<01`L03`L00`071`3o1dP7000>1`8010L00`071`031`80
0`L400870`061`0300L700`700<01`L03@L00`071`3o1dT7000=1`0400L700P700@01`L010L00`07
1`041`0300L700<700<01`L03@L00`071`0:1`80o`M<1`003@L010071`081`0400L700@700<01`L0
10L00`071`031`<03PL200P70P3o1dh7000=1`0400L700P700@01`L010L010071`L300H700<01`L0
40L200@70P3o1e07000=1`0400L700P700@01`L010L01@071`L000P700<01`L04PL40?l7DPL000d7
00@01`L020L010071`021`<00`L00`071`061`0300L70?l7J0L000h70P0:1`801@L010071`L400D7
00<01`L0o`MX1`00;PL00`071`3o1fP7000^1`<0o`MX1`00;PL00`071`3o1fP7003o1iT7003o1iT7
003o1iT7003o1iT7003o1iT7003o1iT7003o1iT7003o1iT7003o1iT7003o1iT70000\
\>"],
  ImageRangeCache->{{{0, 407}, {251, 0}} -> {1.73483, -0.00368749, 0.0056884, 
  8.01339*^-5}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[{\ E\^\(\(-2\) x^2\), E^\((\(-\((x^4)\)\) 1.8)\)}, {x, \(-2\), 2}]
      \)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.0147151 0.588604 [
[.02381 .00222 -6 -9 ]
[.02381 .00222 6 0 ]
[.2619 .00222 -6 -9 ]
[.2619 .00222 6 0 ]
[.7381 .00222 -3 -9 ]
[.7381 .00222 3 0 ]
[.97619 .00222 -3 -9 ]
[.97619 .00222 3 0 ]
[.4875 .13244 -18 -4.5 ]
[.4875 .13244 0 4.5 ]
[.4875 .25016 -18 -4.5 ]
[.4875 .25016 0 4.5 ]
[.4875 .36788 -18 -4.5 ]
[.4875 .36788 0 4.5 ]
[.4875 .4856 -18 -4.5 ]
[.4875 .4856 0 4.5 ]
[.4875 .60332 -6 -4.5 ]
[.4875 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
[(-2)] .02381 .00222 0 1 Mshowa
.2619 .01472 m
.2619 .02097 L
s
[(-1)] .2619 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(1)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(2)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.5 .13244 m
.50625 .13244 L
s
[(0.2)] .4875 .13244 1 0 Mshowa
.5 .25016 m
.50625 .25016 L
s
[(0.4)] .4875 .25016 1 0 Mshowa
.5 .36788 m
.50625 .36788 L
s
[(0.6)] .4875 .36788 1 0 Mshowa
.5 .4856 m
.50625 .4856 L
s
[(0.8)] .4875 .4856 1 0 Mshowa
.5 .60332 m
.50625 .60332 L
s
[(1)] .4875 .60332 1 0 Mshowa
.125 Mabswid
.5 .04415 m
.50375 .04415 L
s
.5 .07358 m
.50375 .07358 L
s
.5 .10301 m
.50375 .10301 L
s
.5 .16187 m
.50375 .16187 L
s
.5 .1913 m
.50375 .1913 L
s
.5 .22073 m
.50375 .22073 L
s
.5 .27959 m
.50375 .27959 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .33845 m
.50375 .33845 L
s
.5 .39731 m
.50375 .39731 L
s
.5 .42674 m
.50375 .42674 L
s
.5 .45617 m
.50375 .45617 L
s
.5 .51503 m
.50375 .51503 L
s
.5 .54446 m
.50375 .54446 L
s
.5 .57389 m
.50375 .57389 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01491 m
.03279 .01498 L
.04262 .01508 L
.05288 .01522 L
.06244 .0154 L
.0731 .01566 L
.0828 .01598 L
.094 .01647 L
.10458 .01708 L
.11428 .01781 L
.12455 .01879 L
.14299 .02128 L
.1524 .02301 L
.16253 .0253 L
.18083 .0309 L
.19093 .03496 L
.20196 .04035 L
.22205 .05328 L
.24173 .07066 L
.2627 .09544 L
.28411 .1284 L
.30428 .16709 L
.34283 .26095 L
.38383 .38036 L
.42332 .49306 L
.44318 .53996 L
.46129 .57302 L
.47131 .58648 L
.47591 .5914 L
.4808 .59572 L
.48328 .59754 L
.48601 .59927 L
.48852 .60059 L
.49082 .60157 L
.49353 .60245 L
.49495 .60279 L
.49567 .60293 L
.49644 .60306 L
.49775 .60321 L
.49896 .6033 L
.4997 .60332 L
.50041 .60332 L
.50172 .60326 L
.50287 .60315 L
.50411 .60297 L
.50528 .60274 L
.50635 .60248 L
.50896 .60165 L
.51144 .60061 L
.51636 .59778 L
Mistroke
.52173 .59359 L
.53131 .58331 L
.54018 .57072 L
.56075 .53147 L
.57937 .48603 L
.61949 .37041 L
.65809 .25844 L
.67767 .20798 L
.69914 .15999 L
.71984 .1217 L
.73868 .09359 L
.75823 .0707 L
.77916 .05237 L
.79828 .04022 L
.80908 .03495 L
.81906 .03094 L
.83776 .02523 L
.8484 .02284 L
.85838 .02105 L
.86823 .01964 L
.8786 .01846 L
.88831 .0176 L
.89712 .01697 L
.90669 .01644 L
.9169 .01599 L
.92636 .01568 L
.93528 .01545 L
.94502 .01526 L
.95533 .01511 L
.96413 .01501 L
.97379 .01493 L
.97619 .01491 L
Mfstroke
.02381 .01472 m
.02499 .01472 L
.02605 .01472 L
.02729 .01472 L
.02846 .01472 L
.02954 .01472 L
.03053 .01472 L
.03163 .01472 L
.03279 .01472 L
.03395 .01472 L
.0352 .01472 L
.03638 .01472 L
.03746 .01472 L
.03873 .01472 L
.04011 .01472 L
.04141 .01472 L
.04262 .01472 L
.04386 .01472 L
.04521 .01472 L
.04648 .01472 L
.04765 .01472 L
.04987 .01472 L
.05099 .01472 L
.05221 .01472 L
.05355 .01472 L
.05477 .01472 L
.05617 .01472 L
.05751 .01472 L
.05987 .01472 L
.06121 .01472 L
.06244 .01472 L
.06486 .01472 L
.06621 .01472 L
.06745 .01472 L
.06974 .01472 L
.0709 .01472 L
.07216 .01472 L
.07484 .01472 L
.07634 .01472 L
.07771 .01472 L
.07898 .01472 L
.08037 .01472 L
.08288 .01472 L
.08422 .01472 L
.08549 .01472 L
.08699 .01472 L
.08836 .01472 L
.09116 .01472 L
.0927 .01472 L
.09417 .01472 L
Mistroke
.09675 .01472 L
.09915 .01472 L
.10178 .01472 L
.10325 .01472 L
.10458 .01472 L
.10691 .01472 L
.10947 .01472 L
.11214 .01472 L
.11463 .01472 L
.11696 .01472 L
.11909 .01472 L
.12154 .01472 L
.12386 .01472 L
.12638 .01473 L
.12905 .01473 L
.13134 .01473 L
.13385 .01474 L
.13655 .01475 L
.13945 .01476 L
.14219 .01478 L
.1447 .01479 L
.14945 .01484 L
.15211 .01488 L
.15453 .01492 L
.15678 .01496 L
.15923 .01502 L
.16366 .01517 L
.16616 .01528 L
.1689 .01542 L
.17158 .01559 L
.17444 .0158 L
.17958 .01632 L
.18437 .01698 L
.18965 .01797 L
.19453 .0192 L
.19989 .02098 L
.20559 .02347 L
.21052 .02624 L
.21515 .02945 L
.22019 .03371 L
.2257 .03942 L
.23552 .0527 L
.24586 .07162 L
.26436 .11939 L
.28395 .18841 L
.30489 .27611 L
.32478 .36186 L
.34635 .4455 L
.36713 .50903 L
.37703 .53256 L
Mistroke
.3863 .55073 L
.39609 .56611 L
.40504 .57712 L
.41498 .58635 L
.42016 .59007 L
.42567 .59334 L
.43084 .59583 L
.43553 .59765 L
.44029 .59914 L
.44467 .60024 L
.4498 .60123 L
.45535 .60201 L
.46024 .6025 L
.4627 .60268 L
.4654 .60285 L
.46792 .60297 L
.47065 .60307 L
.47323 .60315 L
.47562 .6032 L
.47776 .60324 L
.48013 .60327 L
.48132 .60328 L
.48261 .60329 L
.48373 .6033 L
.48493 .6033 L
.48624 .60331 L
.48747 .60331 L
.48822 .60331 L
.48892 .60331 L
.49025 .60332 L
.49092 .60332 L
.49164 .60332 L
.49293 .60332 L
.49365 .60332 L
.49432 .60332 L
.49505 .60332 L
.49584 .60332 L
.49713 .60332 L
.49785 .60332 L
.49853 .60332 L
.49976 .60332 L
.50107 .60332 L
.50236 .60332 L
.50358 .60332 L
.50467 .60332 L
.50585 .60332 L
.5071 .60332 L
.50823 .60332 L
.50954 .60332 L
.51078 .60331 L
Mistroke
.51193 .60331 L
.51299 .60331 L
.51415 .60331 L
.51539 .6033 L
.51662 .60329 L
.51795 .60328 L
.52036 .60326 L
.52183 .60324 L
.52322 .60322 L
.52584 .60317 L
.52837 .60311 L
.53106 .60301 L
.53361 .6029 L
.53592 .60277 L
.53864 .60258 L
.54158 .60233 L
.54692 .60172 L
.55183 .60094 L
.55642 .59999 L
.56145 .59864 L
.56685 .59677 L
.57251 .59428 L
.57787 .59132 L
.58791 .58395 L
.59756 .5742 L
.60781 .56042 L
.62623 .5253 L
.63559 .50179 L
.64569 .47204 L
.66397 .40735 L
.7051 .2332 L
.72561 .15262 L
.73562 .11946 L
.74471 .0937 L
.75354 .07287 L
.76312 .05488 L
.77325 .04065 L
.77818 .03528 L
.7828 .03108 L
.79226 .0246 L
.79728 .02213 L
.80267 .02007 L
.80831 .01845 L
.81366 .01732 L
.81847 .01657 L
.82371 .01597 L
.82627 .01575 L
.82904 .01554 L
.83147 .0154 L
.83405 .01527 L
Mistroke
.83638 .01517 L
.83893 .01508 L
.84341 .01496 L
.84616 .0149 L
.84866 .01486 L
.85135 .01483 L
.85427 .0148 L
.85697 .01478 L
.85947 .01477 L
.86204 .01475 L
.8644 .01475 L
.86661 .01474 L
.86904 .01473 L
.87148 .01473 L
.87404 .01473 L
.87631 .01472 L
.87873 .01472 L
.88102 .01472 L
.88309 .01472 L
.88574 .01472 L
.88818 .01472 L
.89086 .01472 L
.8937 .01472 L
.89616 .01472 L
.89846 .01472 L
.90099 .01472 L
.90241 .01472 L
.9037 .01472 L
.90598 .01472 L
.90849 .01472 L
.90976 .01472 L
.91112 .01472 L
.9123 .01472 L
.91359 .01472 L
.91592 .01472 L
.91719 .01472 L
.91837 .01472 L
.92049 .01472 L
.92275 .01472 L
.92415 .01472 L
.92543 .01472 L
.92682 .01472 L
.92834 .01472 L
.9309 .01472 L
.93231 .01472 L
.93362 .01472 L
.93489 .01472 L
.93611 .01472 L
.93838 .01472 L
.93965 .01472 L
Mistroke
.94083 .01472 L
.94213 .01472 L
.9435 .01472 L
.94456 .01472 L
.94571 .01472 L
.94774 .01472 L
.94889 .01472 L
.95012 .01472 L
.95233 .01472 L
.9534 .01472 L
.95457 .01472 L
.95559 .01472 L
.95668 .01472 L
.95766 .01472 L
.95874 .01472 L
.96065 .01472 L
.96163 .01472 L
.96266 .01472 L
.96451 .01472 L
.96554 .01472 L
.96649 .01472 L
.96761 .01472 L
.96867 .01472 L
.96958 .01472 L
.97057 .01472 L
.9723 .01472 L
.97329 .01472 L
.97433 .01472 L
.97619 .01472 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{416, 257},
  ImageMargins->{{44, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006P00010@P10`40000100000?l0003o0?oo0000
ool0o`3ooooooeEEELIaLG76LHj>>75aaXhhSSR>SZZZZTaaWH20P492@/K6aZFOP=[GbU]GA^SXj5]8
;k2<Fkfm_F21RKK5bC52A^c/k61PH0X:2Q@D51hN7RPX:3<c<cdm?DM7Ae5ADE]KFfIVIW1`L7YjNXB4
Q8j>SYVIVJ>SXjf][KNg]l71`Lc<c=KFe^3Ph>[Zj_Cdm;V>S^;@d6I>C]GEeI6ATBl_;jBTY2LW9d10
Y/300?oo]7mo03lo0=CDe5ADE000?g=cLda<C240<<30`9T0I_ooc000_k:b/P20P800082006IVc3<c
IP2009VIod:JYb8R8_mV<`00P00g??mVc<C4a000O`0o000o?`0oO`0o_`0oo`1o001o?`1oO`1o_`1o
o`2o002o?`2oO`2o_`2oo`3o?`3oO`3o_cl003l0?cl0Ocl0_cl0oclo?cloOclo_cloocmo03mo?cmo
Ocmo_cmoocno03no?cnoOcno_cnoocoo03oo?cooOcoo_cooogl007l0?gl0Ogl0_gl0oglo07lo?glo
Oglo_gloogmo?gmoOgmo_gmoogno07no?gnoOgno_gnoogoo07oo?gooOgoo_goookl00;l0?kl0Okl0
_kl0oklo0;lo?kloOklo_klookmo0;mo?kmoOkmo_kmookno0;no?knoOkno_knookoo0;oo?kooOkoo
_kooool0?ol0Ool0_olo0?lo?oloOolo_olooomo0?mo?omoOomo_omooono0?no?onoOono_onooooo
?oooOooo_gAdM:NWYg<7iZb/[>KViUIFE/k>cT];Ba0@400d00XHF`iK:GX<3>7QhBDU9IeiNN[MgEa7
Ah:2PX]ZJRXZ:X61PL;2`W9bL/`0c<`0ol`c0<`c<l`cI/`cVL`cc<`colaV0<aV<laVI/aVVLaVc<aV
olbI0<bI<lbII/bIVLbIc<bIolc<0<c<<lc<I/c<VLc<ool7X@L00?l7X@L00?l7X@L00?l7X@L00147
101L1`@0^0L405/7100@1`004@L00`071`1O1`0300L70;T700<01`L0FPL00`071`0A1`004PL00`07
1`1N1`0300L70;T700<01`L0F`L00`071`0@1`002`L400@700<01`L0E@L400@700<01`L0^@L00`07
1`1L1`0300L700l7000D1`0300L705`700<01`L0^@L00`071`1M1`0300L700h7000A1`0400L705`7
0`1K1`0300L705/70`1L1`0400L70107000B1`80G`L00`071`1I1`0300L705d700<01`L0F`L20147
003?1`0300L70<h7003?1`0300L70<h7003?1`0300L70<h7003?1`0300L70<h700061ol0U0071`00
40L00`071`0@1`0300L700`72P0=1`0300L700H710061`0300L7014700<01`L040L00`071`0@1`03
00L7010700<01`L040L00`071`0@1`0300L7010700<01`L040L00`071`0@1`0300L7010700<01`L0
4@L00`071`0@1`0300L700D710071`0300L700T7300>1`0300L7010700<01`L03`L0010700<01`L0
:@L601@70P0H1`0300L705`700<01`L0G@L00`071`0C1`D04`L402d700<01`L03`L00487100B1`80
M@L00`071`1b1`0300L7018710131`00APL401070P1c1`0300L707070P0A1`@0A`L004X7100>1`80
L@L00`071`1_1`0300L700d7101;1`00CPL200h700<01`L0KPL00`071`1^1`0300L700/70`1?1`00
D0L200d700<01`L0K@L00`071`1^1`0300L700T70P1B1`00DPL200`700<01`L0K0L00`071`1]1`03
00L700P70P1D1`00E0L200/700<01`L0J`L00`071`1/1`0300L700L70P1F1`00EPL200X700<01`L0
JPL00`071`1[1`0300L700L700<01`L0EPL005P70P081`0300L706X70`1Z1`0300L700H70P1I1`00
FPL200L700<01`L0J@L00`071`1Z1`0300L700@70P1K1`00G0L200H700<01`L0J0L00`071`1Y1`03
00L700@700<01`L0F`L005h70P041`0300L706P700<01`L0J0L00`071`031`80GPL0060700<01`L0
0PL00`071`1W1`0300L706P700<01`L00PL00`071`1N1`00H@L00`071`021`0300L706H700<01`L0
I`L00`071`021`0300L705l7001R1`0500L71`00J0L00`071`1V1`0300L7008700<01`L0H0L006<7
00D01`L7001W1`0300L706H700<01`L00P1S1`00I0L010071`1W1`0300L706D700@01`L0I@L006D7
00@01`L0IPL00`071`1U1`0300L006H7001V1`0300L006H700<01`L0I0L00`07001W1`00I`L00`07
001U1`0300L706@70P1X1`00J0L206D70`1S1`80J@L006T70P1T1`0300L706<700<01`L0J0L006X7
00<01`L0HPL00`071`1R1`0300L706T7001Z1`80H`L00`071`1Q1`80J`L006/700<01`L0H@L00`07
1`1Q1`0300L706X7001[1`80HPL00`071`1P1`80K0L006`70P1Q1`0300L705l70P1]1`00K0L00`07
001P1`0300L705h700<01`00K@L006`700@01`L0G`L00`071`1M1`0300L006h7001]1`0400L705h7
00<01`L0G0L010071`1^1`00K@L01@071`L005d700<01`L0G0L00`07001_1`00K@L01@071`L005d7
00<01`L0F`L010071`1_1`00KPL01@071`L005`70`1J1`0500L71`00K`L006h700D01`L7001L1`03
00L705T700<01`L00PL00`071`1]1`00K`L01@071`L005/700<01`L0F@L01@071`L00707001_1`03
00L7008700<01`L0F0L00`071`1H1`0300L7008700<01`L0KPL006l700<01`L00PL00`071`1H1`03
00L705L700<01`L00`L00`071`1^1`00L0L00`071`021`0300L705L700<01`L0EPL00`071`041`03
00L706h7001`1`0300L700<700<01`L0EPL00`071`1F1`0300L700<700<01`L0K`L0070700<01`L0
0`L00`071`1F1`0300L705D700<01`L010L00`071`1_1`00L@L00`071`031`0300L705D700<01`L0
E@L00`071`041`0300L706l7001a1`0300L700<700<01`L0E@L00`071`1D1`0300L700@700<01`L0
L0L0074700<01`L010L00`071`0o1`8010L00`071`021`@01PL00`071`1D1`0300L700@700<01`L0
L0L0074700<01`L010L00`071`0n1`0400L700P700<01`L01`L00`071`1C1`0300L700@700<01`L0
L@L0078700<01`L010L00`071`0m1`0400L700T700<01`L01PL4058700<01`L010L00`071`1a1`00
LPL00`071`041`0300L703d700@01`L02PL00`071`051`0300L7058700<01`L01@L00`071`1a1`00
LPL00`071`051`0300L703`700@01`L02`L00`071`041`0300L7058700<01`L010L00`071`1b1`00
L`L00`071`041`0300L703`700@01`L020L010071`061`0300L7054700<01`L01@L00`071`1b1`00
L`L00`071`051`0300L703`70P0:1`801`L00`071`1A1`0300L700D700<01`L0LPL007<700<01`L0
1@L00`071`1A1`0300L7050700<01`L01@L00`071`1c1`00L`L00`071`061`0300L7050700<01`L0
D0L00`071`051`0300L707<7001d1`0300L700D700<01`L0D0L00`071`1?1`0300L700D700<01`L0
M0L007@700<01`L01PL00`071`1?1`0300L704l700<01`L01@L00`071`1d1`00M0L00`071`061`03
00L704l700<01`L0CPL00`071`061`0300L707@7001e1`0300L700H700<01`L0CPL00`071`1>1`03
00L700H700<01`L0M0L007D700<01`L01PL00`071`1>1`0300L704d700<01`L01PL00`071`1e1`00
M@L00`071`071`0300L704d70`1=1`0300L700H700<01`L0M@L007D700<01`L01`L00`071`1=1`03
00L704`700<01`L01`L00`071`1e1`00MPL00`071`071`0300L704`700<01`L0C0L00`071`071`03
00L707D7001f1`0300L700L700<01`L0C0L00`071`1;1`0300L700L700<01`L0MPL007H700<01`L0
20L00`071`1;1`0300L704/700<01`L01`L00`071`1f1`00M`L00`071`071`0300L704/700<01`L0
BPL00`071`081`0300L707H7001g1`0300L700P700<01`L0BPL00`071`1:1`0300L700P700<01`L0
MPL007L700<01`L020L00`071`1:1`0300L704T700<01`L020L00`071`1g1`00M`L00`071`091`03
00L704T700<01`L0B@L00`071`081`0300L707L7001h1`0300L700P700<01`L0B@L00`071`181`03
00L700T700<01`L0M`L007P700<01`L020L00`071`191`0300L704P700<01`L02@L00`071`1g1`00
N0L00`071`091`0300L704P70`171`0300L700T700<01`L0N0L007T700<01`L020L00`071`181`03
00L704L700<01`L02@L00`071`1h1`00N@L00`071`091`0300L704L700<01`L0APL00`071`0:1`03
00L707P7001i1`0300L700T700<01`L0A`L00`071`161`0300L700X700<01`L0N0L007T700<01`L0
2PL00`071`161`0300L704D700<01`L02PL00`071`1i1`00NPL00`071`091`0300L704H700<01`L0
A@L00`071`0:1`0300L707T7001j1`0300L700T700<01`L0APL00`071`141`0300L700/700<01`L0
N@L007X700<01`L02PL00`071`151`0300L704@700<01`L02`L00`071`1i1`00NPL00`071`0:1`03
00L704D700<01`L0A0L00`071`0:1`0300L707X7001k1`0300L700X700<01`L0A0L00`071`131`03
00L700/700<01`L0NPL007/700<01`L02PL00`071`141`0300L704<700<01`L02`L00`071`1j1`00
N`L00`071`0;1`0300L704<700<01`L0@PL00`071`0<1`0300L707X7001k1`0300L700/700<01`L0
@`L3048700<01`L02`L00`071`1k1`00O0L00`071`0;1`0300L7048700<01`L0@PL00`071`0;1`03
00L707/7001l1`0300L700/700<01`L0@PL00`071`111`0300L700`700<01`L0N`L007`700<01`L0
2`L00`071`121`0300L7044700<01`L030L00`071`1k1`00O0L00`071`0<1`0300L7044700<01`L0
@0L00`071`0<1`0300L707`7001m1`0300L700/700<01`L0@@L00`071`101`0300L700`700<01`L0
O0L007d700<01`L030L00`071`101`0300L7040700<01`L030L00`071`1l1`00O@L00`071`0<1`03
00L7040700<01`L0?`L00`071`0=1`0300L707`7001m1`0300L700d700<01`L0?`L00`071`0o1`03
00L700`700<01`L0O@L007h700<01`L030L00`071`0o1`0300L703h700<01`L03@L00`071`1m1`00
OPL00`071`0<1`0300L703l700<01`L0?PL00`071`0=1`0300L707d7001n1`0300L700d700<01`L0
:@L200@700<01`L010L00`071`051`0300L703h700<01`L03@L00`071`1m1`00OPL00`071`0=1`03
00L702P700@01`L02PL00`071`051`@0?0L00`071`0=1`0300L707h7001o1`0300L700d700<01`L0
9`L010071`071`D01PL00`071`0m1`0300L700d700<01`L0OPL007l700<01`L03@L00`071`0W1`04
00L700L700@01`L01`L00`071`0l1`0300L700h700<01`L0OPL007l700<01`L03PL00`071`0V1`04
00L700P700<01`001`L00`071`0l1`0300L700h700<01`L0OPL007l700<01`L03PL00`071`0V1`04
00L700T70P071`0300L703`700<01`L03@L00`071`1o1`00P0L00`071`0=1`0300L702L70P0;1`03
00L700D700<01`L0>`L00`071`0>1`0300L707l700201`0300L700h700<01`L0>`L00`071`0k1`03
00L700h700<01`L0O`L0080700<01`L03PL00`071`0k1`0300L703/700<01`L03PL00`071`1o1`00
P0L00`071`0>1`0300L703/700<01`L0>PL00`071`0?1`0300L707l700211`0300L700h700<01`L0
>PL00`071`0j1`0300L700h700<01`L0P0L0084700<01`L03PL00`071`0j1`0300L703X700<01`L0
3PL00`071`201`00P@L00`071`0>1`0300L703X700<01`L0>@L00`071`0?1`0300L7080700211`03
00L700l700<01`L0>@L303T700<01`L03`L00`071`201`00PPL00`071`0>1`0300L703T700<01`L0
>@L00`071`0>1`0300L7084700221`0300L700h700<01`L0>@L00`071`0h1`0300L700l700<01`L0
P@L0088700<01`L03`L00`071`0h1`0300L703P700<01`L03`L00`071`211`00PPL00`071`0?1`03
00L703P700<01`L0>0L00`071`0?1`0300L7084700231`0300L700h700<01`L0>0L00`071`0g1`03
00L7010700<01`L0P@L008<700<01`L03`L00`071`0g1`0300L703L700<01`L03`L00`071`221`00
P`L00`071`0?1`0300L703L700<01`L0=`L00`071`0?1`0300L7088700231`0300L700l700<01`L0
=`L00`071`0f1`0300L7010700<01`L0PPL008@700<01`L03`L00`071`0f1`0300L703H700<01`L0
40L00`071`221`00Q0L00`071`0?1`0300L703H700<01`L0=PL00`071`0?1`0300L708<700241`03
00L700l700<01`L0=PL00`071`0e1`0300L7010700<01`L0P`L008@700<01`L040L00`071`0e1`<0
=@L00`071`0@1`0300L708<700241`0300L7010700<01`L0=@L00`071`0e1`0300L7010700<01`L0
P`L008D700<01`L03`L00`071`0e1`0300L703@700<01`L040L00`071`241`00Q@L00`071`0@1`03
00L703@700<01`L0=0L00`071`0@1`0300L708@700251`0300L7010700<01`L0=0L00`071`0d1`03
00L7010700<01`L0Q0L008D700<01`L040L00`071`0d1`0300L703<700<01`L04@L00`071`241`00
QPL00`071`0@1`0300L703<700<01`L0<`L00`071`0A1`0300L708@700261`0300L7010700<01`L0
<`L00`071`0c1`0300L7010700<01`L0Q@L008H700<01`L040L00`071`0c1`0300L7038700<01`L0
4@L00`071`251`00QPL00`071`0A1`0300L7038700<01`L0<PL00`071`0A1`0300L708D700261`03
00L7014700<01`L0<PL00`071`0b1`0300L7014700<01`L0Q@L008L700<01`L040L00`071`0b1`<0
<@L00`071`0A1`0300L708H700271`0300L7014700<01`L0<@L00`071`0a1`0300L7014700<01`L0
QPL008L700<01`L04@L00`071`0a1`0300L7034700<01`L04@L00`071`261`00Q`L00`071`0A1`03
00L7034700<01`L0<0L00`071`0B1`0300L708H700281`0300L7014700<01`L0<0L00`071`0`1`03
00L7014700<01`L0Q`L008P700<01`L04@L00`071`0`1`0300L7030700<01`L04@L00`071`271`00
R0L00`071`0A1`0300L7030700<01`L0;`L00`071`0B1`0300L708L700281`0300L7018700<01`L0
;`L00`071`0_1`0300L7018700<01`L0Q`L008T700<01`L04@L00`071`0_1`0300L702l700<01`L0
4PL00`071`271`00R@L00`071`0A1`0300L702l700<01`L0;PL00`071`0B1`0300L708P700291`03
00L7018700<01`L0;PL00`071`0^1`0300L7018700<01`L0R0L008T700<01`L04PL00`071`0I1`80
10L00`071`031`801`L00`071`0^1`0300L7018700<01`L0R0L008T700<01`L04PL00`071`0H1`04
00L700P700@01`L01PL402`700<01`L04`L00`071`281`00RPL00`071`0B1`0300L701L700@01`L0
20L010071`061`0300L702d700<01`L04PL00`071`291`00RPL00`071`0B1`0300L701L700@01`L0
20L300L700<01`L0;@L00`071`0B1`0300L708T7002:1`0300L7018700<01`L05`L010071`081`03
00L700L700<01`L0;0L00`071`0C1`0300L708T7002:1`0300L701<700<01`L05PL010071`081`03
00L700L700<01`L0;0L00`071`0C1`0300L708T7002;1`0300L7018700<01`L05`L200X70`061`03
00L702`700<01`L04`L00`071`291`00R`L00`071`0B1`0300L702`700<01`L0:`L00`071`0C1`03
00L708X7002;1`0300L701<700<01`L0:`L00`071`0[1`0300L701<700<01`L0RPL008/700<01`L0
4`L00`071`0[1`0300L702/700<01`L04`L00`071`2:1`00S0L00`071`0B1`0300L702/700<01`L0
:PL00`071`0D1`0300L708X7002<1`0300L701<700<01`L0:PL00`071`0Z1`0300L701<700<01`L0
R`L008`700<01`L04`L00`071`0Z1`0300L702X700<01`L04`L00`071`2;1`00S0L00`071`0C1`03
00L702X70`0Y1`0300L701@700<01`L0R`L008d700<01`L04`L00`071`0Y1`0300L702T700<01`L0
50L00`071`2;1`00S@L00`071`0C1`0300L702T700<01`L0:@L00`071`0C1`0300L708`7002=1`03
00L701@700<01`L0:0L00`071`0X1`0300L701@700<01`L0S0L008d700<01`L050L00`071`0X1`03
00L702P700<01`L050L00`071`2<1`00SPL00`071`0C1`0300L702P700<01`L0:0L00`071`0D1`03
00L708`7002>1`0300L701@700<01`L09`L00`071`0W1`0300L701@700<01`L0S@L008h700<01`L0
50L00`071`0W1`0300L702L700<01`L050L00`071`2=1`00SPL00`071`0D1`0300L702L700<01`L0
9`L00`071`0D1`0300L708d7002?1`0300L701@700<01`L09PL00`071`0V1`0300L701@700<01`L0
SPL008l700<01`L050L00`071`0V1`0300L702H700<01`L050L00`071`2>1`00S`L00`071`0D1`03
00L702H700<01`L09PL00`071`0D1`0300L708h7002?1`0300L701D700<01`L09@L302D700<01`L0
5@L00`071`2>1`00T0L00`071`0D1`0300L702D700<01`L09@L00`071`0D1`0300L708l7002@1`03
00L701@700<01`L09@L00`071`0T1`0300L701D700<01`L0S`L0090700<01`L05@L00`071`0T1`03
00L702@700<01`L05@L00`071`2?1`00T0L00`071`0E1`0300L702@700<01`L090L00`071`0D1`03
00L70907002A1`0300L701D700<01`L08`L00`071`0S1`0300L701D700<01`L0T0L0094700<01`L0
5@L00`071`0S1`0300L702<700<01`L05@L00`071`2@1`00T@L00`071`0E1`0300L702<700<01`L0
8`L00`071`0D1`0300L70947002A1`0300L701H700<01`L08PL00`071`0R1`0300L701D700<01`L0
T@L0098700<01`L05@L00`071`0R1`0300L7028700<01`L05@L00`071`2A1`00TPL00`071`0E1`03
00L7028700<01`L08PL00`071`0D1`0300L70987002B1`0300L701H700<01`L08@L00`071`0Q1`03
00L701D700<01`L0TPL009<700<01`L05@L00`071`0Q1`<08@L00`071`0E1`0300L70987002C1`03
00L701D700<01`L08@L00`071`0Q1`0300L701D700<01`L0TPL009<700<01`L05PL00`071`0P1`03
00L7020700<01`L05@L00`071`2C1`00U0L00`071`0E1`0300L7020700<01`L080L00`071`0E1`03
00L709<7002D1`0300L701D700<01`L080L00`071`0P1`0300L701D700<01`L0T`L009@700<01`L0
5PL00`071`0O1`0300L701l700<01`L05@L00`071`2D1`00U@L00`071`0E1`0300L701l700<01`L0
7`L00`071`0E1`0300L709@7002E1`0300L701H700<01`L07PL00`071`0O1`0300L701D700<01`L0
U0L009D700<01`L05PL00`071`0N1`0300L701h700<01`L05@L00`071`2E1`00UPL00`071`0E1`03
00L701h700<01`L07PL00`071`0E1`0300L709D7002F1`0300L701H700<01`L020L200@700<01`L0
0`L200L700<01`L07PL00`071`0E1`0300L709D7002G1`0300L701D700<01`L01`L010071`081`04
00L700H7100L1`0300L701D700<01`L0UPL009L700<01`L05@L00`071`071`0400L700P700@01`L0
1PL00`071`0M1`0300L701D700<01`L0UPL009L700<01`L05PL00`071`061`0400L700T70P071`03
00L701d700<01`L05@L00`071`2F1`00V0L00`071`0E1`0300L700H700@01`L020L010071`061`03
00L701`700<01`L05@L00`071`2G1`00V0L00`071`0E1`0300L700H700@01`L020L010071`061`03
00L701`700<01`L05@L00`071`2G1`00V0L00`071`0F1`0300L700H70P0:1`801`L00`071`0K1`03
00L701H700<01`L0U`L009T700<01`L05@L00`071`0K1`0300L701/700<01`L05@L00`071`2H1`00
V@L00`071`0F1`0300L701X700<01`L06PL00`071`0F1`0300L709P7002I1`0300L701H700<01`L0
6PL00`071`0J1`0300L701H700<01`L0V0L009X700<01`L05PL00`071`0I1`0300L701T700<01`L0
5PL00`071`2I1`00VPL00`071`0F1`0300L701T700<01`L06@L00`071`0F1`0300L709T7002J1`03
00L701H700<01`L06@L00`071`0I1`0300L701H700<01`L0V@L009/700<01`L05PL00`071`0H1`<0
60L00`071`0F1`0300L709X7002K1`0300L701H700<01`L060L00`071`0H1`0300L701H700<01`L0
VPL009`700<01`L05PL00`071`0G1`0300L701L700<01`L05`L00`071`2J1`00W0L00`071`0F1`03
00L701L700<01`L05`L00`071`0F1`0300L709/7002M1`0300L701D700<01`L05`L00`071`0F1`03
00L701L700<01`L0V`L009d700<01`L05PL00`071`0F1`0300L701H700<01`L05PL00`071`2L1`00
WPL00`071`0E1`0300L701H700<01`L05@L00`071`0G1`0300L709`7002N1`0300L701H700<01`L0
5@L00`071`0E1`0300L701H700<01`L0W@L009h700<01`L05PL00`071`0E1`0300L701D700<01`L0
5PL00`071`2M1`00W`L00`071`0F1`0300L701@700<01`L050L00`071`0F1`0300L709h7002O1`03
00L701H700<01`L050L00`071`0D1`0300L701H700<01`L0WPL009l700<01`L05`L00`071`0C1`03
00L701<700<01`L05PL00`071`2O1`00X0L00`071`0F1`0300L701<70`0C1`0300L701D700<01`L0
X0L00:0700<01`L05`L00`071`0B1`0300L7018700<01`L05PL00`071`2P1`00X@L00`071`0F1`03
00L7018700<01`L04PL00`071`0E1`0300L70:47002Q1`0300L701L700<01`L04@L00`071`0A1`03
00L701H700<01`L0X@L00:8700<01`L05PL00`071`0A1`0300L7014700<01`L05@L00`071`2R1`00
XPL00`071`0G1`0300L7010700<01`L040L00`071`0F1`0300L70:87002S1`0300L701H700<01`L0
40L00`071`0@1`0300L701D700<01`L0X`L00:@700<01`L05PL00`071`0?1`0300L700l700<01`L0
5@L00`071`2T1`00Y0L00`071`0F1`0300L700l700<01`L03`L00`071`0E1`0300L70:@7002U1`03
00L701H700<01`L03PL00`071`0>1`0300L701D700<01`L0Y@L00:H700<01`L05@L00`071`0>1`03
00L700h700<01`L050L00`071`2V1`00Y`L00`071`0E1`0300L700d700<01`L03@L00`071`0E1`03
00L70:H7002X1`0300L701D700<01`L030L300`700<01`L05@L00`071`2W1`00Z@L00`071`0D1`03
00L700`700<01`L030L00`071`0D1`0300L70:P7002Z1`0300L701@700<01`L02`L00`071`0;1`03
00L701@700<01`L0Z@L00:/700<01`L050L00`071`0:1`0300L700/700<01`L04`L00`071`2Z1`00
[0L00`071`0C1`0300L700X700<01`L02PL00`071`0C1`0300L70:/7002]1`0300L701<700<01`L0
2@L00`071`091`0300L701870P2^1`00[PL201@700<01`L020L00`071`081`0300L7018700<01`L0
[PL00;0700<01`L04PL00`071`071`0300L700L700<01`L04@L20;47002a1`0300L7018700<01`L0
1PL00`071`051`804PL20;<7002b1`@04@L200H700<01`L010L00`071`0@1`80]@L00;H7100;1`D0
1@L00`071`031`0300L700d7102g1`00^PL:00<700<01`L01P000`L0000200H72P2k1`00a0LG0<D7
00371`0300L700D700<01`L0cPL00<L700<01`L01@L00`071`3>1`00a@L300L700<01`L0cPL00<L7
00<01`L01@L00`071`3>1`00c`L00`071`3>1`00\
\>"],
  ImageRangeCache->{{{0, 415}, {256, 0}} -> {-2.17281, -0.0593554, 0.0104714, 
  0.00423576}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Table[
        1.04990515451249533`\ 
            HypergeometricPFQ[{}, {1\/2, 3\/4}, 0.684976168949724595`\ k\^4]
               - 2.34952735848058624`\ k\^2\ 
            HypergeometricPFQ[{}, {3\/2, 5\/4}, 
              0.684976168949724595`\ k\^4], {k, 0, 5, .001}]\  >> hyper\)], 
  "Input"]
},
FrontEndVersion->"X 3.0",
ScreenRectangle->{{0, 1600}, {0, 1024}},
WindowSize->{520, 600},
WindowMargins->{{172, Automatic}, {Automatic, 77}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 137, 3, 43, "Input"],
Cell[1871, 56, 700, 16, 141, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2608, 77, 132, 3, 27, "Input"],
Cell[2743, 82, 503, 12, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3283, 99, 319, 6, 162, "Input"],
Cell[3605, 107, 17647, 565, 260, 6081, 418, "GraphicsData", 
"PostScript", "Graphics"],
Cell[21255, 674, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21422, 682, 111, 2, 31, "Input"],
Cell[21536, 686, 24249, 764, 265, 8419, 564, "GraphicsData", 
"PostScript", "Graphics"],
Cell[45788, 1452, 130, 3, 27, "Output"]
}, Open  ]],
Cell[45933, 1458, 317, 7, 155, "Input"]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

